// python wrapper for vtkSMPMergePolyDataHelper
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkSMPMergePolyDataHelper.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkSMPMergePolyDataHelper(PyObject *dict); }
static PyMethodDef PyvtkSMPMergePolyDataHelper_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static const char *PyvtkSMPMergePolyDataHelper_Doc =
  "vtkSMPMergePolyDataHelper - Utility class for merging poly data in\nparallel\n\n"
  "This class is designed as a utility class to help merging of poly\n"
  "data generated by filters that generate multiple polydata outputs and\n"
  "the associated locators. It requires that the filter uses\n"
  "vtkSMPMergePoints which creates a number of necessary data\n"
  "structures.\n\n";

static PyObject *
PyvtkSMPMergePolyDataHelper_New(PyTypeObject * /*unused*/, PyObject * /*unused*/, PyObject * /*unused*/)
{
  PyErr_SetString(PyExc_TypeError,
                  "this class cannot be instantiated");

  return nullptr;
}

static void PyvtkSMPMergePolyDataHelper_Delete(PyObject *self)
{
  PyObject_Del(self);
}

static Py_hash_t PyvtkSMPMergePolyDataHelper_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkSMPMergePolyDataHelper_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkFiltersSMP.vtkSMPMergePolyDataHelper", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkSMPMergePolyDataHelper_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkSMPMergePolyDataHelper_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkSMPMergePolyDataHelper_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkSMPMergePolyDataHelper_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

#ifndef DECLARED_PyvtkSMPMergePolyDataHelper_TypeNew
extern "C" { PyObject *PyvtkSMPMergePolyDataHelper_TypeNew(); }
#define DECLARED_PyvtkSMPMergePolyDataHelper_TypeNew
#endif

PyObject *PyvtkSMPMergePolyDataHelper_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkSMPMergePolyDataHelper_Type,
    PyvtkSMPMergePolyDataHelper_Methods,
    nullptr,
    nullptr);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkSMPMergePolyDataHelper(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkSMPMergePolyDataHelper_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkSMPMergePolyDataHelper", o) != 0)
  {
    Py_DECREF(o);
  }

}

