// python wrapper for vtkIOSSWriter
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkIOSSWriter.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkIOSSWriter(PyObject *dict); }
extern "C" { PyObject *PyvtkIOSSWriter_ClassNew(); }


static PyObject *
PyvtkIOSSWriter_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkIOSSWriter::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkIOSSWriter::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkIOSSWriter *tempr = vtkIOSSWriter::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkIOSSWriter *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkIOSSWriter::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkIOSSWriter::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkIOSSWriter::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetFilePath(temp0))
  {
    if (ap.IsBound())
    {
      op->SetFileName(temp0);
    }
    else
    {
      op->vtkIOSSWriter::SetFileName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetFileName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetFileName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetFileName() :
      op->vtkIOSSWriter::GetFileName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SetOffsetGlobalIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOffsetGlobalIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetOffsetGlobalIds(temp0);
    }
    else
    {
      op->vtkIOSSWriter::SetOffsetGlobalIds(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetOffsetGlobalIds(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOffsetGlobalIds");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetOffsetGlobalIds() :
      op->vtkIOSSWriter::GetOffsetGlobalIds());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_OffsetGlobalIdsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OffsetGlobalIdsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OffsetGlobalIdsOn();
    }
    else
    {
      op->vtkIOSSWriter::OffsetGlobalIdsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_OffsetGlobalIdsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "OffsetGlobalIdsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->OffsetGlobalIdsOff();
    }
    else
    {
      op->vtkIOSSWriter::OffsetGlobalIdsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SetPreserveInputEntityGroups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetPreserveInputEntityGroups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetPreserveInputEntityGroups(temp0);
    }
    else
    {
      op->vtkIOSSWriter::SetPreserveInputEntityGroups(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetPreserveInputEntityGroups(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetPreserveInputEntityGroups");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->GetPreserveInputEntityGroups() :
      op->vtkIOSSWriter::GetPreserveInputEntityGroups());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_PreserveInputEntityGroupsOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PreserveInputEntityGroupsOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PreserveInputEntityGroupsOn();
    }
    else
    {
      op->vtkIOSSWriter::PreserveInputEntityGroupsOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_PreserveInputEntityGroupsOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "PreserveInputEntityGroupsOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->PreserveInputEntityGroupsOff();
    }
    else
    {
      op->vtkIOSSWriter::PreserveInputEntityGroupsOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SetDisplacementMagnitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetDisplacementMagnitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetDisplacementMagnitude(temp0);
    }
    else
    {
      op->vtkIOSSWriter::SetDisplacementMagnitude(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetDisplacementMagnitudeMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplacementMagnitudeMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDisplacementMagnitudeMinValue() :
      op->vtkIOSSWriter::GetDisplacementMagnitudeMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetDisplacementMagnitudeMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplacementMagnitudeMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDisplacementMagnitudeMaxValue() :
      op->vtkIOSSWriter::GetDisplacementMagnitudeMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetDisplacementMagnitude(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetDisplacementMagnitude");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetDisplacementMagnitude() :
      op->vtkIOSSWriter::GetDisplacementMagnitude());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SetMaximumTimeStepsPerFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumTimeStepsPerFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaximumTimeStepsPerFile(temp0);
    }
    else
    {
      op->vtkIOSSWriter::SetMaximumTimeStepsPerFile(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetMaximumTimeStepsPerFileMinValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumTimeStepsPerFileMinValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumTimeStepsPerFileMinValue() :
      op->vtkIOSSWriter::GetMaximumTimeStepsPerFileMinValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetMaximumTimeStepsPerFileMaxValue(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumTimeStepsPerFileMaxValue");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumTimeStepsPerFileMaxValue() :
      op->vtkIOSSWriter::GetMaximumTimeStepsPerFileMaxValue());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetMaximumTimeStepsPerFile(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumTimeStepsPerFile");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetMaximumTimeStepsPerFile() :
      op->vtkIOSSWriter::GetMaximumTimeStepsPerFile());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_SetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  vtkMultiProcessController *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkMultiProcessController"))
  {
    if (ap.IsBound())
    {
      op->SetController(temp0);
    }
    else
    {
      op->vtkIOSSWriter::SetController(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_GetController(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetController");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkMultiProcessController *tempr = (ap.IsBound() ?
      op->GetController() :
      op->vtkIOSSWriter::GetController());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkIOSSWriter_Write(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "Write");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkIOSSWriter *op = static_cast<vtkIOSSWriter *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->Write() :
      op->vtkIOSSWriter::Write());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkIOSSWriter_Methods[] = {
  {"IsTypeOf", PyvtkIOSSWriter_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkIOSSWriter_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkIOSSWriter_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkIOSSWriter\nC++: static vtkIOSSWriter *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkIOSSWriter_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkIOSSWriter\nC++: vtkIOSSWriter *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkIOSSWriter_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkIOSSWriter_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetFileName", PyvtkIOSSWriter_SetFileName, METH_VARARGS,
   "SetFileName(self, _arg:str) -> None\nC++: virtual void SetFileName(const char *_arg)\n\nGet/set the filename. When writing in a distributed environment,\nthe actual filename written out may be different.\n"},
  {"GetFileName", PyvtkIOSSWriter_GetFileName, METH_VARARGS,
   "GetFileName(self) -> str\nC++: virtual char *GetFileName()\n\n"},
  {"SetOffsetGlobalIds", PyvtkIOSSWriter_SetOffsetGlobalIds, METH_VARARGS,
   "SetOffsetGlobalIds(self, _arg:bool) -> None\nC++: virtual void SetOffsetGlobalIds(bool _arg)\n\nExodus wants global ids to start with 1, while VTK generally\nproduces global ids starting with 0. Set this to true (default\nfalse), if the global ids are generated by VTK and hence start\nwith 0. When writing to the output file, they will be offset by 1\nto ensure the ids are valid exodus ids.\n"},
  {"GetOffsetGlobalIds", PyvtkIOSSWriter_GetOffsetGlobalIds, METH_VARARGS,
   "GetOffsetGlobalIds(self) -> bool\nC++: virtual bool GetOffsetGlobalIds()\n\n"},
  {"OffsetGlobalIdsOn", PyvtkIOSSWriter_OffsetGlobalIdsOn, METH_VARARGS,
   "OffsetGlobalIdsOn(self) -> None\nC++: virtual void OffsetGlobalIdsOn()\n\n"},
  {"OffsetGlobalIdsOff", PyvtkIOSSWriter_OffsetGlobalIdsOff, METH_VARARGS,
   "OffsetGlobalIdsOff(self) -> None\nC++: virtual void OffsetGlobalIdsOff()\n\n"},
  {"SetPreserveInputEntityGroups", PyvtkIOSSWriter_SetPreserveInputEntityGroups, METH_VARARGS,
   "SetPreserveInputEntityGroups(self, _arg:bool) -> None\nC++: virtual void SetPreserveInputEntityGroups(bool _arg)\n\nIf input is untransformed IOSS dataset, then the writer can\npreserve entity group classifications, such as element blocks,\nside sets etc. The same is not true if the input has been\ntransformed e.g. through a clip filter. Thus flag is used to\nindicate whether the input has valid element classifications.\n"},
  {"GetPreserveInputEntityGroups", PyvtkIOSSWriter_GetPreserveInputEntityGroups, METH_VARARGS,
   "GetPreserveInputEntityGroups(self) -> bool\nC++: virtual bool GetPreserveInputEntityGroups()\n\n"},
  {"PreserveInputEntityGroupsOn", PyvtkIOSSWriter_PreserveInputEntityGroupsOn, METH_VARARGS,
   "PreserveInputEntityGroupsOn(self) -> None\nC++: virtual void PreserveInputEntityGroupsOn()\n\n"},
  {"PreserveInputEntityGroupsOff", PyvtkIOSSWriter_PreserveInputEntityGroupsOff, METH_VARARGS,
   "PreserveInputEntityGroupsOff(self) -> None\nC++: virtual void PreserveInputEntityGroupsOff()\n\n"},
  {"SetDisplacementMagnitude", PyvtkIOSSWriter_SetDisplacementMagnitude, METH_VARARGS,
   "SetDisplacementMagnitude(self, _arg:float) -> None\nC++: virtual void SetDisplacementMagnitude(double _arg)\n\nIf input dataset has displacements pre-applied, setting the\ndisplacement magnitude to non-zero ensures that the point\ncoordinates in the dataset are correctly transformed using the\ndisplacement field array, if present.\n\nDefaults to 1.0.\n"},
  {"GetDisplacementMagnitudeMinValue", PyvtkIOSSWriter_GetDisplacementMagnitudeMinValue, METH_VARARGS,
   "GetDisplacementMagnitudeMinValue(self) -> float\nC++: virtual double GetDisplacementMagnitudeMinValue()\n\n"},
  {"GetDisplacementMagnitudeMaxValue", PyvtkIOSSWriter_GetDisplacementMagnitudeMaxValue, METH_VARARGS,
   "GetDisplacementMagnitudeMaxValue(self) -> float\nC++: virtual double GetDisplacementMagnitudeMaxValue()\n\n"},
  {"GetDisplacementMagnitude", PyvtkIOSSWriter_GetDisplacementMagnitude, METH_VARARGS,
   "GetDisplacementMagnitude(self) -> float\nC++: virtual double GetDisplacementMagnitude()\n\n"},
  {"SetMaximumTimeStepsPerFile", PyvtkIOSSWriter_SetMaximumTimeStepsPerFile, METH_VARARGS,
   "SetMaximumTimeStepsPerFile(self, _arg:int) -> None\nC++: virtual void SetMaximumTimeStepsPerFile(int _arg)\n\nA debugging variable, set this to non-zero positive number to\nsave at most the specified number of timesteps in a single file\nbefore starting a new one. The writer may start new files (aka\nrestarts) automatically if it determines that the mesh has\nchanged.\n\nDefaults to 0 i.e. unlimited timesteps per file.\n"},
  {"GetMaximumTimeStepsPerFileMinValue", PyvtkIOSSWriter_GetMaximumTimeStepsPerFileMinValue, METH_VARARGS,
   "GetMaximumTimeStepsPerFileMinValue(self) -> int\nC++: virtual int GetMaximumTimeStepsPerFileMinValue()\n\n"},
  {"GetMaximumTimeStepsPerFileMaxValue", PyvtkIOSSWriter_GetMaximumTimeStepsPerFileMaxValue, METH_VARARGS,
   "GetMaximumTimeStepsPerFileMaxValue(self) -> int\nC++: virtual int GetMaximumTimeStepsPerFileMaxValue()\n\n"},
  {"GetMaximumTimeStepsPerFile", PyvtkIOSSWriter_GetMaximumTimeStepsPerFile, METH_VARARGS,
   "GetMaximumTimeStepsPerFile(self) -> int\nC++: virtual int GetMaximumTimeStepsPerFile()\n\n"},
  {"SetController", PyvtkIOSSWriter_SetController, METH_VARARGS,
   "SetController(self, controller:vtkMultiProcessController) -> None\nC++: void SetController(vtkMultiProcessController *controller)\n\nGet/Set the controller to use when working in parallel.\nInitialized to `vtkMultiProcessController::GetGlobalController`\nin the constructor.\n\nThe controller is used to determine the upstream piece request in\nRequestUpdateExtent.\n"},
  {"GetController", PyvtkIOSSWriter_GetController, METH_VARARGS,
   "GetController(self) -> vtkMultiProcessController\nC++: virtual vtkMultiProcessController *GetController()\n\n"},
  {"Write", PyvtkIOSSWriter_Write, METH_VARARGS,
   "Write(self) -> bool\nC++: bool Write()\n\nWrites the input dataset.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkIOSSWriter_Doc =
  "vtkIOSSWriter - writer using IOSS\n\n"
  "Superclass: vtkDataObjectAlgorithm\n\n"
  "vtkIOSSWriter is a writer to write datasets using IOSS library.\n"
  "Currently this writer supports writing Exodus files. This writer is a\n"
  "work in progress and currently only supports targeted use-cases. The\n"
  "writer will be iteratively cleaned up and fixed to support all types\n"
  "of incoming datasets.\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkIOSSWriter_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkIOIOSS.vtkIOSSWriter", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkIOSSWriter_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkIOSSWriter_StaticNew()
{
  return vtkIOSSWriter::New();
}

PyObject *PyvtkIOSSWriter_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkIOSSWriter_Type, PyvtkIOSSWriter_Methods,
    "vtkIOSSWriter",
 &PyvtkIOSSWriter_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#ifndef VTK_PY3K
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkDataObjectAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkIOSSWriter(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkIOSSWriter_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkIOSSWriter", o) != 0)
  {
    Py_DECREF(o);
  }

}

