// python wrapper for vtkBoostBrandesCentrality
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkBoostBrandesCentrality.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkBoostBrandesCentrality(PyObject *dict); }
extern "C" { PyObject *PyvtkBoostBrandesCentrality_ClassNew(); }


static PyObject *
PyvtkBoostBrandesCentrality_IsTypeOf(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkBoostBrandesCentrality::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkBoostBrandesCentrality::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_SafeDownCast(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkBoostBrandesCentrality *tempr = vtkBoostBrandesCentrality::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkBoostBrandesCentrality *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkBoostBrandesCentrality::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(nullptr);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
    else if (tempr != nullptr)
    {
      ap.DeleteVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_GetNumberOfGenerationsFromBaseType(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "GetNumberOfGenerationsFromBaseType");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = vtkBoostBrandesCentrality::GetNumberOfGenerationsFromBaseType(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_GetNumberOfGenerationsFromBase(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNumberOfGenerationsFromBase");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    long long tempr = (ap.IsBound() ?
      op->GetNumberOfGenerationsFromBase(temp0) :
      op->vtkBoostBrandesCentrality::GetNumberOfGenerationsFromBase(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_SetUseEdgeWeightArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetUseEdgeWeightArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetUseEdgeWeightArray(temp0);
    }
    else
    {
      op->vtkBoostBrandesCentrality::SetUseEdgeWeightArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_UseEdgeWeightArrayOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseEdgeWeightArrayOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseEdgeWeightArrayOn();
    }
    else
    {
      op->vtkBoostBrandesCentrality::UseEdgeWeightArrayOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_UseEdgeWeightArrayOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "UseEdgeWeightArrayOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->UseEdgeWeightArrayOff();
    }
    else
    {
      op->vtkBoostBrandesCentrality::UseEdgeWeightArrayOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_SetInvertEdgeWeightArray(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetInvertEdgeWeightArray");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  bool temp0 = false;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetInvertEdgeWeightArray(temp0);
    }
    else
    {
      op->vtkBoostBrandesCentrality::SetInvertEdgeWeightArray(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_InvertEdgeWeightArrayOn(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InvertEdgeWeightArrayOn");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InvertEdgeWeightArrayOn();
    }
    else
    {
      op->vtkBoostBrandesCentrality::InvertEdgeWeightArrayOn();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_InvertEdgeWeightArrayOff(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "InvertEdgeWeightArrayOff");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->InvertEdgeWeightArrayOff();
    }
    else
    {
      op->vtkBoostBrandesCentrality::InvertEdgeWeightArrayOff();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_GetEdgeWeightArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetEdgeWeightArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    char *tempr = (ap.IsBound() ?
      op->GetEdgeWeightArrayName() :
      op->vtkBoostBrandesCentrality::GetEdgeWeightArrayName());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkBoostBrandesCentrality_SetEdgeWeightArrayName(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetEdgeWeightArrayName");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkBoostBrandesCentrality *op = static_cast<vtkBoostBrandesCentrality *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetEdgeWeightArrayName(temp0);
    }
    else
    {
      op->vtkBoostBrandesCentrality::SetEdgeWeightArrayName(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkBoostBrandesCentrality_Methods[] = {
  {"IsTypeOf", PyvtkBoostBrandesCentrality_IsTypeOf, METH_VARARGS,
   "IsTypeOf(type:str) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkBoostBrandesCentrality_IsA, METH_VARARGS,
   "IsA(self, type:str) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkBoostBrandesCentrality_SafeDownCast, METH_VARARGS,
   "SafeDownCast(o:vtkObjectBase) -> vtkBoostBrandesCentrality\nC++: static vtkBoostBrandesCentrality *SafeDownCast(\n    vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkBoostBrandesCentrality_NewInstance, METH_VARARGS,
   "NewInstance(self) -> vtkBoostBrandesCentrality\nC++: vtkBoostBrandesCentrality *NewInstance()\n\n"},
  {"GetNumberOfGenerationsFromBaseType", PyvtkBoostBrandesCentrality_GetNumberOfGenerationsFromBaseType, METH_VARARGS,
   "GetNumberOfGenerationsFromBaseType(type:str) -> int\nC++: static vtkIdType GetNumberOfGenerationsFromBaseType(\n    const char *type)\n\nGiven a the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"GetNumberOfGenerationsFromBase", PyvtkBoostBrandesCentrality_GetNumberOfGenerationsFromBase, METH_VARARGS,
   "GetNumberOfGenerationsFromBase(self, type:str) -> int\nC++: vtkIdType GetNumberOfGenerationsFromBase(const char *type)\n    override;\n\nGiven the name of a base class of this class type, return the\ndistance of inheritance between this class type and the named\nclass (how many generations of inheritance are there between this\nclass and the named class). If the named class is not in this\nclass's inheritance tree, return a negative value. Valid\nresponses will always be nonnegative. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SetUseEdgeWeightArray", PyvtkBoostBrandesCentrality_SetUseEdgeWeightArray, METH_VARARGS,
   "SetUseEdgeWeightArray(self, _arg:bool) -> None\nC++: virtual void SetUseEdgeWeightArray(bool _arg)\n\nGet/Set the flag that sets the rule whether or not to use the\nedge weight array as set using SetEdgeWeightArrayName.\n"},
  {"UseEdgeWeightArrayOn", PyvtkBoostBrandesCentrality_UseEdgeWeightArrayOn, METH_VARARGS,
   "UseEdgeWeightArrayOn(self) -> None\nC++: virtual void UseEdgeWeightArrayOn()\n\n"},
  {"UseEdgeWeightArrayOff", PyvtkBoostBrandesCentrality_UseEdgeWeightArrayOff, METH_VARARGS,
   "UseEdgeWeightArrayOff(self) -> None\nC++: virtual void UseEdgeWeightArrayOff()\n\n"},
  {"SetInvertEdgeWeightArray", PyvtkBoostBrandesCentrality_SetInvertEdgeWeightArray, METH_VARARGS,
   "SetInvertEdgeWeightArray(self, _arg:bool) -> None\nC++: virtual void SetInvertEdgeWeightArray(bool _arg)\n\n"},
  {"InvertEdgeWeightArrayOn", PyvtkBoostBrandesCentrality_InvertEdgeWeightArrayOn, METH_VARARGS,
   "InvertEdgeWeightArrayOn(self) -> None\nC++: virtual void InvertEdgeWeightArrayOn()\n\n"},
  {"InvertEdgeWeightArrayOff", PyvtkBoostBrandesCentrality_InvertEdgeWeightArrayOff, METH_VARARGS,
   "InvertEdgeWeightArrayOff(self) -> None\nC++: virtual void InvertEdgeWeightArrayOff()\n\n"},
  {"GetEdgeWeightArrayName", PyvtkBoostBrandesCentrality_GetEdgeWeightArrayName, METH_VARARGS,
   "GetEdgeWeightArrayName(self) -> str\nC++: virtual char *GetEdgeWeightArrayName()\n\nGet/Set the name of the array that needs to be used as the edge\nweight. The array should be a vtkDataArray.\n"},
  {"SetEdgeWeightArrayName", PyvtkBoostBrandesCentrality_SetEdgeWeightArrayName, METH_VARARGS,
   "SetEdgeWeightArrayName(self, _arg:str) -> None\nC++: virtual void SetEdgeWeightArrayName(const char *_arg)\n\n"},
  {nullptr, nullptr, 0, nullptr}
};

static const char *PyvtkBoostBrandesCentrality_Doc =
  "vtkBoostBrandesCentrality - Compute Brandes betweenness centrality on\na vtkGraph\n\n"
  "Superclass: vtkGraphAlgorithm\n\n"
  "This vtk class uses the Boost brandes_betweeness_centrality generic\n"
  "algorithm to compute betweenness centrality on the input graph (a\n"
  "vtkGraph).\n\n"
  "@sa\n"
  "vtkGraph vtkBoostGraphAdapter\n\n";

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkBoostBrandesCentrality_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkInfovisBoostGraphAlgorithms.vtkBoostBrandesCentrality", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkBoostBrandesCentrality_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkBoostBrandesCentrality_StaticNew()
{
  return vtkBoostBrandesCentrality::New();
}

PyObject *PyvtkBoostBrandesCentrality_ClassNew()
{
  PyTypeObject *pytype = PyVTKClass_Add(
    &PyvtkBoostBrandesCentrality_Type, PyvtkBoostBrandesCentrality_Methods,
    "vtkBoostBrandesCentrality",
 &PyvtkBoostBrandesCentrality_StaticNew);

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#ifndef VTK_PY3K
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = vtkPythonUtil::FindBaseTypeObject("vtkGraphAlgorithm");

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkBoostBrandesCentrality(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkBoostBrandesCentrality_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkBoostBrandesCentrality", o) != 0)
  {
    Py_DECREF(o);
  }

}

