#include "vtkOutlineGlowBlurPassFS.h"

const char *vtkOutlineGlowBlurPassFS =
"//VTK::System::Dec\n"
"\n"
"// ============================================================================\n"
"//\n"
"//  Program:   Visualization Toolkit\n"
"//  Module:    vtkOutlineGlowBlurPassFS.glsl\n"
"//\n"
"//  Copyright (c) Ken Martin, Will Schroeder, Bill Lorensen\n"
"//  All rights reserved.\n"
"//  See Copyright.txt or http://www.kitware.com/Copyright.htm for details.\n"
"//\n"
"//     This software is distributed WITHOUT ANY WARRANTY; without even\n"
"//     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR\n"
"//     PURPOSE.  See the above copyright notice for more information.\n"
"//\n"
"// ============================================================================\n"
"\n"
"// Fragment shader used by the outline glow blur render pass.\n"
"\n"
"in vec2 tcoordVC;\n"
"uniform sampler2D source;\n"
"\n"
"uniform float coef[3];\n"
"uniform float offsetx;\n"
"uniform float offsety;\n"
"\n"
"// the output of this shader\n"
"//VTK::Output::Dec\n"
"\n"
"void main(void)\n"
"{\n"
"  vec2 offset=vec2(offsetx,offsety);\n"
"\n"
"  gl_FragData[0] = coef[0]*texture2D(source,tcoordVC-offset)\n"
"    +coef[1]*texture2D(source,tcoordVC)\n"
"    +coef[2]*texture2D(source,tcoordVC+offset);\n"
"}\n"
"";
