// java wrapper for vtkParametricTorus object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkParametricTorus.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkParametricFunction_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkParametricTorus_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkParametricTorus",dType)) { return me; }
  if ((res= vtkParametricFunction_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkParametricTorus_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkParametricTorus_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkParametricTorus_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkParametricTorus_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkParametricTorus_SetRingRadius_14(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRingRadius(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkParametricTorus_GetRingRadius_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRingRadius();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkParametricTorus_SetCrossSectionRadius_16(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCrossSectionRadius(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkParametricTorus_GetCrossSectionRadius_17(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCrossSectionRadius();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkParametricTorus_GetDimension_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDimension();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkParametricTorus_Evaluate_19(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jdoubleArray id2)
{
  double temp0[3];
  double temp1[3];
  double temp2[9];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  env->GetDoubleArrayRegion(id2, 0, 9, &temp2[0]);

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  op->Evaluate(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  env->SetDoubleArrayRegion(id2, 0, 9, &temp2[0]);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkParametricTorus_EvaluateScalar_110(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jdoubleArray id2)
{
  double temp0[3];
  double temp1[3];
  double temp2[9];
  double   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  env->GetDoubleArrayRegion(id2, 0, 9, &temp2[0]);

  vtkParametricTorus* op = static_cast<vtkParametricTorus*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->EvaluateScalar(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  env->SetDoubleArrayRegion(id2, 0, 9, &temp2[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkParametricTorus_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkParametricTorus::New());
}
