// java wrapper for vtkBitArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBitArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkBitArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkBitArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBitArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBitArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_Allocate_14(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Allocate(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_Initialize_15(JNIEnv* env, jobject obj)
{

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_GetDataType_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_GetDataTypeSize_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataTypeSize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_SetNumberOfTuples_18(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfTuples(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkBitArray_SetNumberOfValues_19(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  bool   temp20;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SetNumberOfValues(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_SetTuple_110(JNIEnv* env, jobject obj,jlong id0,jlong id1,jobject id2)
{
  long long   temp0;
  long long   temp1;
  vtkAbstractArray * temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTuple(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_InsertTuple_111(JNIEnv* env, jobject obj,jlong id0,jlong id1,jobject id2)
{
  long long   temp0;
  long long   temp1;
  vtkAbstractArray * temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertTuple(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_InsertTuples_112(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkIdList * temp0;
  vtkIdList * temp1;
  vtkAbstractArray * temp2;
  temp0 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertTuples(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_InsertTuplesStartingAt_113(JNIEnv* env, jobject obj,jlong id0,jobject id1,jobject id2)
{
  long long   temp0;
  vtkIdList * temp1;
  vtkAbstractArray * temp2;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertTuplesStartingAt(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_InsertTuples_114(JNIEnv* env, jobject obj,jlong id0,jlong id1,jlong id2,jobject id3)
{
  long long   temp0;
  long long   temp1;
  long long   temp2;
  vtkAbstractArray * temp3;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id3));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertTuples(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBitArray_InsertNextTuple_115(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkAbstractArray * temp1;
  long long   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextTuple(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_RemoveTuple_116(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveTuple(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_RemoveFirstTuple_117(JNIEnv* env, jobject obj)
{

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveFirstTuple();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_RemoveLastTuple_118(JNIEnv* env, jobject obj)
{

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveLastTuple();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_SetComponent_119(JNIEnv* env, jobject obj,jlong id0,jint id1,jdouble id2)
{
  long long   temp0;
  int   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetComponent(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_Squeeze_120(JNIEnv* env, jobject obj)
{

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Squeeze();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_Resize_121(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  int   temp20;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Resize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBitArray_GetValue_122(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  int   temp20;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_SetValue_123(JNIEnv* env, jobject obj,jlong id0,jint id1)
{
  long long   temp0;
  int   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetValue(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_InsertValue_124(JNIEnv* env, jobject obj,jlong id0,jint id1)
{
  long long   temp0;
  int   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertValue(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBitArray_InsertNextValue_125(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  long long   temp20;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_InsertComponent_126(JNIEnv* env, jobject obj,jlong id0,jint id1,jdouble id2)
{
  long long   temp0;
  int   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertComponent(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_DeepCopy_127(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataArray * temp0;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_DeepCopy_128(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractArray * temp0;
  temp0 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopy(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBitArray_NewIterator_129(JNIEnv* env, jobject obj)
{
  vtkArrayIterator * temp20;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->NewIterator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBitArray_LookupValue_130(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  long long   temp20;
  temp0 = id0;

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->LookupValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_LookupValue_131(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkIdList * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->LookupValue(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_DataChanged_132(JNIEnv* env, jobject obj)
{

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->DataChanged();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBitArray_ClearLookup_133(JNIEnv* env, jobject obj)
{

  vtkBitArray* op = static_cast<vtkBitArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearLookup();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkBitArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkBitArray::New());
}
