// java wrapper for vtkInformationIterator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkInformationIterator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkInformationIterator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkInformationIterator",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInformationIterator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInformationIterator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInformationIterator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInformationIterator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInformationIterator_SetInformation_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInformation(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInformationIterator_GetInformation_15(JNIEnv* env, jobject obj)
{
  vtkInformation * temp20;

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInformation();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInformationIterator_SetInformationWeak_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInformationWeak(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInformationIterator_InitTraversal_17(JNIEnv* env, jobject obj)
{

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  op->InitTraversal();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInformationIterator_GoToFirstItem_18(JNIEnv* env, jobject obj)
{

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  op->GoToFirstItem();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInformationIterator_GoToNextItem_19(JNIEnv* env, jobject obj)
{

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  op->GoToNextItem();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInformationIterator_IsDoneWithTraversal_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsDoneWithTraversal();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInformationIterator_GetCurrentKey_111(JNIEnv* env, jobject obj)
{
  vtkInformationKey * temp20;

  vtkInformationIterator* op = static_cast<vtkInformationIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCurrentKey();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkInformationIterator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkInformationIterator::New());
}
