// java wrapper for vtkMersenneTwister object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMersenneTwister.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkRandomSequence_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMersenneTwister_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMersenneTwister",dType)) { return me; }
  if ((res= vtkRandomSequence_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMersenneTwister_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMersenneTwister_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMersenneTwister_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMersenneTwister_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMersenneTwister_Initialize_14(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  temp0 = id0;

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMersenneTwister_InitializeNewSequence_15(JNIEnv* env, jobject obj,jint id0,jint id1)
{
   unsigned int   temp0;
  int   temp1;
   unsigned int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InitializeNewSequence(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMersenneTwister_InitializeSequence_16(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2)
{
   unsigned int   temp0;
   unsigned int   temp1;
  int   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  op->InitializeSequence(temp0,temp1,temp2);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkMersenneTwister_GetValue_17(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  double   temp20;
  temp0 = id0;

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkMersenneTwister_GetValue_18(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMersenneTwister_Next_19(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  temp0 = id0;

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  op->Next(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMersenneTwister_Next_110(JNIEnv* env, jobject obj)
{

  vtkMersenneTwister* op = static_cast<vtkMersenneTwister*>(vtkJavaGetPointerFromObject(env, obj));
  op->Next();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMersenneTwister_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMersenneTwister::New());
}
