// java wrapper for vtkShortArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkShortArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkShortArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkShortArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}

// Array conversion routines
extern "C" JNIEXPORT jshortArray JNICALL Java_vtk_vtkShortArray_GetJavaArray_10(JNIEnv* env, jobject obj)
{
  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  short* buffer = op->GetPointer(0);
  return vtkJavaMakeJArrayOfShort(env, reinterpret_cast<jshort*>(buffer), op->GetSize());
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShortArray_SetJavaArray_10(JNIEnv* env, jobject obj, jshortArray id0, jint len0)
{
  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfTuples(len0 / op->GetNumberOfComponents());
  short* buffer = op->GetPointer(0);
  env->GetShortArrayRegion(id0, 0, len0, reinterpret_cast<jshort*>(buffer));
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShortArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShortArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShortArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShortArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShortArray_ExtendedNew_14(JNIEnv* env, jobject obj)
{
  vtkShortArray * temp20;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ExtendedNew();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShortArray_GetDataType_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT jshort  JNICALL Java_vtk_vtkShortArray_GetValue_16(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  short   temp20;
  temp0 = id0;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShortArray_SetValue_17(JNIEnv* env, jobject obj,jlong id0,jshort id1)
{
  long long   temp0;
  short   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetValue(temp0,temp1);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkShortArray_SetNumberOfValues_18(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  bool   temp20;
  temp0 = id0;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SetNumberOfValues(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShortArray_InsertValue_19(JNIEnv* env, jobject obj,jlong id0,jshort id1)
{
  long long   temp0;
  short   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertValue(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShortArray_InsertNextValue_110(JNIEnv* env, jobject obj,jshort id0)
{
  short   temp0;
  long long   temp20;
  temp0 = id0;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jshortArray  JNICALL Java_vtk_vtkShortArray_GetValueRange_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  short * temp20;
  temp0 = id0;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange(temp0);
  return vtkJavaMakeJArrayOfShort(env, reinterpret_cast<jshort*>(temp20), 2);

}

extern "C" JNIEXPORT jshortArray  JNICALL Java_vtk_vtkShortArray_GetValueRange_112(JNIEnv* env, jobject obj)
{
  short * temp20;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueRange();
  return vtkJavaMakeJArrayOfShort(env, reinterpret_cast<jshort*>(temp20), 2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShortArray_FastDownCast_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractArray * temp0;
  vtkShortArray * temp20;
  temp0 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FastDownCast(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jshort  JNICALL Java_vtk_vtkShortArray_GetDataTypeValueMin_114(JNIEnv* env, jobject obj)
{
  short   temp20;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataTypeValueMin();
  return temp20;

}

extern "C" JNIEXPORT jshort  JNICALL Java_vtk_vtkShortArray_GetDataTypeValueMax_115(JNIEnv* env, jobject obj)
{
  short   temp20;

  vtkShortArray* op = static_cast<vtkShortArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataTypeValueMax();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkShortArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkShortArray::New());
}
