// java wrapper for vtkUnsignedLongArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUnsignedLongArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkUnsignedLongArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkUnsignedLongArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}

// Array conversion routines
extern "C" JNIEXPORT jlongArray JNICALL Java_vtk_vtkUnsignedLongArray_GetJavaArray_10(JNIEnv* env, jobject obj)
{
  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  unsigned long* buffer = op->GetPointer(0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<jlong*>(buffer), op->GetSize());
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedLongArray_SetJavaArray_10(JNIEnv* env, jobject obj, jlongArray id0, jint len0)
{
  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfTuples(len0 / op->GetNumberOfComponents());
  unsigned long* buffer = op->GetPointer(0);
  env->GetLongArrayRegion(id0, 0, len0, reinterpret_cast<jlong*>(buffer));
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedLongArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedLongArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_ExtendedNew_14(JNIEnv* env, jobject obj)
{
  vtkUnsignedLongArray * temp20;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ExtendedNew();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedLongArray_GetDataType_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_GetValue_16(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
   unsigned long   temp20;
  temp0 = id0;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedLongArray_SetValue_17(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
   unsigned long   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetValue(temp0,temp1);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkUnsignedLongArray_SetNumberOfValues_18(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  bool   temp20;
  temp0 = id0;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SetNumberOfValues(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedLongArray_InsertValue_19(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
   unsigned long   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertValue(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_InsertNextValue_110(JNIEnv* env, jobject obj,jlong id0)
{
   unsigned long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_FastDownCast_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractArray * temp0;
  vtkUnsignedLongArray * temp20;
  temp0 = static_cast<vtkAbstractArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FastDownCast(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_GetDataTypeValueMin_112(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataTypeValueMin();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedLongArray_GetDataTypeValueMax_113(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkUnsignedLongArray* op = static_cast<vtkUnsignedLongArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataTypeValueMax();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkUnsignedLongArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkUnsignedLongArray::New());
}
