// java wrapper for vtkBezierCurve object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBezierCurve.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkHigherOrderCurve_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkBezierCurve_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkBezierCurve",dType)) { return me; }
  if ((res= vtkHigherOrderCurve_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierCurve_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierCurve_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierCurve_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierCurve_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierCurve_GetCellType_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBezierCurve_SetRationalWeightsFromPointData_15(JNIEnv* env, jobject obj,jobject id0,jlong id1)
{
  vtkPointData * temp0;
  long long   temp1;
  temp0 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRationalWeightsFromPointData(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierCurve_GetRationalWeights_16(JNIEnv* env, jobject obj)
{
  vtkDoubleArray * temp20;

  vtkBezierCurve* op = static_cast<vtkBezierCurve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRationalWeights();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkBezierCurve_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkBezierCurve::New());
}
