// java wrapper for vtkBezierHexahedron object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBezierHexahedron.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkHigherOrderHexahedron_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkBezierHexahedron_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkBezierHexahedron",dType)) { return me; }
  if ((res= vtkHigherOrderHexahedron_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierHexahedron_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierHexahedron_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierHexahedron_GetCellType_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellType();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetEdge_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkCell * temp20;
  temp0 = id0;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdge(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetFace_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkCell * temp20;
  temp0 = id0;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFace(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBezierHexahedron_SetRationalWeightsFromPointData_17(JNIEnv* env, jobject obj,jobject id0,jlong id1)
{
  vtkPointData * temp0;
  long long   temp1;
  temp0 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRationalWeightsFromPointData(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetRationalWeights_18(JNIEnv* env, jobject obj)
{
  vtkDoubleArray * temp20;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRationalWeights();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetEdgeCell_19(JNIEnv* env, jobject obj)
{
  vtkHigherOrderCurve * temp20;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdgeCell();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetFaceCell_110(JNIEnv* env, jobject obj)
{
  vtkHigherOrderQuadrilateral * temp20;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFaceCell();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierHexahedron_GetInterpolation_111(JNIEnv* env, jobject obj)
{
  vtkHigherOrderInterpolation * temp20;

  vtkBezierHexahedron* op = static_cast<vtkBezierHexahedron*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInterpolation();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkBezierHexahedron_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkBezierHexahedron::New());
}
