// java wrapper for vtkCellArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCellArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCellArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCellArray",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellArray_Allocate_14(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Allocate(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_AllocateEstimate_15(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  bool   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->AllocateEstimate(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_AllocateExact_16(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  bool   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->AllocateExact(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_AllocateCopy_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCellArray * temp0;
  bool   temp20;
  temp0 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->AllocateCopy(temp0);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_ResizeExact_18(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  bool   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ResizeExact(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_Initialize_19(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_Reset_110(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Reset();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_Squeeze_111(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Squeeze();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_IsValid_112(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsValid();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetNumberOfCells_113(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfCells();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetNumberOfOffsets_114(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfOffsets();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetOffset_115(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOffset(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetNumberOfConnectivityIds_116(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfConnectivityIds();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_NewIterator_117(JNIEnv* env, jobject obj)
{
  vtkCellArrayIterator * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->NewIterator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_SetData_118(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkDataArray * temp0;
  vtkDataArray * temp1;
  bool   temp20;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SetData(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_SetData_119(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkDataArray * temp1;
  bool   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SetData(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_IsStorage64Bit_120(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsStorage64Bit();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_IsStorageShareable_121(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsStorageShareable();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_Use32BitStorage_122(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Use32BitStorage();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_Use64BitStorage_123(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Use64BitStorage();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_UseDefaultStorage_124(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseDefaultStorage();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_CanConvertTo32BitStorage_125(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CanConvertTo32BitStorage();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_CanConvertTo64BitStorage_126(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CanConvertTo64BitStorage();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_CanConvertToDefaultStorage_127(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CanConvertToDefaultStorage();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_ConvertTo32BitStorage_128(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ConvertTo32BitStorage();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_ConvertTo64BitStorage_129(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ConvertTo64BitStorage();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_ConvertToDefaultStorage_130(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ConvertToDefaultStorage();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellArray_ConvertToSmallestStorage_131(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ConvertToSmallestStorage();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetOffsetsArray_132(JNIEnv* env, jobject obj)
{
  vtkDataArray * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOffsetsArray();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetOffsetsArray32_133(JNIEnv* env, jobject obj)
{
  vtkTypeInt32Array * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOffsetsArray32();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetOffsetsArray64_134(JNIEnv* env, jobject obj)
{
  vtkTypeInt64Array * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOffsetsArray64();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetConnectivityArray_135(JNIEnv* env, jobject obj)
{
  vtkDataArray * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetConnectivityArray();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetConnectivityArray32_136(JNIEnv* env, jobject obj)
{
  vtkTypeInt32Array * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetConnectivityArray32();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetConnectivityArray64_137(JNIEnv* env, jobject obj)
{
  vtkTypeInt64Array * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetConnectivityArray64();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_IsHomogeneous_138(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsHomogeneous();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_InitTraversal_139(JNIEnv* env, jobject obj)
{

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InitTraversal();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellArray_GetNextCell_140(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdList * temp0;
  int   temp20;
  temp0 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNextCell(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_GetCellAtId_141(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkIdList * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetCellAtId(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetCellSize_142(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellSize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_InsertNextCell_143(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCell * temp0;
  long long   temp20;
  temp0 = static_cast<vtkCell*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextCell(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_InsertNextCell_144(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdList * temp0;
  long long   temp20;
  temp0 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextCell(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_InsertNextCell_145(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  long long   temp20;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextCell(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_InsertCellPoint_146(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertCellPoint(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_UpdateCellCount_147(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->UpdateCellCount(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetTraversalCellId_148(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTraversalCellId();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_SetTraversalCellId_149(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTraversalCellId(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_ReverseCellAtId_150(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReverseCellAtId(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_ReplaceCellAtId_151(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkIdList * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReplaceCellAtId(temp0,temp1);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellArray_GetMaxCellSize_152(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaxCellSize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_DeepCopy_153(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCellArray * temp0;
  temp0 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_ShallowCopy_154(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCellArray * temp0;
  temp0 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShallowCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_Append_155(JNIEnv* env, jobject obj,jobject id0,jlong id1)
{
  vtkCellArray * temp0;
  long long   temp1;
  temp0 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->Append(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_ExportLegacyFormat_156(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdTypeArray * temp0;
  temp0 = static_cast<vtkIdTypeArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExportLegacyFormat(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_ImportLegacyFormat_157(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdTypeArray * temp0;
  temp0 = static_cast<vtkIdTypeArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ImportLegacyFormat(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_AppendLegacyFormat_158(JNIEnv* env, jobject obj,jobject id0,jlong id1)
{
  vtkIdTypeArray * temp0;
  long long   temp1;
  temp0 = static_cast<vtkIdTypeArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->AppendLegacyFormat(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetActualMemorySize_159(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetActualMemorySize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_SetNumberOfCells_160(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfCells(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_EstimateSize_161(JNIEnv* env, jobject obj,jlong id0,jint id1)
{
  long long   temp0;
  int   temp1;
  long long   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->EstimateSize(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetSize_162(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSize();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetNumberOfConnectivityEntries_163(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfConnectivityEntries();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_GetCell_164(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkIdList * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetCell(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetInsertLocation_165(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  long long   temp20;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInsertLocation(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetTraversalLocation_166(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTraversalLocation();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetTraversalLocation_167(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTraversalLocation(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_SetTraversalLocation_168(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTraversalLocation(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_ReverseCell_169(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReverseCell(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellArray_SetCells_170(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkIdTypeArray * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkIdTypeArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCells(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellArray_GetData_171(JNIEnv* env, jobject obj)
{
  vtkIdTypeArray * temp20;

  vtkCellArray* op = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCellArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCellArray::New());
}
