// java wrapper for vtkCellLocator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCellLocator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAbstractCellLocator_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCellLocator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCellLocator",dType)) { return me; }
  if ((res= vtkAbstractCellLocator_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_SetNumberOfCellsPerBucket_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfCellsPerBucket(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_GetNumberOfCellsPerBucket_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfCellsPerBucket();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_IntersectWithLine_16(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jdouble id2,jobject id3,jobject id4,jobject id5)
{
  double temp0[3];
  double temp1[3];
  double   temp2;
  vtkPoints * temp3;
  vtkIdList * temp4;
  vtkGenericCell * temp5;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  temp2 = id2;
  temp3 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id4));
  temp5 = static_cast<vtkGenericCell*>(vtkJavaGetPointerFromObject(env, id5));

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IntersectWithLine(temp0,temp1,temp2,temp3,temp4,temp5);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_FindCellsAlongLine_17(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jdouble id2,jobject id3)
{
  double temp0[3];
  double temp1[3];
  double   temp2;
  vtkIdList * temp3;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  temp2 = id2;
  temp3 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id3));

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->FindCellsAlongLine(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_FreeSearchStructure_18(JNIEnv* env, jobject obj)
{

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->FreeSearchStructure();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_BuildLocator_19(JNIEnv* env, jobject obj)
{

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->BuildLocator();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_ForceBuildLocator_110(JNIEnv* env, jobject obj)
{

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceBuildLocator();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_GenerateRepresentation_111(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkPolyData * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id1));

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->GenerateRepresentation(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_BuildLocatorIfNeeded_112(JNIEnv* env, jobject obj)
{

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->BuildLocatorIfNeeded();

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocator_GetCells_113(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkIdList * temp20;
  temp0 = id0;

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCells(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_GetNumberOfBuckets_114(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfBuckets();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocator_ShallowCopy_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractCellLocator * temp0;
  temp0 = static_cast<vtkAbstractCellLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShallowCopy(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_IntersectWithLine_116(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jobject id2,jobject id3)
{
  double temp0[3];
  double temp1[3];
  vtkPoints * temp2;
  vtkIdList * temp3;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  temp2 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id3));

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IntersectWithLine(temp0,temp1,temp2,temp3);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocator_IntersectWithLine_117(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jdouble id2,jobject id3,jobject id4)
{
  double temp0[3];
  double temp1[3];
  double   temp2;
  vtkPoints * temp3;
  vtkIdList * temp4;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  temp2 = id2;
  temp3 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id4));

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IntersectWithLine(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocator_FindCell_118(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkCellLocator* op = static_cast<vtkCellLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FindCell(temp0);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCellLocator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCellLocator::New());
}
