// java wrapper for vtkCellLocatorStrategy object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCellLocatorStrategy.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkFindCellStrategy_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCellLocatorStrategy_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCellLocatorStrategy",dType)) { return me; }
  if ((res= vtkFindCellStrategy_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocatorStrategy_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocatorStrategy_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocatorStrategy_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocatorStrategy_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellLocatorStrategy_Initialize_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPointSet * temp0;
  int   temp20;
  temp0 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Initialize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkCellLocatorStrategy_InsideCellBounds_15(JNIEnv* env, jobject obj,jdoubleArray id0,jlong id1)
{
  double temp0[3];
  long long   temp1;
  bool   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = id1;

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsideCellBounds(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocatorStrategy_SetCellLocator_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractCellLocator * temp0;
  temp0 = static_cast<vtkAbstractCellLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCellLocator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellLocatorStrategy_GetCellLocator_17(JNIEnv* env, jobject obj)
{
  vtkAbstractCellLocator * temp20;

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellLocator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellLocatorStrategy_CopyParameters_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkFindCellStrategy * temp0;
  temp0 = static_cast<vtkFindCellStrategy*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCellLocatorStrategy* op = static_cast<vtkCellLocatorStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyParameters(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCellLocatorStrategy_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCellLocatorStrategy::New());
}
