// java wrapper for vtkClosestPointStrategy object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkClosestPointStrategy.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkFindCellStrategy_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkClosestPointStrategy_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkClosestPointStrategy",dType)) { return me; }
  if ((res= vtkFindCellStrategy_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkClosestPointStrategy_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkClosestPointStrategy_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkClosestPointStrategy_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkClosestPointStrategy_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkClosestPointStrategy_Initialize_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPointSet * temp0;
  int   temp20;
  temp0 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Initialize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkClosestPointStrategy_InsideCellBounds_15(JNIEnv* env, jobject obj,jdoubleArray id0,jlong id1)
{
  double temp0[3];
  long long   temp1;
  bool   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = id1;

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsideCellBounds(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkClosestPointStrategy_SetPointLocator_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractPointLocator * temp0;
  temp0 = static_cast<vtkAbstractPointLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPointLocator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkClosestPointStrategy_GetPointLocator_17(JNIEnv* env, jobject obj)
{
  vtkAbstractPointLocator * temp20;

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPointLocator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkClosestPointStrategy_SelectCell_18(JNIEnv* env, jobject obj,jobject id0,jlong id1,jobject id2,jobject id3)
{
  vtkPointSet * temp0;
  long long   temp1;
  vtkCell * temp2;
  vtkGenericCell * temp3;
  vtkCell * temp20;
  temp0 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;
  temp2 = static_cast<vtkCell*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkGenericCell*>(vtkJavaGetPointerFromObject(env, id3));

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SelectCell(temp0,temp1,temp2,temp3);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkClosestPointStrategy_CopyParameters_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkFindCellStrategy * temp0;
  temp0 = static_cast<vtkFindCellStrategy*>(vtkJavaGetPointerFromObject(env, id0));

  vtkClosestPointStrategy* op = static_cast<vtkClosestPointStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyParameters(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkClosestPointStrategy_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkClosestPointStrategy::New());
}
