// java wrapper for vtkEdgeTable object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkEdgeTable.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkEdgeTable_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkEdgeTable",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEdgeTable_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEdgeTable_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEdgeTable_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEdgeTable_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEdgeTable_Initialize_14(JNIEnv* env, jobject obj)
{

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEdgeTable_InitEdgeInsertion_15(JNIEnv* env, jobject obj,jlong id0,jint id1)
{
  long long   temp0;
  int   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InitEdgeInsertion(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEdgeTable_InsertEdge_16(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  long long   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertEdge(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEdgeTable_InsertEdge_17(JNIEnv* env, jobject obj,jlong id0,jlong id1,jlong id2)
{
  long long   temp0;
  long long   temp1;
  long long   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertEdge(temp0,temp1,temp2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEdgeTable_IsEdge_18(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  long long   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsEdge(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEdgeTable_InitPointInsertion_19(JNIEnv* env, jobject obj,jobject id0,jlong id1)
{
  vtkPoints * temp0;
  long long   temp1;
  int   temp20;
  temp0 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InitPointInsertion(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEdgeTable_GetNumberOfEdges_110(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfEdges();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEdgeTable_InitTraversal_111(JNIEnv* env, jobject obj)
{

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  op->InitTraversal();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEdgeTable_Reset_112(JNIEnv* env, jobject obj)
{

  vtkEdgeTable* op = static_cast<vtkEdgeTable*>(vtkJavaGetPointerFromObject(env, obj));
  op->Reset();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkEdgeTable_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkEdgeTable::New());
}
