// java wrapper for vtkExtractStructuredGridHelper object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractStructuredGridHelper.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExtractStructuredGridHelper_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExtractStructuredGridHelper",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetOutputWholeExtent_14(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractStructuredGridHelper_Initialize_15(JNIEnv* env, jobject obj,jintArray id0,jintArray id1,jintArray id2,jboolean id3)
{
  int temp0[6];
  int temp1[6];
  int temp2[3];
  bool   temp3;
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  env->GetIntArrayRegion(id2, 0, 3, reinterpret_cast<jint*>(&temp2[0]));
  temp3 = (id3 != 0) ? true : false;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize(temp0,temp1,temp2,temp3);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  env->SetIntArrayRegion(id2, 0, 3, reinterpret_cast<jint*>(&temp2[0]));

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkExtractStructuredGridHelper_IsValid_16(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsValid();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetSize_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  int   temp20;
  temp0 = id0;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetMappedIndex_18(JNIEnv* env, jobject obj,jint id0,jint id1)
{
  int   temp0;
  int   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMappedIndex(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetMappedIndexFromExtentValue_19(JNIEnv* env, jobject obj,jint id0,jint id1)
{
  int   temp0;
  int   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMappedIndexFromExtentValue(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetMappedExtentValue_110(JNIEnv* env, jobject obj,jint id0,jint id1)
{
  int   temp0;
  int   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMappedExtentValue(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetMappedExtentValueFromIndex_111(JNIEnv* env, jobject obj,jint id0,jint id1)
{
  int   temp0;
  int   temp1;
  int   temp20;
  temp0 = id0;
  temp1 = id1;

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMappedExtentValueFromIndex(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractStructuredGridHelper_ComputeBeginAndEnd_112(JNIEnv* env, jobject obj,jintArray id0,jintArray id1,jintArray id2,jintArray id3)
{
  int temp0[6];
  int temp1[6];
  int temp2[3];
  int temp3[3];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  env->GetIntArrayRegion(id2, 0, 3, reinterpret_cast<jint*>(&temp2[0]));
  env->GetIntArrayRegion(id3, 0, 3, reinterpret_cast<jint*>(&temp3[0]));

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeBeginAndEnd(temp0,temp1,temp2,temp3);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  env->SetIntArrayRegion(id2, 0, 3, reinterpret_cast<jint*>(&temp2[0]));
  env->SetIntArrayRegion(id3, 0, 3, reinterpret_cast<jint*>(&temp3[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractStructuredGridHelper_CopyPointsAndPointData_113(JNIEnv* env, jobject obj,jintArray id0,jintArray id1,jobject id2,jobject id3,jobject id4,jobject id5)
{
  int temp0[6];
  int temp1[6];
  vtkPointData * temp2;
  vtkPoints * temp3;
  vtkPointData * temp4;
  vtkPoints * temp5;
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  temp2 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id4));
  temp5 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id5));

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyPointsAndPointData(temp0,temp1,temp2,temp3,temp4,temp5);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractStructuredGridHelper_CopyCellData_114(JNIEnv* env, jobject obj,jintArray id0,jintArray id1,jobject id2,jobject id3)
{
  int temp0[6];
  int temp1[6];
  vtkCellData * temp2;
  vtkCellData * temp3;
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  temp2 = static_cast<vtkCellData*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkCellData*>(vtkJavaGetPointerFromObject(env, id3));

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyCellData(temp0,temp1,temp2,temp3);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetPartitionedVOI_115(JNIEnv* env, jobject obj,jintArray id0,jintArray id1,jintArray id2,jboolean id3,jintArray id4)
{
  int temp0[6];
  int temp1[6];
  int temp2[3];
  bool   temp3;
  int temp4[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  env->GetIntArrayRegion(id2, 0, 3, reinterpret_cast<jint*>(&temp2[0]));
  temp3 = (id3 != 0) ? true : false;
  env->GetIntArrayRegion(id4, 0, 6, reinterpret_cast<jint*>(&temp4[0]));

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetPartitionedVOI(temp0,temp1,temp2,temp3,temp4);
  env->SetIntArrayRegion(id4, 0, 6, reinterpret_cast<jint*>(&temp4[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractStructuredGridHelper_GetPartitionedOutputExtent_116(JNIEnv* env, jobject obj,jintArray id0,jintArray id1,jintArray id2,jintArray id3,jboolean id4,jintArray id5)
{
  int temp0[6];
  int temp1[6];
  int temp2[6];
  int temp3[3];
  bool   temp4;
  int temp5[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  env->GetIntArrayRegion(id2, 0, 6, reinterpret_cast<jint*>(&temp2[0]));
  env->GetIntArrayRegion(id3, 0, 3, reinterpret_cast<jint*>(&temp3[0]));
  temp4 = (id4 != 0) ? true : false;
  env->GetIntArrayRegion(id5, 0, 6, reinterpret_cast<jint*>(&temp5[0]));

  vtkExtractStructuredGridHelper* op = static_cast<vtkExtractStructuredGridHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetPartitionedOutputExtent(temp0,temp1,temp2,temp3,temp4,temp5);
  env->SetIntArrayRegion(id5, 0, 6, reinterpret_cast<jint*>(&temp5[0]));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtractStructuredGridHelper_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkExtractStructuredGridHelper::New());
}
