// java wrapper for vtkImplicitWindowFunction object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImplicitWindowFunction.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImplicitFunction_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImplicitWindowFunction_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImplicitWindowFunction",dType)) { return me; }
  if ((res= vtkImplicitFunction_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImplicitWindowFunction_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImplicitWindowFunction_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImplicitWindowFunction_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImplicitWindowFunction_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImplicitWindowFunction_EvaluateFunction_14(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  double   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->EvaluateFunction(temp0);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_EvaluateGradient_15(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[3];
  double temp1[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->EvaluateGradient(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 3, &temp1[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_SetImplicitFunction_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImplicitFunction * temp0;
  temp0 = static_cast<vtkImplicitFunction*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetImplicitFunction(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImplicitWindowFunction_GetImplicitFunction_17(JNIEnv* env, jobject obj)
{
  vtkImplicitFunction * temp20;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetImplicitFunction();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_SetWindowRange_18(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWindowRange(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_SetWindowRange_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWindowRange(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImplicitWindowFunction_GetWindowRange_110(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWindowRange();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_SetWindowValues_111(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWindowValues(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_SetWindowValues_112(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWindowValues(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImplicitWindowFunction_GetWindowValues_113(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWindowValues();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImplicitWindowFunction_GetMTime_114(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkImplicitWindowFunction_UsesGarbageCollector_115(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->UsesGarbageCollector();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImplicitWindowFunction_EvaluateFunction_116(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkDataArray * temp0;
  vtkDataArray * temp1;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  op->EvaluateFunction(temp0,temp1);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImplicitWindowFunction_EvaluateFunction_117(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImplicitWindowFunction* op = static_cast<vtkImplicitWindowFunction*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->EvaluateFunction(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImplicitWindowFunction_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImplicitWindowFunction::New());
}
