// java wrapper for vtkInEdgeIterator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkInEdgeIterator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkInEdgeIterator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkInEdgeIterator",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInEdgeIterator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInEdgeIterator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInEdgeIterator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInEdgeIterator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInEdgeIterator_Initialize_14(JNIEnv* env, jobject obj,jobject id0,jlong id1)
{
  vtkGraph * temp0;
  long long   temp1;
  temp0 = static_cast<vtkGraph*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInEdgeIterator_GetGraph_15(JNIEnv* env, jobject obj)
{
  vtkGraph * temp20;

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGraph();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInEdgeIterator_GetVertex_16(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVertex();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInEdgeIterator_NextGraphEdge_17(JNIEnv* env, jobject obj)
{
  vtkGraphEdge * temp20;

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->NextGraphEdge();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkInEdgeIterator_HasNext_18(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkInEdgeIterator* op = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasNext();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkInEdgeIterator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkInEdgeIterator::New());
}
