// java wrapper for vtkIncrementalPointLocator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkIncrementalPointLocator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAbstractPointLocator_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkIncrementalPointLocator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkIncrementalPointLocator",dType)) { return me; }
  if ((res= vtkAbstractPointLocator_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIncrementalPointLocator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIncrementalPointLocator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIncrementalPointLocator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIncrementalPointLocator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIncrementalPointLocator_FindClosestInsertedPoint_14(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FindClosestInsertedPoint(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIncrementalPointLocator_InitPointInsertion_15(JNIEnv* env, jobject obj,jobject id0,jdoubleArray id1)
{
  vtkPoints * temp0;
  double temp1[6];
  int   temp20;
  temp0 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id0));
  env->GetDoubleArrayRegion(id1, 0, 6, &temp1[0]);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InitPointInsertion(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIncrementalPointLocator_InitPointInsertion_16(JNIEnv* env, jobject obj,jobject id0,jdoubleArray id1,jlong id2)
{
  vtkPoints * temp0;
  double temp1[6];
  long long   temp2;
  int   temp20;
  temp0 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id0));
  env->GetDoubleArrayRegion(id1, 0, 6, &temp1[0]);
  temp2 = id2;

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InitPointInsertion(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIncrementalPointLocator_IsInsertedPoint_17(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  long long   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsInsertedPoint(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIncrementalPointLocator_IsInsertedPoint_18(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsInsertedPoint(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkIncrementalPointLocator_InsertPoint_19(JNIEnv* env, jobject obj,jlong id0,jdoubleArray id1)
{
  long long   temp0;
  double temp1[3];
  temp0 = id0;
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsertPoint(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIncrementalPointLocator_InsertNextPoint_110(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkIncrementalPointLocator* op = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InsertNextPoint(temp0);
  return temp20;

}
