// java wrapper for vtkMultiBlockDataSet object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMultiBlockDataSet.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataObjectTree_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMultiBlockDataSet_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMultiBlockDataSet",dType)) { return me; }
  if ((res= vtkDataObjectTree_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiBlockDataSet_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiBlockDataSet_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiBlockDataSet_GetDataObjectType_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataObjectType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiBlockDataSet_SetNumberOfBlocks_15(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  temp0 = id0;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfBlocks(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiBlockDataSet_GetNumberOfBlocks_16(JNIEnv* env, jobject obj)
{
   unsigned int   temp20;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfBlocks();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetBlock_17(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  vtkDataObject * temp20;
  temp0 = id0;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBlock(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiBlockDataSet_SetBlock_18(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
   unsigned int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBlock(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiBlockDataSet_RemoveBlock_19(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  temp0 = id0;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveBlock(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiBlockDataSet_HasMetaData_110(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  int   temp20;
  temp0 = id0;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasMetaData(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetMetaData_111(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  vtkInformation * temp20;
  temp0 = id0;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMetaData(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetData_112(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  vtkMultiBlockDataSet * temp20;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetData_113(JNIEnv* env, jobject obj,jobject id0,jint id1)
{
  vtkInformationVector * temp0;
  int   temp1;
  vtkMultiBlockDataSet * temp20;
  temp0 = static_cast<vtkInformationVector*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData(temp0,temp1);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiBlockDataSet_GetMetaData_114(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCompositeDataIterator * temp0;
  vtkInformation * temp20;
  temp0 = static_cast<vtkCompositeDataIterator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMetaData(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiBlockDataSet_HasMetaData_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCompositeDataIterator * temp0;
  int   temp20;
  temp0 = static_cast<vtkCompositeDataIterator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMultiBlockDataSet* op = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasMetaData(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMultiBlockDataSet_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMultiBlockDataSet::New());
}
