// java wrapper for vtkMultiPieceDataSet object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMultiPieceDataSet.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPartitionedDataSet_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMultiPieceDataSet_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMultiPieceDataSet",dType)) { return me; }
  if ((res= vtkPartitionedDataSet_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiPieceDataSet_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiPieceDataSet_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiPieceDataSet_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiPieceDataSet_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiPieceDataSet_GetDataObjectType_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataObjectType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiPieceDataSet_SetNumberOfPieces_15(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  temp0 = id0;

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfPieces(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiPieceDataSet_GetNumberOfPieces_16(JNIEnv* env, jobject obj)
{
   unsigned int   temp20;

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfPieces();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiPieceDataSet_GetPiece_17(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  vtkDataSet * temp20;
  temp0 = id0;

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPiece(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiPieceDataSet_GetPieceAsDataObject_18(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  vtkDataObject * temp20;
  temp0 = id0;

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPieceAsDataObject(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiPieceDataSet_SetPiece_19(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
   unsigned int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPiece(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiPieceDataSet_GetData_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  vtkMultiPieceDataSet * temp20;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiPieceDataSet_GetData_111(JNIEnv* env, jobject obj,jobject id0,jint id1)
{
  vtkInformationVector * temp0;
  int   temp1;
  vtkMultiPieceDataSet * temp20;
  temp0 = static_cast<vtkInformationVector*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkMultiPieceDataSet* op = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData(temp0,temp1);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMultiPieceDataSet_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMultiPieceDataSet::New());
}
