// java wrapper for vtkPlanesIntersection object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPlanesIntersection.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPlanes_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPlanesIntersection_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPlanesIntersection",dType)) { return me; }
  if ((res= vtkPlanes_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPlanesIntersection_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPlanesIntersection_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPlanesIntersection_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPlanesIntersection_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPlanesIntersection_SetRegionVertices_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPoints * temp0;
  temp0 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRegionVertices(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPlanesIntersection_GetNumberOfRegionVertices_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfRegionVertices();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPlanesIntersection_GetNumRegionVertices_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumRegionVertices();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPlanesIntersection_IntersectsRegion_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPoints * temp0;
  int   temp20;
  temp0 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IntersectsRegion(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPlanesIntersection_PolygonIntersectsBBox_18(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1)
{
  double temp0[6];
  vtkPoints * temp1;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);
  temp1 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PolygonIntersectsBBox(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 6, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPlanesIntersection_Convert3DCell_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCell * temp0;
  vtkPlanesIntersection * temp20;
  temp0 = static_cast<vtkCell*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPlanesIntersection* op = static_cast<vtkPlanesIntersection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Convert3DCell(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPlanesIntersection_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPlanesIntersection::New());
}
