// java wrapper for vtkPyramid object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPyramid.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkCell3D_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPyramid_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPyramid",dType)) { return me; }
  if ((res= vtkCell3D_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPyramid_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPyramid_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkPyramid_GetCentroid_14(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  bool   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCentroid(temp0);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkPyramid_IsInsideOut_15(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsInsideOut();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_GetCellType_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellType();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_GetCellDimension_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellDimension();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_GetNumberOfEdges_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfEdges();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_GetNumberOfFaces_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfFaces();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPyramid_GetEdge_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkCell * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdge(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPyramid_GetFace_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkCell * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFace(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_CellBoundary_112(JNIEnv* env, jobject obj,jint id0,jdoubleArray id1,jobject id2)
{
  int   temp0;
  double temp1[3];
  vtkIdList * temp2;
  int   temp20;
  temp0 = id0;
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);
  temp2 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id2));

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CellBoundary(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPyramid_Contour_113(JNIEnv* env, jobject obj,jdouble id0,jobject id1,jobject id2,jobject id3,jobject id4,jobject id5,jobject id6,jobject id7,jobject id8,jlong id9,jobject id10)
{
  double   temp0;
  vtkDataArray * temp1;
  vtkIncrementalPointLocator * temp2;
  vtkCellArray * temp3;
  vtkCellArray * temp4;
  vtkCellArray * temp5;
  vtkPointData * temp6;
  vtkPointData * temp7;
  vtkCellData * temp8;
  long long   temp9;
  vtkCellData * temp10;
  temp0 = id0;
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkIncrementalPointLocator*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id4));
  temp5 = static_cast<vtkCellArray*>(vtkJavaGetPointerFromObject(env, id5));
  temp6 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id6));
  temp7 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id7));
  temp8 = static_cast<vtkCellData*>(vtkJavaGetPointerFromObject(env, id8));
  temp9 = id9;
  temp10 = static_cast<vtkCellData*>(vtkJavaGetPointerFromObject(env, id10));

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  op->Contour(temp0,temp1,temp2,temp3,temp4,temp5,temp6,temp7,temp8,temp9,temp10);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_Triangulate_114(JNIEnv* env, jobject obj,jint id0,jobject id1,jobject id2)
{
  int   temp0;
  vtkIdList * temp1;
  vtkPoints * temp2;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id2));

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Triangulate(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPyramid_GetParametricCenter_115(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetParametricCenter(temp0);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPyramid_InterpolationFunctions_116(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[3];
  double temp1[5];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 5, &temp1[0]);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  op->InterpolationFunctions(temp0,temp1);
  env->SetDoubleArrayRegion(id1, 0, 5, &temp1[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPyramid_InterpolationDerivs_117(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[3];
  double temp1[15];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 15, &temp1[0]);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  op->InterpolationDerivs(temp0,temp1);
  env->SetDoubleArrayRegion(id1, 0, 15, &temp1[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPyramid_InterpolateFunctions_118(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[3];
  double temp1[5];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 5, &temp1[0]);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  op->InterpolateFunctions(temp0,temp1);
  env->SetDoubleArrayRegion(id1, 0, 5, &temp1[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPyramid_InterpolateDerivs_119(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[3];
  double temp1[15];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 15, &temp1[0]);

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  op->InterpolateDerivs(temp0,temp1);
  env->SetDoubleArrayRegion(id1, 0, 15, &temp1[0]);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetEdgeArray_120(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdgeArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 2);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetFaceArray_121(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFaceArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 4);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetEdgeToAdjacentFacesArray_122(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdgeToAdjacentFacesArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 2);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetFaceToAdjacentFacesArray_123(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFaceToAdjacentFacesArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 4);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetPointToIncidentEdgesArray_124(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPointToIncidentEdgesArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 4);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetPointToIncidentFacesArray_125(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPointToIncidentFacesArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 4);

}

extern "C" JNIEXPORT jlongArray  JNICALL Java_vtk_vtkPyramid_GetPointToOneRingPointsArray_126(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  const long long * temp20;
  temp0 = id0;

  vtkPyramid* op = static_cast<vtkPyramid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPointToOneRingPointsArray(temp0);
  return vtkJavaMakeJArrayOfLong(env, reinterpret_cast<const jlong*>(temp20), 4);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPyramid_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPyramid::New());
}
