// java wrapper for vtkSpline object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSpline.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkSpline_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkSpline",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSpline_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSpline_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetParametricRange_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetParametricRange(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetParametricRange_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetParametricRange(temp0);
  env->SetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_GetParametricRange_16(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetParametricRange(temp0);
  env->SetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetClampValue_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetClampValue(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetClampValue_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetClampValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_ClampValueOn_19(JNIEnv* env, jobject obj)
{

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClampValueOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_ClampValueOff_110(JNIEnv* env, jobject obj)
{

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClampValueOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_Compute_111(JNIEnv* env, jobject obj)
{

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->Compute();

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSpline_Evaluate_112(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  double   temp20;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Evaluate(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetNumberOfPoints_113(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfPoints();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_AddPoint_114(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddPoint(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_RemovePoint_115(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemovePoint(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_RemoveAllPoints_116(JNIEnv* env, jobject obj)
{

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveAllPoints();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetClosed_117(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetClosed(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetClosed_118(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetClosed();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_ClosedOn_119(JNIEnv* env, jobject obj)
{

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClosedOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_ClosedOff_120(JNIEnv* env, jobject obj)
{

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClosedOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetLeftConstraint_121(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLeftConstraint(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetLeftConstraintMinValue_122(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLeftConstraintMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetLeftConstraintMaxValue_123(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLeftConstraintMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetLeftConstraint_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLeftConstraint();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetRightConstraint_125(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRightConstraint(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetRightConstraintMinValue_126(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRightConstraintMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetRightConstraintMaxValue_127(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRightConstraintMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSpline_GetRightConstraint_128(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRightConstraint();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetLeftValue_129(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLeftValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSpline_GetLeftValue_130(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLeftValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_SetRightValue_131(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRightValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSpline_GetRightValue_132(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRightValue();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSpline_GetMTime_133(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSpline_DeepCopy_134(JNIEnv* env, jobject obj,jobject id0)
{
  vtkSpline * temp0;
  temp0 = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSpline* op = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopy(temp0);

}
