// java wrapper for vtkUndirectedGraph object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUndirectedGraph.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkGraph_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkUndirectedGraph_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkUndirectedGraph",dType)) { return me; }
  if ((res= vtkGraph_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUndirectedGraph_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUndirectedGraph_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUndirectedGraph_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUndirectedGraph_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUndirectedGraph_GetDataObjectType_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataObjectType();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUndirectedGraph_GetInDegree_15(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  long long   temp20;
  temp0 = id0;

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInDegree(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUndirectedGraph_GetInEdge_16(JNIEnv* env, jobject obj,jlong id0,jlong id1,jobject id2)
{
  long long   temp0;
  long long   temp1;
  vtkGraphEdge * temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = static_cast<vtkGraphEdge*>(vtkJavaGetPointerFromObject(env, id2));

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetInEdge(temp0,temp1,temp2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUndirectedGraph_GetData_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  vtkUndirectedGraph * temp20;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUndirectedGraph_GetData_18(JNIEnv* env, jobject obj,jobject id0,jint id1)
{
  vtkInformationVector * temp0;
  int   temp1;
  vtkUndirectedGraph * temp20;
  temp0 = static_cast<vtkInformationVector*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetData(temp0,temp1);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUndirectedGraph_GetInEdges_19(JNIEnv* env, jobject obj,jlong id0,jobject id1)
{
  long long   temp0;
  vtkInEdgeIterator * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkInEdgeIterator*>(vtkJavaGetPointerFromObject(env, id1));

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetInEdges(temp0,temp1);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkUndirectedGraph_IsStructureValid_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkGraph * temp0;
  bool   temp20;
  temp0 = static_cast<vtkGraph*>(vtkJavaGetPointerFromObject(env, id0));

  vtkUndirectedGraph* op = static_cast<vtkUndirectedGraph*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsStructureValid(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkUndirectedGraph_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkUndirectedGraph::New());
}
