// java wrapper for vtkDataSetAlgorithm object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkDataSetAlgorithm.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkDataSetAlgorithm",dType)) { return me; }
  if ((res= vtkAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkDataSetAlgorithm_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkDataSetAlgorithm_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkDataSet * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetOutput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkDataSet * temp20;
  temp0 = id0;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetInput_16(JNIEnv* env, jobject obj)
{
  vtkDataObject * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetPolyDataOutput_17(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyDataOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetStructuredPointsOutput_18(JNIEnv* env, jobject obj)
{
  vtkStructuredPoints * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredPointsOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetImageDataOutput_19(JNIEnv* env, jobject obj)
{
  vtkImageData * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetImageDataOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetStructuredGridOutput_110(JNIEnv* env, jobject obj)
{
  vtkStructuredGrid * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetUnstructuredGridOutput_111(JNIEnv* env, jobject obj)
{
  vtkUnstructuredGrid * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUnstructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDataSetAlgorithm_GetRectilinearGridOutput_112(JNIEnv* env, jobject obj)
{
  vtkRectilinearGrid * temp20;

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRectilinearGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_SetInputData_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_SetInputData_114(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_SetInputData_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataSet * temp0;
  temp0 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_SetInputData_116(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataSet * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id1));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_AddInputData_117(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_AddInputData_118(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataSet * temp0;
  temp0 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_AddInputData_119(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataSet * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id1));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDataSetAlgorithm_AddInputData_120(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkDataSetAlgorithm* op = static_cast<vtkDataSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0,temp1);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkDataSetAlgorithm_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkDataSetAlgorithm::New());
}
