// java wrapper for vtkDirectedGraphAlgorithm object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkDirectedGraphAlgorithm.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkDirectedGraphAlgorithm_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkDirectedGraphAlgorithm",dType)) { return me; }
  if ((res= vtkAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkDirectedGraph * temp20;

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_GetOutput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkDirectedGraph * temp20;
  temp0 = id0;

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_SetInputData_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkDirectedGraphAlgorithm_SetInputData_17(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkDirectedGraphAlgorithm* op = static_cast<vtkDirectedGraphAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0,temp1);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkDirectedGraphAlgorithm_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkDirectedGraphAlgorithm::New());
}
