// java wrapper for vtkExtentTranslator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtentTranslator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExtentTranslator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExtentTranslator",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtentTranslator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtentTranslator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetWholeExtent_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetWholeExtent_15(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkExtentTranslator_GetWholeExtent_16(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetExtent_17(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetExtent_18(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtent(temp0);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkExtentTranslator_GetExtent_19(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetPiece_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPiece(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_GetPiece_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPiece();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetNumberOfPieces_112(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfPieces(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_GetNumberOfPieces_113(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfPieces();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetGhostLevel_114(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetGhostLevel(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_GetGhostLevel_115(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGhostLevel();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_PieceToExtent_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PieceToExtent();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_PieceToExtentByPoints_117(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PieceToExtentByPoints();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetSplitModeToBlock_118(JNIEnv* env, jobject obj)
{

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSplitModeToBlock();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetSplitModeToXSlab_119(JNIEnv* env, jobject obj)
{

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSplitModeToXSlab();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetSplitModeToYSlab_120(JNIEnv* env, jobject obj)
{

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSplitModeToYSlab();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtentTranslator_SetSplitModeToZSlab_121(JNIEnv* env, jobject obj)
{

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSplitModeToZSlab();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtentTranslator_GetSplitMode_122(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSplitMode();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtentTranslator_UPDATE_1SPLIT_1MODE_123(JNIEnv* env, jobject obj)
{
  vtkInformationIntegerRequestKey * temp20;

  vtkExtentTranslator* op = static_cast<vtkExtentTranslator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->UPDATE_SPLIT_MODE();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtentTranslator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkExtentTranslator::New());
}
