// java wrapper for vtkHyperTreeGridAlgorithm object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHyperTreeGridAlgorithm.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkHyperTreeGridAlgorithm_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkHyperTreeGridAlgorithm",dType)) { return me; }
  if ((res= vtkAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkDataObject * temp20;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetOutput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkDataObject * temp20;
  temp0 = id0;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_SetOutput_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutput(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetHyperTreeGridOutput_17(JNIEnv* env, jobject obj)
{
  vtkHyperTreeGrid * temp20;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHyperTreeGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetHyperTreeGridOutput_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkHyperTreeGrid * temp20;
  temp0 = id0;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHyperTreeGridOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetPolyDataOutput_19(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyDataOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetPolyDataOutput_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkPolyData * temp20;
  temp0 = id0;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyDataOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetUnstructuredGridOutput_111(JNIEnv* env, jobject obj)
{
  vtkUnstructuredGrid * temp20;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUnstructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_GetUnstructuredGridOutput_112(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkUnstructuredGrid * temp20;
  temp0 = id0;

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUnstructuredGridOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_SetInputData_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_SetInputData_114(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_AddInputData_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGridAlgorithm_AddInputData_116(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkHyperTreeGridAlgorithm* op = static_cast<vtkHyperTreeGridAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0,temp1);

}
