// java wrapper for vtkPointSetAlgorithm object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPointSetAlgorithm.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPointSetAlgorithm_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPointSetAlgorithm",dType)) { return me; }
  if ((res= vtkAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPointSetAlgorithm_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPointSetAlgorithm_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkPointSet * temp20;

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetOutput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkPointSet * temp20;
  temp0 = id0;

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetPolyDataOutput_16(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyDataOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetStructuredGridOutput_17(JNIEnv* env, jobject obj)
{
  vtkStructuredGrid * temp20;

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetUnstructuredGridOutput_18(JNIEnv* env, jobject obj)
{
  vtkUnstructuredGrid * temp20;

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUnstructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_SetInputData_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_SetInputData_110(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_SetInputData_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPointSet * temp0;
  temp0 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_SetInputData_112(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkPointSet * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_AddInputData_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_AddInputData_114(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPointSet * temp0;
  temp0 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_AddInputData_115(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkPointSet * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkPointSet*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointSetAlgorithm_AddInputData_116(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkDataObject * temp1;
  temp0 = id0;
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddInputData(temp0,temp1);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointSetAlgorithm_GetInput_117(JNIEnv* env, jobject obj)
{
  vtkDataObject * temp20;

  vtkPointSetAlgorithm* op = static_cast<vtkPointSetAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPointSetAlgorithm_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPointSetAlgorithm::New());
}
