// java wrapper for vtkReaderAlgorithm object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkReaderAlgorithm.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkReaderAlgorithm_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkReaderAlgorithm",dType)) { return me; }
  if ((res= vtkAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkReaderAlgorithm_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkReaderAlgorithm_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkReaderAlgorithm_CreateOutput_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  vtkDataObject * temp20;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CreateOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_ReadMetaData_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  int   temp20;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMetaData(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_ReadTimeDependentMetaData_16(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadTimeDependentMetaData(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_ReadMesh_17(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMesh(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_ReadPoints_18(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadPoints(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkReaderAlgorithm_ReadArrays_19(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkReaderAlgorithm* op = static_cast<vtkReaderAlgorithm*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadArrays(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}
