// java wrapper for vtkScalarTree object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkScalarTree.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkScalarTree_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkScalarTree",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkScalarTree_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkScalarTree_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkScalarTree_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkScalarTree_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkScalarTree_ShallowCopy_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkScalarTree * temp0;
  temp0 = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, id0));

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShallowCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkScalarTree_SetDataSet_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataSet * temp0;
  temp0 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDataSet(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkScalarTree_GetDataSet_16(JNIEnv* env, jobject obj)
{
  vtkDataSet * temp20;

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataSet();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkScalarTree_SetScalars_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataArray * temp0;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalars(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkScalarTree_GetScalars_18(JNIEnv* env, jobject obj)
{
  vtkDataArray * temp20;

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalars();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkScalarTree_BuildTree_19(JNIEnv* env, jobject obj)
{

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  op->BuildTree();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkScalarTree_Initialize_110(JNIEnv* env, jobject obj)
{

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkScalarTree_InitTraversal_111(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  op->InitTraversal(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkScalarTree_GetScalarValue_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalarValue();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkScalarTree_GetNumberOfCellBatches_113(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  long long   temp20;
  temp0 = id0;

  vtkScalarTree* op = static_cast<vtkScalarTree*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfCellBatches(temp0);
  return temp20;

}
