// java wrapper for vtkSimpleReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSimpleReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkReaderAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkSimpleReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkSimpleReader",dType)) { return me; }
  if ((res= vtkReaderAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSimpleReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSimpleReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSimpleReader_AddFileName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddFileName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSimpleReader_ClearFileNames_15(JNIEnv* env, jobject obj)
{

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearFileNames();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_GetNumberOfFileNames_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfFileNames();
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSimpleReader_GetFileName_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  const char * temp20;
  temp0 = id0;

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName(temp0);
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSimpleReader_GetCurrentFileName_18(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCurrentFileName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadTimeDependentMetaData_19(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadTimeDependentMetaData(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadMetaData_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformation * temp0;
  int   temp20;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMetaData(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadMesh_111(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMesh(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadPoints_112(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadPoints(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadArrays_113(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jobject id4)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  vtkDataObject * temp4;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id4));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadArrays(temp0,temp1,temp2,temp3,temp4);
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSimpleReader_GetTimeValue_114(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  std::string temp0;
  double   temp20;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTimeValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadMetaDataSimple_115(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1)
{
  std::string temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMetaDataSimple(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadMeshSimple_116(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1)
{
  std::string temp0;
  vtkDataObject * temp1;
  int   temp20;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMeshSimple(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadPointsSimple_117(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1)
{
  std::string temp0;
  vtkDataObject * temp1;
  int   temp20;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadPointsSimple(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSimpleReader_ReadArraysSimple_118(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1)
{
  std::string temp0;
  vtkDataObject * temp1;
  int   temp20;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkSimpleReader* op = static_cast<vtkSimpleReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadArraysSimple(temp0,temp1);
  return temp20;

}
