// java wrapper for vtkHeap object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHeap.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkHeap_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkHeap",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHeap_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHeap_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHeap_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHeap_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHeap_GetNumberOfBlocks_14(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfBlocks();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHeap_GetNumberOfAllocations_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfAllocations();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHeap_Reset_16(JNIEnv* env, jobject obj)
{

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  op->Reset();

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkHeap_StringDup_17(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  char * temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHeap* op = static_cast<vtkHeap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->StringDup(temp0);
  delete[] temp0;
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkHeap_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkHeap::New());
}
