// java wrapper for vtkBinCellDataFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBinCellDataFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkBinCellDataFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkBinCellDataFilter",dType)) { return me; }
  if ((res= vtkDataSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBinCellDataFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBinCellDataFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetValue_14(JNIEnv* env, jobject obj,jint id0,jdouble id1)
{
  int   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetValue(temp0,temp1);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkBinCellDataFilter_GetValue_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  double   temp20;
  temp0 = id0;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValue(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetNumberOfBins_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfBins(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBinCellDataFilter_GetNumberOfBins_17(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfBins();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_GenerateValues_18(JNIEnv* env, jobject obj,jint id0,jdoubleArray id1)
{
  int   temp0;
  double temp1[2];
  temp0 = id0;
  env->GetDoubleArrayRegion(id1, 0, 2, &temp1[0]);

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->GenerateValues(temp0,temp1);
  env->SetDoubleArrayRegion(id1, 0, 2, &temp1[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_GenerateValues_19(JNIEnv* env, jobject obj,jint id0,jdouble id1,jdouble id2)
{
  int   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->GenerateValues(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetSourceData_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSourceData(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBinCellDataFilter_GetSource_111(JNIEnv* env, jobject obj)
{
  vtkDataObject * temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSource();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetSourceConnection_112(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAlgorithmOutput * temp0;
  temp0 = static_cast<vtkAlgorithmOutput*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSourceConnection(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetSpatialMatch_113(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSpatialMatch(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_GetSpatialMatch_114(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSpatialMatch();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SpatialMatchOn_115(JNIEnv* env, jobject obj)
{

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SpatialMatchOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SpatialMatchOff_116(JNIEnv* env, jobject obj)
{

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SpatialMatchOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetStoreNumberOfNonzeroBins_117(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStoreNumberOfNonzeroBins(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_StoreNumberOfNonzeroBinsOn_118(JNIEnv* env, jobject obj)
{

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->StoreNumberOfNonzeroBinsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_StoreNumberOfNonzeroBinsOff_119(JNIEnv* env, jobject obj)
{

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->StoreNumberOfNonzeroBinsOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkBinCellDataFilter_GetStoreNumberOfNonzeroBins_120(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStoreNumberOfNonzeroBins();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetNumberOfNonzeroBinsArrayName_121(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfNonzeroBinsArrayName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkBinCellDataFilter_GetNumberOfNonzeroBinsArrayName_122(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfNonzeroBinsArrayName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetTolerance_123(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTolerance(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkBinCellDataFilter_GetTolerance_124(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTolerance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetComputeTolerance_125(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetComputeTolerance(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_ComputeToleranceOn_126(JNIEnv* env, jobject obj)
{

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeToleranceOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_ComputeToleranceOff_127(JNIEnv* env, jobject obj)
{

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeToleranceOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkBinCellDataFilter_GetComputeTolerance_128(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetComputeTolerance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetArrayComponent_129(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetArrayComponent(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_GetArrayComponent_130(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetArrayComponent();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetCellOverlapMethod_131(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCellOverlapMethod(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_GetCellOverlapMethodMinValue_132(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellOverlapMethodMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_GetCellOverlapMethodMaxValue_133(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellOverlapMethodMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBinCellDataFilter_GetCellOverlapMethod_134(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellOverlapMethod();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBinCellDataFilter_SetCellLocator_135(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractCellLocator * temp0;
  temp0 = static_cast<vtkAbstractCellLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCellLocator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBinCellDataFilter_GetCellLocator_136(JNIEnv* env, jobject obj)
{
  vtkAbstractCellLocator * temp20;

  vtkBinCellDataFilter* op = static_cast<vtkBinCellDataFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCellLocator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkBinCellDataFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkBinCellDataFilter::New());
}
