// java wrapper for vtkElevationFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkElevationFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkElevationFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkElevationFilter",dType)) { return me; }
  if ((res= vtkDataSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkElevationFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkElevationFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkElevationFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkElevationFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkElevationFilter_SetLowPoint_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLowPoint(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkElevationFilter_SetLowPoint_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLowPoint(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkElevationFilter_GetLowPoint_16(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLowPoint();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkElevationFilter_SetHighPoint_17(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetHighPoint(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkElevationFilter_SetHighPoint_18(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetHighPoint(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkElevationFilter_GetHighPoint_19(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHighPoint();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkElevationFilter_SetScalarRange_110(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalarRange(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkElevationFilter_SetScalarRange_111(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalarRange(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkElevationFilter_GetScalarRange_112(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkElevationFilter* op = static_cast<vtkElevationFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalarRange();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 2);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkElevationFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkElevationFilter::New());
}
