// java wrapper for vtkPassThrough object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPassThrough.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPassInputTypeAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPassThrough_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPassThrough",dType)) { return me; }
  if ((res= vtkPassInputTypeAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPassThrough_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPassThrough_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPassThrough_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPassThrough_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPassThrough_FillInputPortInformation_14(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FillInputPortInformation(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPassThrough_SetDeepCopyInput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDeepCopyInput(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPassThrough_GetDeepCopyInput_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDeepCopyInput();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPassThrough_DeepCopyInputOn_17(JNIEnv* env, jobject obj)
{

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopyInputOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPassThrough_DeepCopyInputOff_18(JNIEnv* env, jobject obj)
{

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopyInputOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPassThrough_SetAllowNullInput_19(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAllowNullInput(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkPassThrough_GetAllowNullInput_110(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAllowNullInput();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPassThrough_AllowNullInputOn_111(JNIEnv* env, jobject obj)
{

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  op->AllowNullInputOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPassThrough_AllowNullInputOff_112(JNIEnv* env, jobject obj)
{

  vtkPassThrough* op = static_cast<vtkPassThrough*>(vtkJavaGetPointerFromObject(env, obj));
  op->AllowNullInputOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPassThrough_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPassThrough::New());
}
