// java wrapper for vtkExtractCells object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractCells.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkUnstructuredGridAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExtractCells_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExtractCells",dType)) { return me; }
  if ((res= vtkUnstructuredGridAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractCells_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractCells_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractCells_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractCells_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_SetCellList_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdList * temp0;
  temp0 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCellList(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_AddCellList_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdList * temp0;
  temp0 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddCellList(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_AddCellRange_16(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddCellRange(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_SetExtractAllCells_17(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtractAllCells(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkExtractCells_GetExtractAllCells_18(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtractAllCells();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_ExtractAllCellsOn_19(JNIEnv* env, jobject obj)
{

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractAllCellsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_ExtractAllCellsOff_110(JNIEnv* env, jobject obj)
{

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractAllCellsOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_SetAssumeSortedAndUniqueIds_111(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAssumeSortedAndUniqueIds(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkExtractCells_GetAssumeSortedAndUniqueIds_112(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAssumeSortedAndUniqueIds();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_AssumeSortedAndUniqueIdsOn_113(JNIEnv* env, jobject obj)
{

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->AssumeSortedAndUniqueIdsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractCells_AssumeSortedAndUniqueIdsOff_114(JNIEnv* env, jobject obj)
{

  vtkExtractCells* op = static_cast<vtkExtractCells*>(vtkJavaGetPointerFromObject(env, obj));
  op->AssumeSortedAndUniqueIdsOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtractCells_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkExtractCells::New());
}
