// java wrapper for vtkExtractGeometry object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractGeometry.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkUnstructuredGridAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExtractGeometry_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExtractGeometry",dType)) { return me; }
  if ((res= vtkUnstructuredGridAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractGeometry_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractGeometry_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractGeometry_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractGeometry_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractGeometry_GetMTime_14(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_SetImplicitFunction_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImplicitFunction * temp0;
  temp0 = static_cast<vtkImplicitFunction*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetImplicitFunction(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractGeometry_GetImplicitFunction_16(JNIEnv* env, jobject obj)
{
  vtkImplicitFunction * temp20;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetImplicitFunction();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_SetExtractInside_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtractInside(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractGeometry_GetExtractInside_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtractInside();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_ExtractInsideOn_19(JNIEnv* env, jobject obj)
{

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractInsideOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_ExtractInsideOff_110(JNIEnv* env, jobject obj)
{

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractInsideOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_SetExtractBoundaryCells_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtractBoundaryCells(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractGeometry_GetExtractBoundaryCells_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtractBoundaryCells();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_ExtractBoundaryCellsOn_113(JNIEnv* env, jobject obj)
{

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractBoundaryCellsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_ExtractBoundaryCellsOff_114(JNIEnv* env, jobject obj)
{

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractBoundaryCellsOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_SetExtractOnlyBoundaryCells_115(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtractOnlyBoundaryCells(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractGeometry_GetExtractOnlyBoundaryCells_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtractOnlyBoundaryCells();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_ExtractOnlyBoundaryCellsOn_117(JNIEnv* env, jobject obj)
{

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractOnlyBoundaryCellsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractGeometry_ExtractOnlyBoundaryCellsOff_118(JNIEnv* env, jobject obj)
{

  vtkExtractGeometry* op = static_cast<vtkExtractGeometry*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractOnlyBoundaryCellsOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtractGeometry_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkExtractGeometry::New());
}
