// java wrapper for vtkExtractVectorComponents object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractVectorComponents.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExtractVectorComponents_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExtractVectorComponents",dType)) { return me; }
  if ((res= vtkDataSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractVectorComponents_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractVectorComponents_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractVectorComponents_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractVectorComponents_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractVectorComponents_SetInputData_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataSet * temp0;
  temp0 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInputData(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractVectorComponents_GetVxComponent_15(JNIEnv* env, jobject obj)
{
  vtkDataSet * temp20;

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVxComponent();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractVectorComponents_GetVyComponent_16(JNIEnv* env, jobject obj)
{
  vtkDataSet * temp20;

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVyComponent();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractVectorComponents_GetVzComponent_17(JNIEnv* env, jobject obj)
{
  vtkDataSet * temp20;

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVzComponent();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractVectorComponents_SetExtractToFieldData_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtractToFieldData(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractVectorComponents_GetExtractToFieldData_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtractToFieldData();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractVectorComponents_ExtractToFieldDataOn_110(JNIEnv* env, jobject obj)
{

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractToFieldDataOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractVectorComponents_ExtractToFieldDataOff_111(JNIEnv* env, jobject obj)
{

  vtkExtractVectorComponents* op = static_cast<vtkExtractVectorComponents*>(vtkJavaGetPointerFromObject(env, obj));
  op->ExtractToFieldDataOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtractVectorComponents_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkExtractVectorComponents::New());
}
