// java wrapper for vtkEvenlySpacedStreamlines2D object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkEvenlySpacedStreamlines2D.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkEvenlySpacedStreamlines2D_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkEvenlySpacedStreamlines2D",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetStartPosition_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStartPosition(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetStartPosition_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStartPosition(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetStartPosition_16(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStartPosition();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegrator_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInitialValueProblemSolver * temp0;
  temp0 = static_cast<vtkInitialValueProblemSolver*>(vtkJavaGetPointerFromObject(env, id0));

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIntegrator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetIntegrator_18(JNIEnv* env, jobject obj)
{
  vtkInitialValueProblemSolver * temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetIntegrator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegratorType_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIntegratorType(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetIntegratorType_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetIntegratorType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegratorTypeToRungeKutta2_111(JNIEnv* env, jobject obj)
{

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIntegratorTypeToRungeKutta2();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegratorTypeToRungeKutta4_112(JNIEnv* env, jobject obj)
{

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIntegratorTypeToRungeKutta4();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorTypeToDataSetPointLocator_113(JNIEnv* env, jobject obj)
{

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInterpolatorTypeToDataSetPointLocator();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorTypeToCellLocator_114(JNIEnv* env, jobject obj)
{

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInterpolatorTypeToCellLocator();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegrationStepUnit_115(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIntegrationStepUnit(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetIntegrationStepUnit_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetIntegrationStepUnit();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetMaximumNumberOfSteps_117(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMaximumNumberOfSteps(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetMaximumNumberOfSteps_118(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumNumberOfSteps();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetMinimumNumberOfLoopPoints_119(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMinimumNumberOfLoopPoints(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetMinimumNumberOfLoopPoints_120(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMinimumNumberOfLoopPoints();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInitialIntegrationStep_121(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInitialIntegrationStep(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetInitialIntegrationStep_122(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInitialIntegrationStep();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetSeparatingDistance_123(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSeparatingDistance(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetSeparatingDistance_124(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSeparatingDistance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetSeparatingDistanceRatio_125(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSeparatingDistanceRatio(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetSeparatingDistanceRatio_126(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSeparatingDistanceRatio();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetClosedLoopMaximumDistance_127(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetClosedLoopMaximumDistance(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetClosedLoopMaximumDistance_128(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetClosedLoopMaximumDistance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetLoopAngle_129(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLoopAngle(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetLoopAngle_130(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLoopAngle();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetTerminalSpeed_131(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTerminalSpeed(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetTerminalSpeed_132(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTerminalSpeed();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetComputeVorticity_133(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetComputeVorticity(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetComputeVorticity_134(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetComputeVorticity();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorPrototype_135(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractInterpolatedVelocityField * temp0;
  temp0 = static_cast<vtkAbstractInterpolatedVelocityField*>(vtkJavaGetPointerFromObject(env, id0));

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInterpolatorPrototype(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorType_136(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkEvenlySpacedStreamlines2D* op = static_cast<vtkEvenlySpacedStreamlines2D*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInterpolatorType(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkEvenlySpacedStreamlines2D::New());
}
