// java wrapper for vtkCellDerivatives object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCellDerivatives.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCellDerivatives_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCellDerivatives",dType)) { return me; }
  if ((res= vtkDataSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellDerivatives_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellDerivatives_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellDerivatives_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCellDerivatives_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetVectorMode_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVectorMode(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellDerivatives_GetVectorMode_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVectorMode();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetVectorModeToPassVectors_16(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVectorModeToPassVectors();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetVectorModeToComputeGradient_17(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVectorModeToComputeGradient();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetVectorModeToComputeVorticity_18(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVectorModeToComputeVorticity();

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCellDerivatives_GetVectorModeAsString_19(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVectorModeAsString();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetTensorMode_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTensorMode(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCellDerivatives_GetTensorMode_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTensorMode();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetTensorModeToPassTensors_112(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTensorModeToPassTensors();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetTensorModeToComputeGradient_113(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTensorModeToComputeGradient();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetTensorModeToComputeStrain_114(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTensorModeToComputeStrain();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCellDerivatives_SetTensorModeToComputeGreenLagrangeStrain_115(JNIEnv* env, jobject obj)
{

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTensorModeToComputeGreenLagrangeStrain();

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCellDerivatives_GetTensorModeAsString_116(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkCellDerivatives* op = static_cast<vtkCellDerivatives*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTensorModeAsString();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCellDerivatives_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCellDerivatives::New());
}
