// java wrapper for vtkPolyDataStreamer object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPolyDataStreamer.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkStreamerBase_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPolyDataStreamer_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPolyDataStreamer",dType)) { return me; }
  if ((res= vtkStreamerBase_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataStreamer_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataStreamer_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataStreamer_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataStreamer_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataStreamer_SetNumberOfStreamDivisions_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfStreamDivisions(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataStreamer_GetNumberOfStreamDivisions_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfStreamDivisions();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataStreamer_SetColorByPiece_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetColorByPiece(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataStreamer_GetColorByPiece_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetColorByPiece();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataStreamer_ColorByPieceOn_18(JNIEnv* env, jobject obj)
{

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  op->ColorByPieceOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataStreamer_ColorByPieceOff_19(JNIEnv* env, jobject obj)
{

  vtkPolyDataStreamer* op = static_cast<vtkPolyDataStreamer*>(vtkJavaGetPointerFromObject(env, obj));
  op->ColorByPieceOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPolyDataStreamer_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPolyDataStreamer::New());
}
