// java wrapper for vtkQuantizePolyDataPoints object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkQuantizePolyDataPoints.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkCleanPolyData_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkQuantizePolyDataPoints_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkQuantizePolyDataPoints",dType)) { return me; }
  if ((res= vtkCleanPolyData_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkQuantizePolyDataPoints_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkQuantizePolyDataPoints_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkQuantizePolyDataPoints_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkQuantizePolyDataPoints_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkQuantizePolyDataPoints_SetQFactor_14(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetQFactor(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkQuantizePolyDataPoints_GetQFactorMinValue_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetQFactorMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkQuantizePolyDataPoints_GetQFactorMaxValue_16(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetQFactorMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkQuantizePolyDataPoints_GetQFactor_17(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetQFactor();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkQuantizePolyDataPoints_OperateOnPoint_18(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[3];
  double temp1[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 3, &temp1[0]);

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->OperateOnPoint(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 3, &temp1[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkQuantizePolyDataPoints_OperateOnBounds_19(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1)
{
  double temp0[6];
  double temp1[6];
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 6, &temp1[0]);

  vtkQuantizePolyDataPoints* op = static_cast<vtkQuantizePolyDataPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->OperateOnBounds(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 6, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 6, &temp1[0]);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkQuantizePolyDataPoints_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkQuantizePolyDataPoints::New());
}
