// java wrapper for vtkTableToStructuredGrid object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTableToStructuredGrid.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkStructuredGridAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTableToStructuredGrid_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTableToStructuredGrid",dType)) { return me; }
  if ((res= vtkStructuredGridAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableToStructuredGrid_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableToStructuredGrid_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetWholeExtent_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetWholeExtent_15(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkTableToStructuredGrid_GetWholeExtent_16(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetXColumn_17(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetXColumn(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTableToStructuredGrid_GetXColumn_18(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXColumn();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetXComponent_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetXComponent(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetXComponentMinValue_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXComponentMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetXComponentMaxValue_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXComponentMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetXComponent_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXComponent();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetYColumn_113(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetYColumn(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTableToStructuredGrid_GetYColumn_114(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYColumn();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetYComponent_115(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetYComponent(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetYComponentMinValue_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYComponentMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetYComponentMaxValue_117(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYComponentMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetYComponent_118(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYComponent();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetZColumn_119(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetZColumn(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTableToStructuredGrid_GetZColumn_120(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZColumn();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToStructuredGrid_SetZComponent_121(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetZComponent(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetZComponentMinValue_122(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZComponentMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetZComponentMaxValue_123(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZComponentMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToStructuredGrid_GetZComponent_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTableToStructuredGrid* op = static_cast<vtkTableToStructuredGrid*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZComponent();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTableToStructuredGrid_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTableToStructuredGrid::New());
}
