// java wrapper for vtkTransformFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTransformFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPointSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTransformFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTransformFilter",dType)) { return me; }
  if ((res= vtkPointSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFilter_GetMTime_14(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFilter_SetTransform_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractTransform * temp0;
  temp0 = static_cast<vtkAbstractTransform*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTransform(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFilter_GetTransform_16(JNIEnv* env, jobject obj)
{
  vtkAbstractTransform * temp20;

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTransform();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFilter_SetOutputPointsPrecision_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputPointsPrecision(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFilter_GetOutputPointsPrecision_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputPointsPrecision();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFilter_SetTransformAllInputVectors_19(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTransformAllInputVectors(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTransformFilter_GetTransformAllInputVectors_110(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTransformAllInputVectors();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFilter_TransformAllInputVectorsOn_111(JNIEnv* env, jobject obj)
{

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->TransformAllInputVectorsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFilter_TransformAllInputVectorsOff_112(JNIEnv* env, jobject obj)
{

  vtkTransformFilter* op = static_cast<vtkTransformFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->TransformAllInputVectorsOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTransformFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTransformFilter::New());
}
