// java wrapper for vtkVoxelContoursToSurfaceFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkVoxelContoursToSurfaceFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkVoxelContoursToSurfaceFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkVoxelContoursToSurfaceFilter",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_SetMemoryLimitInBytes_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMemoryLimitInBytes(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_GetMemoryLimitInBytes_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMemoryLimitInBytes();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_SetSpacing_16(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSpacing(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_SetSpacing_17(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSpacing(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_GetSpacing_18(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkVoxelContoursToSurfaceFilter* op = static_cast<vtkVoxelContoursToSurfaceFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSpacing();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkVoxelContoursToSurfaceFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkVoxelContoursToSurfaceFilter::New());
}
