// java wrapper for vtkWarpLens object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkWarpLens.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPointSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkWarpLens_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkWarpLens",dType)) { return me; }
  if ((res= vtkPointSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpLens_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpLens_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkWarpLens_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkWarpLens_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetKappa_14(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKappa(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetKappa_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKappa();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetCenter_16(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkWarpLens_GetCenter_17(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetPrincipalPoint_18(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPrincipalPoint(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetPrincipalPoint_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPrincipalPoint(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkWarpLens_GetPrincipalPoint_110(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPrincipalPoint();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetK1_111(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetK1(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetK1_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetK1();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetK2_113(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetK2(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetK2_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetK2();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetP1_115(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetP1(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetP1_116(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetP1();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetP2_117(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetP2(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetP2_118(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetP2();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetFormatWidth_119(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFormatWidth(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetFormatWidth_120(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFormatWidth();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetFormatHeight_121(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFormatHeight(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpLens_GetFormatHeight_122(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFormatHeight();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetImageWidth_123(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetImageWidth(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpLens_GetImageWidth_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetImageWidth();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpLens_SetImageHeight_125(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetImageHeight(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpLens_GetImageHeight_126(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetImageHeight();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpLens_FillInputPortInformation_127(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkWarpLens* op = static_cast<vtkWarpLens*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FillInputPortInformation(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkWarpLens_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkWarpLens::New());
}
