// java wrapper for vtkWarpTo object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkWarpTo.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPointSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkWarpTo_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkWarpTo",dType)) { return me; }
  if ((res= vtkPointSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpTo_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpTo_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkWarpTo_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkWarpTo_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpTo_SetScaleFactor_14(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScaleFactor(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkWarpTo_GetScaleFactor_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScaleFactor();
  return temp20;

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkWarpTo_GetPosition_16(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPosition();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpTo_SetPosition_17(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpTo_SetPosition_18(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpTo_SetAbsolute_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAbsolute(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpTo_GetAbsolute_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAbsolute();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpTo_AbsoluteOn_111(JNIEnv* env, jobject obj)
{

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  op->AbsoluteOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkWarpTo_AbsoluteOff_112(JNIEnv* env, jobject obj)
{

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  op->AbsoluteOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkWarpTo_FillInputPortInformation_113(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkWarpTo* op = static_cast<vtkWarpTo*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FillInputPortInformation(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkWarpTo_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkWarpTo::New());
}
