// java wrapper for vtkStructuredGridConnectivity object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkStructuredGridConnectivity.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAbstractGridConnectivity_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkStructuredGridConnectivity_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkStructuredGridConnectivity",dType)) { return me; }
  if ((res= vtkAbstractGridConnectivity_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetWholeExtent_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetWholeExtent_15(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetWholeExtent_16(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetDataDimension_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataDimension();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetNumberOfGrids_18(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  temp0 = id0;

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfGrids(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_RegisterGrid_19(JNIEnv* env, jobject obj,jint id0,jintArray id1,jobject id2,jobject id3,jobject id4,jobject id5,jobject id6)
{
  int   temp0;
  int temp1[6];
  vtkUnsignedCharArray * temp2;
  vtkUnsignedCharArray * temp3;
  vtkPointData * temp4;
  vtkCellData * temp5;
  vtkPoints * temp6;
  temp0 = id0;
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));
  temp2 = static_cast<vtkUnsignedCharArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkUnsignedCharArray*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id4));
  temp5 = static_cast<vtkCellData*>(vtkJavaGetPointerFromObject(env, id5));
  temp6 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id6));

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->RegisterGrid(temp0,temp1,temp2,temp3,temp4,temp5,temp6);
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetGridExtent_110(JNIEnv* env, jobject obj,jint id0,jintArray id1)
{
  int   temp0;
  int temp1[6];
  temp0 = id0;
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetGridExtent(temp0,temp1);
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetGhostedGridExtent_111(JNIEnv* env, jobject obj,jint id0,jintArray id1)
{
  int   temp0;
  int temp1[6];
  temp0 = id0;
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetGhostedGridExtent(temp0,temp1);
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetGhostedGridExtent_112(JNIEnv* env, jobject obj,jint id0,jintArray id1)
{
  int   temp0;
  int temp1[6];
  temp0 = id0;
  env->GetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetGhostedGridExtent(temp0,temp1);
  env->SetIntArrayRegion(id1, 0, 6, reinterpret_cast<jint*>(&temp1[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_ComputeNeighbors_113(JNIEnv* env, jobject obj)
{

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeNeighbors();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetNumberOfNeighbors_114(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  int   temp20;
  temp0 = id0;

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfNeighbors(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_FillGhostArrays_115(JNIEnv* env, jobject obj,jint id0,jobject id1,jobject id2)
{
  int   temp0;
  vtkUnsignedCharArray * temp1;
  vtkUnsignedCharArray * temp2;
  temp0 = id0;
  temp1 = static_cast<vtkUnsignedCharArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkUnsignedCharArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->FillGhostArrays(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_CreateGhostLayers_116(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkStructuredGridConnectivity* op = static_cast<vtkStructuredGridConnectivity*>(vtkJavaGetPointerFromObject(env, obj));
  op->CreateGhostLayers(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkStructuredGridConnectivity_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkStructuredGridConnectivity::New());
}
