// java wrapper for vtkPolyDataSilhouette object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPolyDataSilhouette.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPolyDataSilhouette_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPolyDataSilhouette",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataSilhouette_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataSilhouette_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataSilhouette_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataSilhouette_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetEnableFeatureAngle_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEnableFeatureAngle(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataSilhouette_GetEnableFeatureAngle_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEnableFeatureAngle();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetFeatureAngle_16(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFeatureAngle(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkPolyDataSilhouette_GetFeatureAngle_17(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFeatureAngle();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetBorderEdges_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBorderEdges(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataSilhouette_GetBorderEdges_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBorderEdges();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_BorderEdgesOn_110(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->BorderEdgesOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_BorderEdgesOff_111(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->BorderEdgesOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetPieceInvariant_112(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPieceInvariant(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataSilhouette_GetPieceInvariant_113(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPieceInvariant();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_PieceInvariantOn_114(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->PieceInvariantOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_PieceInvariantOff_115(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->PieceInvariantOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetDirection_116(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirection(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataSilhouette_GetDirection_117(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDirection();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetDirectionToSpecifiedVector_118(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirectionToSpecifiedVector();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetDirectionToSpecifiedOrigin_119(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirectionToSpecifiedOrigin();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetDirectionToCameraVector_120(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirectionToCameraVector();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetDirectionToCameraOrigin_121(JNIEnv* env, jobject obj)
{

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirectionToCameraOrigin();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetCamera_122(JNIEnv* env, jobject obj,jobject id0)
{
  vtkCamera * temp0;
  temp0 = static_cast<vtkCamera*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCamera(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataSilhouette_GetCamera_123(JNIEnv* env, jobject obj)
{
  vtkCamera * temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCamera();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetProp3D_124(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProp3D * temp0;
  temp0 = static_cast<vtkProp3D*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetProp3D(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataSilhouette_GetProp3D_125(JNIEnv* env, jobject obj)
{
  vtkProp3D * temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetProp3D();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetVector_126(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVector(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetVector_127(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVector(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkPolyDataSilhouette_GetVector_128(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVector();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetOrigin_129(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOrigin(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataSilhouette_SetOrigin_130(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOrigin(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkPolyDataSilhouette_GetOrigin_131(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOrigin();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataSilhouette_GetMTime_132(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkPolyDataSilhouette* op = static_cast<vtkPolyDataSilhouette*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPolyDataSilhouette_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPolyDataSilhouette::New());
}
