// java wrapper for vtkTemporalDataSetCache object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTemporalDataSetCache.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTemporalDataSetCache_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTemporalDataSetCache",dType)) { return me; }
  if ((res= vtkAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTemporalDataSetCache_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTemporalDataSetCache_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTemporalDataSetCache_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTemporalDataSetCache_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_SetCacheSize_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCacheSize(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTemporalDataSetCache_GetCacheSize_15(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCacheSize();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_SetCacheInMemkind_16(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCacheInMemkind(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTemporalDataSetCache_GetCacheInMemkind_17(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCacheInMemkind();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_CacheInMemkindOn_18(JNIEnv* env, jobject obj)
{

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->CacheInMemkindOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_CacheInMemkindOff_19(JNIEnv* env, jobject obj)
{

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->CacheInMemkindOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_SetIsASource_110(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIsASource(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTemporalDataSetCache_GetIsASource_111(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetIsASource();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_IsASourceOn_112(JNIEnv* env, jobject obj)
{

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->IsASourceOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDataSetCache_IsASourceOff_113(JNIEnv* env, jobject obj)
{

  vtkTemporalDataSetCache* op = static_cast<vtkTemporalDataSetCache*>(vtkJavaGetPointerFromObject(env, obj));
  op->IsASourceOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTemporalDataSetCache_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTemporalDataSetCache::New());
}
