// java wrapper for vtkHausdorffDistancePointSetFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHausdorffDistancePointSetFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPointSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkHausdorffDistancePointSetFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkHausdorffDistancePointSetFilter",dType)) { return me; }
  if ((res= vtkPointSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_GetRelativeDistance_14(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRelativeDistance();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 2);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_GetHausdorffDistance_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHausdorffDistance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_SetTargetDistanceMethod_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTargetDistanceMethod(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_GetTargetDistanceMethod_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTargetDistanceMethod();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_SetTargetDistanceMethodToPointToPoint_18(JNIEnv* env, jobject obj)
{

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTargetDistanceMethodToPointToPoint();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_SetTargetDistanceMethodToPointToCell_19(JNIEnv* env, jobject obj)
{

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTargetDistanceMethodToPointToCell();

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_GetTargetDistanceMethodAsString_110(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkHausdorffDistancePointSetFilter* op = static_cast<vtkHausdorffDistancePointSetFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTargetDistanceMethodAsString();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkHausdorffDistancePointSetFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkHausdorffDistancePointSetFilter::New());
}
