// java wrapper for vtkTrimmedExtrusionFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTrimmedExtrusionFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTrimmedExtrusionFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTrimmedExtrusionFilter",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetExtrusionDirection_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtrusionDirection(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetExtrusionDirection_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtrusionDirection(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetExtrusionDirection_16(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtrusionDirection();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetTrimSurfaceData_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPolyData * temp0;
  temp0 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTrimSurfaceData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetTrimSurfaceConnection_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAlgorithmOutput * temp0;
  temp0 = static_cast<vtkAlgorithmOutput*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTrimSurfaceConnection(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetTrimSurface_19(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTrimSurface();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetTrimSurface_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformationVector * temp0;
  vtkPolyData * temp20;
  temp0 = static_cast<vtkInformationVector*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTrimSurface(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetCapping_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCapping(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetCapping_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCapping();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_CappingOn_113(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->CappingOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_CappingOff_114(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->CappingOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetExtrusionStrategy_115(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtrusionStrategy(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetExtrusionStrategy_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExtrusionStrategy();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetExtrusionStrategyToBoundaryEdges_117(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtrusionStrategyToBoundaryEdges();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetExtrusionStrategyToAllEdges_118(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExtrusionStrategyToAllEdges();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetCappingStrategy_119(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCappingStrategy(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetCappingStrategy_120(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCappingStrategy();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetCappingStrategyToIntersection_121(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCappingStrategyToIntersection();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetCappingStrategyToMinimumDistance_122(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCappingStrategyToMinimumDistance();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetCappingStrategyToMaximumDistance_123(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCappingStrategyToMaximumDistance();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetCappingStrategyToAverageDistance_124(JNIEnv* env, jobject obj)
{

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCappingStrategyToAverageDistance();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_SetLocator_125(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractCellLocator * temp0;
  temp0 = static_cast<vtkAbstractCellLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLocator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTrimmedExtrusionFilter_GetLocator_126(JNIEnv* env, jobject obj)
{
  vtkAbstractCellLocator * temp20;

  vtkTrimmedExtrusionFilter* op = static_cast<vtkTrimmedExtrusionFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLocator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTrimmedExtrusionFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTrimmedExtrusionFilter::New());
}
