// java wrapper for vtkEllipsoidalGaussianKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkEllipsoidalGaussianKernel.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkGeneralizedKernel_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkEllipsoidalGaussianKernel_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkEllipsoidalGaussianKernel",dType)) { return me; }
  if ((res= vtkGeneralizedKernel_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_Initialize_14(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkAbstractPointLocator * temp0;
  vtkDataSet * temp1;
  vtkPointData * temp2;
  temp0 = static_cast<vtkAbstractPointLocator*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id2));

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize(temp0,temp1,temp2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_ComputeWeights_15(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jobject id2,jobject id3)
{
  double temp0[3];
  vtkIdList * temp1;
  vtkDoubleArray * temp2;
  vtkDoubleArray * temp3;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDoubleArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkDoubleArray*>(vtkJavaGetPointerFromObject(env, id3));

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ComputeWeights(temp0,temp1,temp2,temp3);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetUseNormals_16(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetUseNormals(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetUseNormals_17(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUseNormals();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseNormalsOn_18(JNIEnv* env, jobject obj)
{

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseNormalsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseNormalsOff_19(JNIEnv* env, jobject obj)
{

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseNormalsOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetNormalsArrayName_110(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNormalsArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetNormalsArrayName_111(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNormalsArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetUseScalars_112(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetUseScalars(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetUseScalars_113(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUseScalars();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseScalarsOn_114(JNIEnv* env, jobject obj)
{

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseScalarsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseScalarsOff_115(JNIEnv* env, jobject obj)
{

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseScalarsOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetScalarsArrayName_116(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalarsArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScalarsArrayName_117(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalarsArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetScaleFactor_118(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScaleFactor(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScaleFactorMinValue_119(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScaleFactorMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScaleFactorMaxValue_120(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScaleFactorMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScaleFactor_121(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScaleFactor();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetSharpness_122(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSharpness(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetSharpnessMinValue_123(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSharpnessMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetSharpnessMaxValue_124(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSharpnessMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetSharpness_125(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSharpness();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetEccentricity_126(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEccentricity(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetEccentricityMinValue_127(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEccentricityMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetEccentricityMaxValue_128(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEccentricityMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetEccentricity_129(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEccentricity();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_ComputeWeights_130(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  double temp0[3];
  vtkIdList * temp1;
  vtkDoubleArray * temp2;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDoubleArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkEllipsoidalGaussianKernel* op = static_cast<vtkEllipsoidalGaussianKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ComputeWeights(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkEllipsoidalGaussianKernel::New());
}
