// java wrapper for vtkExtractEnclosedPoints object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExtractEnclosedPoints.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPointCloudFilter_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExtractEnclosedPoints_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExtractEnclosedPoints",dType)) { return me; }
  if ((res= vtkPointCloudFilter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractEnclosedPoints_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractEnclosedPoints_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetSurfaceData_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPolyData * temp0;
  temp0 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSurfaceData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetSurfaceConnection_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAlgorithmOutput * temp0;
  temp0 = static_cast<vtkAlgorithmOutput*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSurfaceConnection(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetSurface_16(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSurface();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetSurface_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkInformationVector * temp0;
  vtkPolyData * temp20;
  temp0 = static_cast<vtkInformationVector*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSurface(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetCheckSurface_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCheckSurface(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_CheckSurfaceOn_19(JNIEnv* env, jobject obj)
{

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->CheckSurfaceOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_CheckSurfaceOff_110(JNIEnv* env, jobject obj)
{

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->CheckSurfaceOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetCheckSurface_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCheckSurface();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExtractEnclosedPoints_SetTolerance_112(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTolerance(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetToleranceMinValue_113(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetToleranceMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetToleranceMaxValue_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetToleranceMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkExtractEnclosedPoints_GetTolerance_115(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkExtractEnclosedPoints* op = static_cast<vtkExtractEnclosedPoints*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTolerance();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkExtractEnclosedPoints_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkExtractEnclosedPoints::New());
}
