// java wrapper for vtkInterpolationKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkInterpolationKernel.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkInterpolationKernel_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkInterpolationKernel",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInterpolationKernel_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkInterpolationKernel_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInterpolationKernel_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInterpolationKernel_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInterpolationKernel_Initialize_14(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkAbstractPointLocator * temp0;
  vtkDataSet * temp1;
  vtkPointData * temp2;
  temp0 = static_cast<vtkAbstractPointLocator*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkPointData*>(vtkJavaGetPointerFromObject(env, id2));

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInterpolationKernel_SetRequiresInitialization_15(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRequiresInitialization(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkInterpolationKernel_GetRequiresInitialization_16(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRequiresInitialization();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInterpolationKernel_RequiresInitializationOn_17(JNIEnv* env, jobject obj)
{

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->RequiresInitializationOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkInterpolationKernel_RequiresInitializationOff_18(JNIEnv* env, jobject obj)
{

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  op->RequiresInitializationOff();

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInterpolationKernel_ComputeBasis_19(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jlong id2)
{
  double temp0[3];
  vtkIdList * temp1;
  long long   temp2;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = id2;

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ComputeBasis(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkInterpolationKernel_ComputeWeights_110(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  double temp0[3];
  vtkIdList * temp1;
  vtkDoubleArray * temp2;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDoubleArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkInterpolationKernel* op = static_cast<vtkInterpolationKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ComputeWeights(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}
