// java wrapper for vtkPointOccupancyFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPointOccupancyFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPointOccupancyFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPointOccupancyFilter",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPointOccupancyFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPointOccupancyFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointOccupancyFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPointOccupancyFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointOccupancyFilter_SetSampleDimensions_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2)
{
  int   temp0;
  int   temp1;
  int   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSampleDimensions(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointOccupancyFilter_SetSampleDimensions_15(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[3];
  env->GetIntArrayRegion(id0, 0, 3, reinterpret_cast<jint*>(&temp0[0]));

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSampleDimensions(temp0);
  env->SetIntArrayRegion(id0, 0, 3, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkPointOccupancyFilter_GetSampleDimensions_16(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSampleDimensions();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointOccupancyFilter_SetModelBounds_17(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3,jdouble id4,jdouble id5)
{
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp3;
  double   temp4;
  double   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetModelBounds(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointOccupancyFilter_SetModelBounds_18(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[6];
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetModelBounds(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkPointOccupancyFilter_GetModelBounds_19(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetModelBounds();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointOccupancyFilter_SetEmptyValue_110(JNIEnv* env, jobject obj,jbyte id0)
{
   unsigned char   temp0;
  temp0 = id0;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEmptyValue(temp0);

}

extern "C" JNIEXPORT jbyte  JNICALL Java_vtk_vtkPointOccupancyFilter_GetEmptyValue_111(JNIEnv* env, jobject obj)
{
   unsigned char   temp20;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEmptyValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPointOccupancyFilter_SetOccupiedValue_112(JNIEnv* env, jobject obj,jbyte id0)
{
   unsigned char   temp0;
  temp0 = id0;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOccupiedValue(temp0);

}

extern "C" JNIEXPORT jbyte  JNICALL Java_vtk_vtkPointOccupancyFilter_GetOccupiedValue_113(JNIEnv* env, jobject obj)
{
   unsigned char   temp20;

  vtkPointOccupancyFilter* op = static_cast<vtkPointOccupancyFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOccupiedValue();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPointOccupancyFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPointOccupancyFilter::New());
}
