// java wrapper for vtkSPHInterpolator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSPHInterpolator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkSPHInterpolator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkSPHInterpolator",dType)) { return me; }
  if ((res= vtkDataSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSPHInterpolator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSPHInterpolator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetSourceData_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataObject * temp0;
  temp0 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSourceData(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSPHInterpolator_GetSource_15(JNIEnv* env, jobject obj)
{
  vtkDataObject * temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSource();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetSourceConnection_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAlgorithmOutput * temp0;
  temp0 = static_cast<vtkAlgorithmOutput*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSourceConnection(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetLocator_17(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractPointLocator * temp0;
  temp0 = static_cast<vtkAbstractPointLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLocator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSPHInterpolator_GetLocator_18(JNIEnv* env, jobject obj)
{
  vtkAbstractPointLocator * temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLocator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetKernel_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkSPHKernel * temp0;
  temp0 = static_cast<vtkSPHKernel*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSPHInterpolator_GetKernel_110(JNIEnv* env, jobject obj)
{
  vtkSPHKernel * temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernel();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetCutoffArrayName_111(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCutoffArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetCutoffArrayName_112(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCutoffArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetDensityArrayName_113(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDensityArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetDensityArrayName_114(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDensityArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetMassArrayName_115(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMassArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetMassArrayName_116(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMassArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_AddExcludedArray_117(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddExcludedArray(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_ClearExcludedArrays_118(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearExcludedArrays();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetNumberOfExcludedArrays_119(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfExcludedArrays();
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetExcludedArray_120(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  const char * temp20;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetExcludedArray(temp0);
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_AddDerivativeArray_121(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddDerivativeArray(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_ClearDerivativeArrays_122(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearDerivativeArrays();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetNumberOfDerivativeArrays_123(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfDerivativeArrays();
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetDerivativeArray_124(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  const char * temp20;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDerivativeArray(temp0);
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetNullPointsStrategy_125(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNullPointsStrategy(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetNullPointsStrategy_126(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNullPointsStrategy();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetNullPointsStrategyToMaskPoints_127(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNullPointsStrategyToMaskPoints();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetNullPointsStrategyToNullValue_128(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNullPointsStrategyToNullValue();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetValidPointsMaskArrayName_129(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetValidPointsMaskArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetValidPointsMaskArrayName_130(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValidPointsMaskArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetNullValue_131(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNullValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSPHInterpolator_GetNullValue_132(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNullValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetComputeShepardSum_133(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetComputeShepardSum(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_ComputeShepardSumOn_134(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeShepardSumOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_ComputeShepardSumOff_135(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeShepardSumOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetComputeShepardSum_136(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetComputeShepardSum();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetShepardSumArrayName_137(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetShepardSumArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkSPHInterpolator_GetShepardSumArrayName_138(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetShepardSumArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetPromoteOutputArrays_139(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPromoteOutputArrays(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PromoteOutputArraysOn_140(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PromoteOutputArraysOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PromoteOutputArraysOff_141(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PromoteOutputArraysOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetPromoteOutputArrays_142(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPromoteOutputArrays();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetPassPointArrays_143(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPassPointArrays(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PassPointArraysOn_144(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PassPointArraysOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PassPointArraysOff_145(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PassPointArraysOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetPassPointArrays_146(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPassPointArrays();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetPassCellArrays_147(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPassCellArrays(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PassCellArraysOn_148(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PassCellArraysOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PassCellArraysOff_149(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PassCellArraysOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetPassCellArrays_150(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPassCellArrays();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetPassFieldArrays_151(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPassFieldArrays(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PassFieldArraysOn_152(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PassFieldArraysOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_PassFieldArraysOff_153(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->PassFieldArraysOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetPassFieldArrays_154(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPassFieldArrays();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_SetShepardNormalization_155(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetShepardNormalization(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_ShepardNormalizationOn_156(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShepardNormalizationOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSPHInterpolator_ShepardNormalizationOff_157(JNIEnv* env, jobject obj)
{

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShepardNormalizationOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSPHInterpolator_GetShepardNormalization_158(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetShepardNormalization();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSPHInterpolator_GetMTime_159(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkSPHInterpolator* op = static_cast<vtkSPHInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkSPHInterpolator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkSPHInterpolator::New());
}
