// java wrapper for vtkUnsignedDistance object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUnsignedDistance.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkUnsignedDistance_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkUnsignedDistance",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedDistance_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedDistance_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkUnsignedDistance_GetDimensions_14(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDimensions();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetDimensions_15(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2)
{
  int   temp0;
  int   temp1;
  int   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDimensions(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetDimensions_16(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[3];
  env->GetIntArrayRegion(id0, 0, 3, reinterpret_cast<jint*>(&temp0[0]));

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDimensions(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetBounds_17(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3,jdouble id4,jdouble id5)
{
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp3;
  double   temp4;
  double   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBounds(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetBounds_18(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[6];
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBounds(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkUnsignedDistance_GetBounds_19(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBounds();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetAdjustBounds_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAdjustBounds(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustBounds_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAdjustBounds();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_AdjustBoundsOn_112(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->AdjustBoundsOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_AdjustBoundsOff_113(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->AdjustBoundsOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetAdjustDistance_114(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAdjustDistance(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustDistanceMinValue_115(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAdjustDistanceMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustDistanceMaxValue_116(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAdjustDistanceMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustDistance_117(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAdjustDistance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetRadius_118(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRadius(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetRadiusMinValue_119(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadiusMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetRadiusMaxValue_120(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadiusMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetRadius_121(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadius();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetLocator_122(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractPointLocator * temp0;
  temp0 = static_cast<vtkAbstractPointLocator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLocator(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedDistance_GetLocator_123(JNIEnv* env, jobject obj)
{
  vtkAbstractPointLocator * temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLocator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetCapping_124(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCapping(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_GetCapping_125(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCapping();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_CappingOn_126(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->CappingOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_CappingOff_127(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->CappingOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetCapValue_128(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCapValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetCapValue_129(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCapValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetOutputScalarType_130(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarType(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_GetOutputScalarType_131(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputScalarType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetOutputScalarTypeToFloat_132(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToFloat();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetOutputScalarTypeToDouble_133(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToDouble();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_StartAppend_134(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->StartAppend();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_Append_135(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPolyData * temp0;
  temp0 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->Append(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_EndAppend_136(JNIEnv* env, jobject obj)
{

  vtkUnsignedDistance* op = static_cast<vtkUnsignedDistance*>(vtkJavaGetPointerFromObject(env, obj));
  op->EndAppend();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkUnsignedDistance_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkUnsignedDistance::New());
}
