// java wrapper for vtkVoronoiKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkVoronoiKernel.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkInterpolationKernel_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkVoronoiKernel_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkVoronoiKernel",dType)) { return me; }
  if ((res= vtkInterpolationKernel_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoronoiKernel_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoronoiKernel* op = static_cast<vtkVoronoiKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoronoiKernel_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoronoiKernel* op = static_cast<vtkVoronoiKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkVoronoiKernel_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoronoiKernel* op = static_cast<vtkVoronoiKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkVoronoiKernel_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkVoronoiKernel* op = static_cast<vtkVoronoiKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkVoronoiKernel_ComputeBasis_14(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jlong id2)
{
  double temp0[3];
  vtkIdList * temp1;
  long long   temp2;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = id2;

  vtkVoronoiKernel* op = static_cast<vtkVoronoiKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ComputeBasis(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkVoronoiKernel_ComputeWeights_15(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  double temp0[3];
  vtkIdList * temp1;
  vtkDoubleArray * temp2;
  long long   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkIdList*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDoubleArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkVoronoiKernel* op = static_cast<vtkVoronoiKernel*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ComputeWeights(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkVoronoiKernel_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkVoronoiKernel::New());
}
