// java wrapper for vtkProgrammableFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkProgrammableFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPassInputTypeAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkProgrammableFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkProgrammableFilter",dType)) { return me; }
  if ((res= vtkPassInputTypeAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkProgrammableFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkProgrammableFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProgrammableFilter_SetExecuteMethod_14(JNIEnv* env, jobject obj,jobject id0, jbyteArray id1, jint len1)
{
  vtkJavaVoidFuncArg* fstruct = new vtkJavaVoidFuncArg;
  env->GetJavaVM(&(fstruct->vm));
  fstruct->uobj = env->NewGlobalRef(id0);
  char* handler = vtkJavaUTF8ToChars(env ,id1, len1);
  fstruct->mid = env->GetMethodID(env->GetObjectClass(id0), handler, "()V");
  delete[] handler;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExecuteMethod(vtkJavaVoidFunc,fstruct);
  op->SetExecuteMethodArgDelete(vtkJavaVoidFuncArgDelete);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetPolyDataInput_15(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyDataInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetStructuredPointsInput_16(JNIEnv* env, jobject obj)
{
  vtkStructuredPoints * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredPointsInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetStructuredGridInput_17(JNIEnv* env, jobject obj)
{
  vtkStructuredGrid * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredGridInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetUnstructuredGridInput_18(JNIEnv* env, jobject obj)
{
  vtkUnstructuredGrid * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUnstructuredGridInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetRectilinearGridInput_19(JNIEnv* env, jobject obj)
{
  vtkRectilinearGrid * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRectilinearGridInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetGraphInput_110(JNIEnv* env, jobject obj)
{
  vtkGraph * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGraphInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetMoleculeInput_111(JNIEnv* env, jobject obj)
{
  vtkMolecule * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMoleculeInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetTableInput_112(JNIEnv* env, jobject obj)
{
  vtkTable * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTableInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableFilter_GetHyperTreeGridInput_113(JNIEnv* env, jobject obj)
{
  vtkHyperTreeGrid * temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHyperTreeGridInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProgrammableFilter_SetCopyArrays_114(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCopyArrays(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkProgrammableFilter_GetCopyArrays_115(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCopyArrays();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProgrammableFilter_CopyArraysOn_116(JNIEnv* env, jobject obj)
{

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyArraysOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProgrammableFilter_CopyArraysOff_117(JNIEnv* env, jobject obj)
{

  vtkProgrammableFilter* op = static_cast<vtkProgrammableFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyArraysOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkProgrammableFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkProgrammableFilter::New());
}
