// java wrapper for vtkCapsuleSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCapsuleSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCapsuleSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCapsuleSource",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCapsuleSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCapsuleSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetRadius_14(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRadius(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCapsuleSource_GetRadiusMinValue_15(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadiusMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCapsuleSource_GetRadiusMaxValue_16(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadiusMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCapsuleSource_GetRadius_17(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadius();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetCenter_18(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetCenter_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkCapsuleSource_GetCenter_110(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetCylinderLength_111(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCylinderLength(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCapsuleSource_GetCylinderLengthMinValue_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCylinderLengthMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCapsuleSource_GetCylinderLengthMaxValue_113(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCylinderLengthMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkCapsuleSource_GetCylinderLength_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCylinderLength();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetThetaResolution_115(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetThetaResolution(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetThetaResolutionMinValue_116(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetThetaResolutionMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetThetaResolutionMaxValue_117(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetThetaResolutionMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetThetaResolution_118(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetThetaResolution();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetPhiResolution_119(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPhiResolution(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetPhiResolutionMinValue_120(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPhiResolutionMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetPhiResolutionMaxValue_121(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPhiResolutionMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetPhiResolution_122(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPhiResolution();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetLatLongTessellation_123(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLatLongTessellation(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetLatLongTessellation_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLatLongTessellation();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_LatLongTessellationOn_125(JNIEnv* env, jobject obj)
{

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->LatLongTessellationOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_LatLongTessellationOff_126(JNIEnv* env, jobject obj)
{

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->LatLongTessellationOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCapsuleSource_SetOutputPointsPrecision_127(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputPointsPrecision(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCapsuleSource_GetOutputPointsPrecision_128(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkCapsuleSource* op = static_cast<vtkCapsuleSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputPointsPrecision();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCapsuleSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCapsuleSource::New());
}
