// java wrapper for vtkGraphToPolyData object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkGraphToPolyData.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkGraphToPolyData_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkGraphToPolyData",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGraphToPolyData_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGraphToPolyData_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphToPolyData_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphToPolyData_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphToPolyData_SetEdgeGlyphOutput_14(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEdgeGlyphOutput(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkGraphToPolyData_GetEdgeGlyphOutput_15(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdgeGlyphOutput();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphToPolyData_EdgeGlyphOutputOn_16(JNIEnv* env, jobject obj)
{

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->EdgeGlyphOutputOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphToPolyData_EdgeGlyphOutputOff_17(JNIEnv* env, jobject obj)
{

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->EdgeGlyphOutputOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphToPolyData_SetEdgeGlyphPosition_18(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEdgeGlyphPosition(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGraphToPolyData_GetEdgeGlyphPosition_19(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkGraphToPolyData* op = static_cast<vtkGraphToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdgeGlyphPosition();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkGraphToPolyData_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkGraphToPolyData::New());
}
