// java wrapper for vtkProgrammableSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkProgrammableSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataObjectAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkProgrammableSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkProgrammableSource",dType)) { return me; }
  if ((res= vtkDataObjectAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkProgrammableSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkProgrammableSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProgrammableSource_SetExecuteMethod_14(JNIEnv* env, jobject obj,jobject id0, jbyteArray id1, jint len1)
{
  vtkJavaVoidFuncArg* fstruct = new vtkJavaVoidFuncArg;
  env->GetJavaVM(&(fstruct->vm));
  fstruct->uobj = env->NewGlobalRef(id0);
  char* handler = vtkJavaUTF8ToChars(env ,id1, len1);
  fstruct->mid = env->GetMethodID(env->GetObjectClass(id0), handler, "()V");
  delete[] handler;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetExecuteMethod(vtkJavaVoidFunc,fstruct);
  op->SetExecuteMethodArgDelete(vtkJavaVoidFuncArgDelete);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetPolyDataOutput_15(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyDataOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetStructuredPointsOutput_16(JNIEnv* env, jobject obj)
{
  vtkStructuredPoints * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredPointsOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetStructuredGridOutput_17(JNIEnv* env, jobject obj)
{
  vtkStructuredGrid * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetUnstructuredGridOutput_18(JNIEnv* env, jobject obj)
{
  vtkUnstructuredGrid * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUnstructuredGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetRectilinearGridOutput_19(JNIEnv* env, jobject obj)
{
  vtkRectilinearGrid * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRectilinearGridOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetGraphOutput_110(JNIEnv* env, jobject obj)
{
  vtkGraph * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGraphOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetMoleculeOutput_111(JNIEnv* env, jobject obj)
{
  vtkMolecule * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMoleculeOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProgrammableSource_GetTableOutput_112(JNIEnv* env, jobject obj)
{
  vtkTable * temp20;

  vtkProgrammableSource* op = static_cast<vtkProgrammableSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTableOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkProgrammableSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkProgrammableSource::New());
}
