// java wrapper for vtkKMeansDistanceFunctor object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkKMeansDistanceFunctor.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkKMeansDistanceFunctor_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkKMeansDistanceFunctor",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansDistanceFunctor_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansDistanceFunctor_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansDistanceFunctor_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansDistanceFunctor_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansDistanceFunctor_GetEmptyTuple_14(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  vtkVariantArray * temp20;
  temp0 = id0;

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEmptyTuple(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansDistanceFunctor_PairwiseUpdate_15(JNIEnv* env, jobject obj,jobject id0,jlong id1,jobject id2,jlong id3,jlong id4)
{
  vtkTable * temp0;
  long long   temp1;
  vtkVariantArray * temp2;
  long long   temp3;
  long long   temp4;
  temp0 = static_cast<vtkTable*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;
  temp2 = static_cast<vtkVariantArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = id3;
  temp4 = id4;

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  op->PairwiseUpdate(temp0,temp1,temp2,temp3,temp4);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansDistanceFunctor_PerturbElement_16(JNIEnv* env, jobject obj,jobject id0,jobject id1,jlong id2,jlong id3,jlong id4,jdouble id5)
{
  vtkTable * temp0;
  vtkTable * temp1;
  long long   temp2;
  long long   temp3;
  long long   temp4;
  double   temp5;
  temp0 = static_cast<vtkTable*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkTable*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  op->PerturbElement(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansDistanceFunctor_CreateCoordinateArray_17(JNIEnv* env, jobject obj)
{
  vtkAbstractArray * temp20;

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CreateCoordinateArray();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansDistanceFunctor_GetDataType_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkKMeansDistanceFunctor* op = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataType();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkKMeansDistanceFunctor_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkKMeansDistanceFunctor::New());
}
