// java wrapper for vtkKMeansStatistics object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkKMeansStatistics.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkStatisticsAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkKMeansStatistics_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkKMeansStatistics",dType)) { return me; }
  if ((res= vtkStatisticsAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansStatistics_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansStatistics_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansStatistics_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansStatistics_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_SetDistanceFunctor_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkKMeansDistanceFunctor * temp0;
  temp0 = static_cast<vtkKMeansDistanceFunctor*>(vtkJavaGetPointerFromObject(env, id0));

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDistanceFunctor(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkKMeansStatistics_GetDistanceFunctor_15(JNIEnv* env, jobject obj)
{
  vtkKMeansDistanceFunctor * temp20;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDistanceFunctor();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_SetDefaultNumberOfClusters_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDefaultNumberOfClusters(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansStatistics_GetDefaultNumberOfClusters_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDefaultNumberOfClusters();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_SetKValuesArrayName_18(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKValuesArrayName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkKMeansStatistics_GetKValuesArrayName_19(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKValuesArrayName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_SetMaxNumIterations_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMaxNumIterations(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkKMeansStatistics_GetMaxNumIterations_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaxNumIterations();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_SetTolerance_112(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTolerance(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkKMeansStatistics_GetTolerance_113(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTolerance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_Aggregate_114(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkDataObjectCollection * temp0;
  vtkMultiBlockDataSet * temp1;
  temp0 = static_cast<vtkDataObjectCollection*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, id1));

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->Aggregate(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkKMeansStatistics_SetGhostsToSkip_115(JNIEnv* env, jobject obj,jbyte id0)
{
   unsigned char   temp0;
  temp0 = id0;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetGhostsToSkip(temp0);

}

extern "C" JNIEXPORT jbyte  JNICALL Java_vtk_vtkKMeansStatistics_GetGhostsToSkip_116(JNIEnv* env, jobject obj)
{
   unsigned char   temp20;

  vtkKMeansStatistics* op = static_cast<vtkKMeansStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGhostsToSkip();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkKMeansStatistics_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkKMeansStatistics::New());
}
