// java wrapper for vtkMultiCorrelativeStatistics object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMultiCorrelativeStatistics.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkStatisticsAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMultiCorrelativeStatistics_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMultiCorrelativeStatistics",dType)) { return me; }
  if ((res= vtkStatisticsAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_Aggregate_14(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkDataObjectCollection * temp0;
  vtkMultiBlockDataSet * temp1;
  temp0 = static_cast<vtkDataObjectCollection*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkMultiBlockDataSet*>(vtkJavaGetPointerFromObject(env, id1));

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->Aggregate(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_SetMedianAbsoluteDeviation_15(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMedianAbsoluteDeviation(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_GetMedianAbsoluteDeviation_16(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMedianAbsoluteDeviation();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_MedianAbsoluteDeviationOn_17(JNIEnv* env, jobject obj)
{

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->MedianAbsoluteDeviationOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_MedianAbsoluteDeviationOff_18(JNIEnv* env, jobject obj)
{

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->MedianAbsoluteDeviationOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_SetGhostsToSkip_19(JNIEnv* env, jobject obj,jbyte id0)
{
   unsigned char   temp0;
  temp0 = id0;

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetGhostsToSkip(temp0);

}

extern "C" JNIEXPORT jbyte  JNICALL Java_vtk_vtkMultiCorrelativeStatistics_GetGhostsToSkip_110(JNIEnv* env, jobject obj)
{
   unsigned char   temp20;

  vtkMultiCorrelativeStatistics* op = static_cast<vtkMultiCorrelativeStatistics*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGhostsToSkip();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMultiCorrelativeStatistics_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMultiCorrelativeStatistics::New());
}
