// java wrapper for vtkTextureMapToSphere object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTextureMapToSphere.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSetAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTextureMapToSphere_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTextureMapToSphere",dType)) { return me; }
  if ((res= vtkDataSetAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextureMapToSphere_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextureMapToSphere_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTextureMapToSphere_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTextureMapToSphere_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_SetCenter_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_SetCenter_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkTextureMapToSphere_GetCenter_16(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_SetAutomaticSphereGeneration_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAutomaticSphereGeneration(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextureMapToSphere_GetAutomaticSphereGeneration_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAutomaticSphereGeneration();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_AutomaticSphereGenerationOn_19(JNIEnv* env, jobject obj)
{

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->AutomaticSphereGenerationOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_AutomaticSphereGenerationOff_110(JNIEnv* env, jobject obj)
{

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->AutomaticSphereGenerationOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_SetPreventSeam_111(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPreventSeam(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextureMapToSphere_GetPreventSeam_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPreventSeam();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_PreventSeamOn_113(JNIEnv* env, jobject obj)
{

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->PreventSeamOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_PreventSeamOff_114(JNIEnv* env, jobject obj)
{

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->PreventSeamOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextureMapToSphere_ComputeCenter_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataSet * temp0;
  temp0 = static_cast<vtkDataSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextureMapToSphere* op = static_cast<vtkTextureMapToSphere*>(vtkJavaGetPointerFromObject(env, obj));
  op->ComputeCenter(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTextureMapToSphere_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTextureMapToSphere::New());
}
