// java wrapper for vtkCMLMoleculeReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCMLMoleculeReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkMoleculeAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCMLMoleculeReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCMLMoleculeReader",dType)) { return me; }
  if ((res= vtkMoleculeAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCMLMoleculeReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCMLMoleculeReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCMLMoleculeReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCMLMoleculeReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCMLMoleculeReader_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkMolecule * temp20;

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCMLMoleculeReader_SetOutput_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkMolecule * temp0;
  temp0 = static_cast<vtkMolecule*>(vtkJavaGetPointerFromObject(env, id0));

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutput(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCMLMoleculeReader_SetFileName_16(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkCMLMoleculeReader_GetFileName_17(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkCMLMoleculeReader* op = static_cast<vtkCMLMoleculeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCMLMoleculeReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCMLMoleculeReader::New());
}
