// java wrapper for vtkJavaScriptDataWriter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkJavaScriptDataWriter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkWriter_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkJavaScriptDataWriter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkJavaScriptDataWriter",dType)) { return me; }
  if ((res= vtkWriter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkJavaScriptDataWriter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkJavaScriptDataWriter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkJavaScriptDataWriter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkJavaScriptDataWriter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkJavaScriptDataWriter_SetVariableName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVariableName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkJavaScriptDataWriter_GetVariableName_15(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVariableName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkJavaScriptDataWriter_SetFileName_16(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkJavaScriptDataWriter_GetFileName_17(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkJavaScriptDataWriter_SetIncludeFieldNames_18(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIncludeFieldNames(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkJavaScriptDataWriter_GetIncludeFieldNames_19(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkJavaScriptDataWriter* op = static_cast<vtkJavaScriptDataWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetIncludeFieldNames();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkJavaScriptDataWriter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkJavaScriptDataWriter::New());
}
