// java wrapper for vtkUTF16TextCodec object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUTF16TextCodec.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkTextCodec_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkUTF16TextCodec_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkUTF16TextCodec",dType)) { return me; }
  if ((res= vtkTextCodec_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUTF16TextCodec_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUTF16TextCodec_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUTF16TextCodec_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUTF16TextCodec_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkUTF16TextCodec_Name_14(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Name();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkUTF16TextCodec_CanHandle_15(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  bool   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->CanHandle(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUTF16TextCodec_SetBigEndian_16(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkUTF16TextCodec* op = static_cast<vtkUTF16TextCodec*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBigEndian(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkUTF16TextCodec_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkUTF16TextCodec::New());
}
