// java wrapper for vtkExporter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkExporter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkExporter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkExporter",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExporter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkExporter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExporter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExporter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_Write_14(JNIEnv* env, jobject obj)
{

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->Write();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_Update_15(JNIEnv* env, jobject obj)
{

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->Update();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_SetRenderWindow_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkRenderWindow * temp0;
  temp0 = static_cast<vtkRenderWindow*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRenderWindow(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExporter_GetRenderWindow_17(JNIEnv* env, jobject obj)
{
  vtkRenderWindow * temp20;

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRenderWindow();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_SetActiveRenderer_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkRenderer * temp0;
  temp0 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetActiveRenderer(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExporter_GetActiveRenderer_19(JNIEnv* env, jobject obj)
{
  vtkRenderer * temp20;

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetActiveRenderer();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_SetInput_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkRenderWindow * temp0;
  temp0 = static_cast<vtkRenderWindow*>(vtkJavaGetPointerFromObject(env, id0));

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInput(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExporter_GetInput_111(JNIEnv* env, jobject obj)
{
  vtkRenderWindow * temp20;

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_SetStartWrite_112(JNIEnv* env, jobject obj,jobject id0, jbyteArray id1, jint len1)
{
  vtkJavaVoidFuncArg* fstruct = new vtkJavaVoidFuncArg;
  env->GetJavaVM(&(fstruct->vm));
  fstruct->uobj = env->NewGlobalRef(id0);
  char* handler = vtkJavaUTF8ToChars(env ,id1, len1);
  fstruct->mid = env->GetMethodID(env->GetObjectClass(id0), handler, "()V");
  delete[] handler;

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStartWrite(vtkJavaVoidFunc,fstruct);
  op->SetStartWriteArgDelete(vtkJavaVoidFuncArgDelete);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkExporter_SetEndWrite_113(JNIEnv* env, jobject obj,jobject id0, jbyteArray id1, jint len1)
{
  vtkJavaVoidFuncArg* fstruct = new vtkJavaVoidFuncArg;
  env->GetJavaVM(&(fstruct->vm));
  fstruct->uobj = env->NewGlobalRef(id0);
  char* handler = vtkJavaUTF8ToChars(env ,id1, len1);
  fstruct->mid = env->GetMethodID(env->GetObjectClass(id0), handler, "()V");
  delete[] handler;

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEndWrite(vtkJavaVoidFunc,fstruct);
  op->SetEndWriteArgDelete(vtkJavaVoidFuncArgDelete);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkExporter_GetMTime_114(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkExporter* op = static_cast<vtkExporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}
