// java wrapper for vtkGLTFImporter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkGLTFImporter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImporter_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkGLTFImporter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkGLTFImporter",dType)) { return me; }
  if ((res= vtkImporter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGLTFImporter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGLTFImporter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGLTFImporter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGLTFImporter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGLTFImporter_SetFileName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFileName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkGLTFImporter_GetFileName_15(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFileName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkGLTFImporter_GetOutputsDescription_16(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputsDescription();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGLTFImporter_UpdateTimeStep_17(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->UpdateTimeStep(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGLTFImporter_GetNumberOfAnimations_18(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfAnimations();
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkGLTFImporter_GetAnimationName_19(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  std::string   temp20;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAnimationName(temp0);
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGLTFImporter_EnableAnimation_110(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->EnableAnimation(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGLTFImporter_DisableAnimation_111(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->DisableAnimation(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkGLTFImporter_IsAnimationEnabled_112(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  bool   temp20;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsAnimationEnabled(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGLTFImporter_GetNumberOfCameras_113(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfCameras();
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkGLTFImporter_GetCameraName_114(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  std::string   temp20;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCameraName(temp0);
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGLTFImporter_SetCamera_115(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkGLTFImporter* op = static_cast<vtkGLTFImporter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCamera(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkGLTFImporter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkGLTFImporter::New());
}
