// java wrapper for vtkMultiNewickTreeReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMultiNewickTreeReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataReader_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMultiNewickTreeReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMultiNewickTreeReader",dType)) { return me; }
  if ((res= vtkDataReader_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiNewickTreeReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiNewickTreeReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiNewickTreeReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiNewickTreeReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiNewickTreeReader_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkMultiPieceDataSet * temp20;

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMultiNewickTreeReader_GetOutput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkMultiPieceDataSet * temp20;
  temp0 = id0;

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMultiNewickTreeReader_SetOutput_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkMultiPieceDataSet * temp0;
  temp0 = static_cast<vtkMultiPieceDataSet*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutput(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMultiNewickTreeReader_ReadMeshSimple_17(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1)
{
  std::string temp0;
  vtkDataObject * temp1;
  int   temp20;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);
  temp1 = static_cast<vtkDataObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkMultiNewickTreeReader* op = static_cast<vtkMultiNewickTreeReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->ReadMeshSimple(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMultiNewickTreeReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMultiNewickTreeReader::New());
}
