// java wrapper for vtkNewickTreeWriter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkNewickTreeWriter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataWriter_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkNewickTreeWriter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkNewickTreeWriter",dType)) { return me; }
  if ((res= vtkDataWriter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkNewickTreeWriter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkNewickTreeWriter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkNewickTreeWriter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkNewickTreeWriter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkNewickTreeWriter_GetInput_14(JNIEnv* env, jobject obj)
{
  vtkTree * temp20;

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkNewickTreeWriter_GetInput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkTree * temp20;
  temp0 = id0;

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkNewickTreeWriter_GetEdgeWeightArrayName_16(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEdgeWeightArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkNewickTreeWriter_SetEdgeWeightArrayName_17(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEdgeWeightArrayName(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkNewickTreeWriter_GetNodeNameArrayName_18(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNodeNameArrayName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkNewickTreeWriter_SetNodeNameArrayName_19(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkNewickTreeWriter* op = static_cast<vtkNewickTreeWriter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNodeNameArrayName(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkNewickTreeWriter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkNewickTreeWriter::New());
}
