// java wrapper for vtkTemporalDelimitedTextReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTemporalDelimitedTextReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDelimitedTextReader_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTemporalDelimitedTextReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTemporalDelimitedTextReader",dType)) { return me; }
  if ((res= vtkDelimitedTextReader_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_GetTimeColumnName_14(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTimeColumnName();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_SetTimeColumnName_15(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  std::string   temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTimeColumnName(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_GetTimeColumnId_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTimeColumnId();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_SetTimeColumnId_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTimeColumnId(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_GetRemoveTimeStepColumn_18(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRemoveTimeStepColumn();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_SetRemoveTimeStepColumn_19(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRemoveTimeStepColumn(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTemporalDelimitedTextReader_GetMTime_110(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkTemporalDelimitedTextReader* op = static_cast<vtkTemporalDelimitedTextReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTemporalDelimitedTextReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTemporalDelimitedTextReader::New());
}
