// java wrapper for vtkRTXMLPolyDataReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkRTXMLPolyDataReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkXMLPolyDataReader_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkRTXMLPolyDataReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkRTXMLPolyDataReader",dType)) { return me; }
  if ((res= vtkXMLPolyDataReader_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRTXMLPolyDataReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRTXMLPolyDataReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkRTXMLPolyDataReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkRTXMLPolyDataReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTXMLPolyDataReader_SetLocation_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLocation(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkRTXMLPolyDataReader_GetDataLocation_15(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDataLocation();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTXMLPolyDataReader_UpdateToNextFile_16(JNIEnv* env, jobject obj)
{

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->UpdateToNextFile();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRTXMLPolyDataReader_NewDataAvailable_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->NewDataAvailable();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTXMLPolyDataReader_ResetReader_18(JNIEnv* env, jobject obj)
{

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->ResetReader();

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkRTXMLPolyDataReader_GetNextFileName_19(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkRTXMLPolyDataReader* op = static_cast<vtkRTXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNextFileName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkRTXMLPolyDataReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkRTXMLPolyDataReader::New());
}
