// java wrapper for vtkXMLPolyDataReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkXMLPolyDataReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkXMLUnstructuredDataReader_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkXMLPolyDataReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkXMLPolyDataReader",dType)) { return me; }
  if ((res= vtkXMLUnstructuredDataReader_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLPolyDataReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLPolyDataReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetOutput_14(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetOutput_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkPolyData * temp20;
  temp0 = id0;

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutput(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetNumberOfVerts_16(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfVerts();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetNumberOfLines_17(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfLines();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetNumberOfStrips_18(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfStrips();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLPolyDataReader_GetNumberOfPolys_19(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLPolyDataReader* op = static_cast<vtkXMLPolyDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfPolys();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkXMLPolyDataReader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkXMLPolyDataReader::New());
}
