// java wrapper for vtkXMLStructuredDataReader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkXMLStructuredDataReader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkXMLDataReader_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkXMLStructuredDataReader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkXMLStructuredDataReader",dType)) { return me; }
  if ((res= vtkXMLDataReader_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLStructuredDataReader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLStructuredDataReader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLStructuredDataReader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLStructuredDataReader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLStructuredDataReader_GetNumberOfPoints_14(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfPoints();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLStructuredDataReader_GetNumberOfCells_15(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfCells();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLStructuredDataReader_SetWholeSlices_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeSlices(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLStructuredDataReader_GetWholeSlices_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWholeSlices();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLStructuredDataReader_WholeSlicesOn_18(JNIEnv* env, jobject obj)
{

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->WholeSlicesOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLStructuredDataReader_WholeSlicesOff_19(JNIEnv* env, jobject obj)
{

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->WholeSlicesOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLStructuredDataReader_CopyOutputInformation_110(JNIEnv* env, jobject obj,jobject id0,jint id1)
{
  vtkInformation * temp0;
  int   temp1;
  temp0 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;

  vtkXMLStructuredDataReader* op = static_cast<vtkXMLStructuredDataReader*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyOutputInformation(temp0,temp1);

}
