// java wrapper for vtkXMLDataParser object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkXMLDataParser.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkXMLParser_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkXMLDataParser_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkXMLDataParser",dType)) { return me; }
  if ((res= vtkXMLParser_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLDataParser_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLDataParser_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLDataParser_GetRootElement_14(JNIEnv* env, jobject obj)
{
  vtkXMLDataElement * temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRootElement();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLDataParser_SetCompressor_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkDataCompressor * temp0;
  temp0 = static_cast<vtkDataCompressor*>(vtkJavaGetPointerFromObject(env, id0));

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCompressor(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLDataParser_GetCompressor_16(JNIEnv* env, jobject obj)
{
  vtkDataCompressor * temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCompressor();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_Parse_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Parse();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_GetAbort_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAbort();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLDataParser_SetAbort_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAbort(temp0);

}

extern "C" JNIEXPORT jfloat  JNICALL Java_vtk_vtkXMLDataParser_GetProgress_110(JNIEnv* env, jobject obj)
{
  float   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetProgress();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLDataParser_SetProgress_111(JNIEnv* env, jobject obj,jfloat id0)
{
  float   temp0;
  temp0 = id0;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetProgress(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLDataParser_SetAttributesEncoding_112(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAttributesEncoding(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_GetAttributesEncodingMinValue_113(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAttributesEncodingMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_GetAttributesEncodingMaxValue_114(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAttributesEncodingMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkXMLDataParser_GetAttributesEncoding_115(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAttributesEncoding();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkXMLDataParser_CharacterDataHandler_116(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jint id1)
{
  char * temp0;
  int   temp1;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = id1;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  op->CharacterDataHandler(temp0,temp1);
  delete[] temp0;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkXMLDataParser_GetAppendedDataPosition_117(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkXMLDataParser* op = static_cast<vtkXMLDataParser*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAppendedDataPosition();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkXMLDataParser_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkXMLDataParser::New());
}
