// java wrapper for vtkImageClip object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageClip.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageClip_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageClip",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageClip_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageClip_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageClip_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageClip_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_SetOutputWholeExtent_14(JNIEnv* env, jobject obj,jintArray id0,jobject id1)
{
  int temp0[6];
  vtkInformation * temp1;
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputWholeExtent(temp0,temp1);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_SetOutputWholeExtent_15(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_GetOutputWholeExtent_16(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetOutputWholeExtent(temp0);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkImageClip_GetOutputWholeExtent_17(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_ResetOutputWholeExtent_18(JNIEnv* env, jobject obj)
{

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->ResetOutputWholeExtent();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_SetClipData_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetClipData(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageClip_GetClipData_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetClipData();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_ClipDataOn_111(JNIEnv* env, jobject obj)
{

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClipDataOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageClip_ClipDataOff_112(JNIEnv* env, jobject obj)
{

  vtkImageClip* op = static_cast<vtkImageClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClipDataOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageClip_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageClip::New());
}
