// java wrapper for vtkImageMagnify object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageMagnify.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkThreadedImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageMagnify_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageMagnify",dType)) { return me; }
  if ((res= vtkThreadedImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageMagnify_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageMagnify_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageMagnify_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageMagnify_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageMagnify_SetMagnificationFactors_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2)
{
  int   temp0;
  int   temp1;
  int   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMagnificationFactors(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageMagnify_SetMagnificationFactors_15(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[3];
  env->GetIntArrayRegion(id0, 0, 3, reinterpret_cast<jint*>(&temp0[0]));

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMagnificationFactors(temp0);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkImageMagnify_GetMagnificationFactors_16(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMagnificationFactors();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageMagnify_SetInterpolate_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInterpolate(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageMagnify_GetInterpolate_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInterpolate();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageMagnify_InterpolateOn_19(JNIEnv* env, jobject obj)
{

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  op->InterpolateOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageMagnify_InterpolateOff_110(JNIEnv* env, jobject obj)
{

  vtkImageMagnify* op = static_cast<vtkImageMagnify*>(vtkJavaGetPointerFromObject(env, obj));
  op->InterpolateOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageMagnify_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageMagnify::New());
}
