// java wrapper for vtkImagePadFilter object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImagePadFilter.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkThreadedImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImagePadFilter_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImagePadFilter",dType)) { return me; }
  if ((res= vtkThreadedImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImagePadFilter_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImagePadFilter_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImagePadFilter_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImagePadFilter_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImagePadFilter_SetOutputWholeExtent_14(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputWholeExtent(temp0);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImagePadFilter_SetOutputWholeExtent_15(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImagePadFilter_GetOutputWholeExtent_16(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetOutputWholeExtent(temp0);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkImagePadFilter_GetOutputWholeExtent_17(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImagePadFilter_SetOutputNumberOfScalarComponents_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputNumberOfScalarComponents(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImagePadFilter_GetOutputNumberOfScalarComponents_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkImagePadFilter* op = static_cast<vtkImagePadFilter*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputNumberOfScalarComponents();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImagePadFilter_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImagePadFilter::New());
}
