// java wrapper for vtkImageStencilSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageStencilSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageStencilAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageStencilSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageStencilSource",dType)) { return me; }
  if ((res= vtkImageStencilAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageStencilSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageStencilSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencilSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencilSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetInformationInput_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImageData * temp0;
  temp0 = static_cast<vtkImageData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInformationInput(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencilSource_GetInformationInput_15(JNIEnv* env, jobject obj)
{
  vtkImageData * temp20;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInformationInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetOutputOrigin_16(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputOrigin(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetOutputOrigin_17(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputOrigin(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageStencilSource_GetOutputOrigin_18(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputOrigin();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetOutputSpacing_19(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputSpacing(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetOutputSpacing_110(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputSpacing(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageStencilSource_GetOutputSpacing_111(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputSpacing();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetOutputWholeExtent_112(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_SetOutputWholeExtent_113(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputWholeExtent(temp0);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkImageStencilSource_GetOutputWholeExtent_114(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencilSource_ReportReferences_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkGarbageCollector * temp0;
  temp0 = static_cast<vtkGarbageCollector*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageStencilSource* op = static_cast<vtkImageStencilSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReportReferences(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageStencilSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageStencilSource::New());
}
