// java wrapper for vtkRTAnalyticSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkRTAnalyticSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkRTAnalyticSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkRTAnalyticSource",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRTAnalyticSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRTAnalyticSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkRTAnalyticSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkRTAnalyticSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetWholeExtent_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkRTAnalyticSource_GetWholeExtent_15(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetCenter_16(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetCenter_17(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkRTAnalyticSource_GetCenter_18(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetMaximum_19(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMaximum(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetMaximum_110(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximum();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetStandardDeviation_111(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStandardDeviation(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetStandardDeviation_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStandardDeviation();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetXFreq_113(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetXFreq(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetXFreq_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXFreq();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetYFreq_115(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetYFreq(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetYFreq_116(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYFreq();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetZFreq_117(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetZFreq(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetZFreq_118(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZFreq();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetXMag_119(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetXMag(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetXMag_120(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXMag();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetYMag_121(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetYMag(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetYMag_122(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYMag();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetZMag_123(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetZMag(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkRTAnalyticSource_GetZMag_124(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZMag();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRTAnalyticSource_SetSubsampleRate_125(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSubsampleRate(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRTAnalyticSource_GetSubsampleRate_126(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkRTAnalyticSource* op = static_cast<vtkRTAnalyticSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSubsampleRate();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkRTAnalyticSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkRTAnalyticSource::New());
}
