// java wrapper for vtkImageConvolve object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageConvolve.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkThreadedImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageConvolve_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageConvolve",dType)) { return me; }
  if ((res= vtkThreadedImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageConvolve_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageConvolve_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageConvolve_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageConvolve_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkImageConvolve_GetKernelSize_14(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernelSize();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_SetKernel3x3_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[9];
  env->GetDoubleArrayRegion(id0, 0, 9, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel3x3(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_SetKernel5x5_16(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[25];
  env->GetDoubleArrayRegion(id0, 0, 25, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel5x5(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_SetKernel7x7_17(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[49];
  env->GetDoubleArrayRegion(id0, 0, 49, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel7x7(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageConvolve_GetKernel3x3_18(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernel3x3();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 9);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_GetKernel3x3_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[9];
  env->GetDoubleArrayRegion(id0, 0, 9, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetKernel3x3(temp0);
  env->SetDoubleArrayRegion(id0, 0, 9, &temp0[0]);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageConvolve_GetKernel5x5_110(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernel5x5();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 25);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_GetKernel5x5_111(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[25];
  env->GetDoubleArrayRegion(id0, 0, 25, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetKernel5x5(temp0);
  env->SetDoubleArrayRegion(id0, 0, 25, &temp0[0]);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageConvolve_GetKernel7x7_112(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernel7x7();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 49);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_GetKernel7x7_113(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[49];
  env->GetDoubleArrayRegion(id0, 0, 49, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetKernel7x7(temp0);
  env->SetDoubleArrayRegion(id0, 0, 49, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_SetKernel3x3x3_114(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[27];
  env->GetDoubleArrayRegion(id0, 0, 27, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel3x3x3(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_SetKernel5x5x5_115(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[125];
  env->GetDoubleArrayRegion(id0, 0, 125, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel5x5x5(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_SetKernel7x7x7_116(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[343];
  env->GetDoubleArrayRegion(id0, 0, 343, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetKernel7x7x7(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageConvolve_GetKernel3x3x3_117(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernel3x3x3();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 27);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_GetKernel3x3x3_118(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[27];
  env->GetDoubleArrayRegion(id0, 0, 27, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetKernel3x3x3(temp0);
  env->SetDoubleArrayRegion(id0, 0, 27, &temp0[0]);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageConvolve_GetKernel5x5x5_119(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetKernel5x5x5();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 125);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_GetKernel5x5x5_120(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[125];
  env->GetDoubleArrayRegion(id0, 0, 125, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetKernel5x5x5(temp0);
  env->SetDoubleArrayRegion(id0, 0, 125, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageConvolve_GetKernel7x7x7_121(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[343];
  env->GetDoubleArrayRegion(id0, 0, 343, &temp0[0]);

  vtkImageConvolve* op = static_cast<vtkImageConvolve*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetKernel7x7x7(temp0);
  env->SetDoubleArrayRegion(id0, 0, 343, &temp0[0]);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageConvolve_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageConvolve::New());
}
