// java wrapper for vtkImageSeparableConvolution object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageSeparableConvolution.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageDecomposeFilter_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageSeparableConvolution_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageSeparableConvolution",dType)) { return me; }
  if ((res= vtkImageDecomposeFilter_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSeparableConvolution_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSeparableConvolution_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSeparableConvolution_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSeparableConvolution_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSeparableConvolution_SetXKernel_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkFloatArray * temp0;
  temp0 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetXKernel(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSeparableConvolution_GetXKernel_15(JNIEnv* env, jobject obj)
{
  vtkFloatArray * temp20;

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetXKernel();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSeparableConvolution_SetYKernel_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkFloatArray * temp0;
  temp0 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetYKernel(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSeparableConvolution_GetYKernel_17(JNIEnv* env, jobject obj)
{
  vtkFloatArray * temp20;

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetYKernel();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSeparableConvolution_SetZKernel_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkFloatArray * temp0;
  temp0 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetZKernel(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSeparableConvolution_GetZKernel_19(JNIEnv* env, jobject obj)
{
  vtkFloatArray * temp20;

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZKernel();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSeparableConvolution_GetMTime_110(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkImageSeparableConvolution* op = static_cast<vtkImageSeparableConvolution*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageSeparableConvolution_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageSeparableConvolution::New());
}
