// java wrapper for vtkImageEllipsoidSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageEllipsoidSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageEllipsoidSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageEllipsoidSource",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageEllipsoidSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageEllipsoidSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageEllipsoidSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageEllipsoidSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetWholeExtent_14(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetWholeExtent_15(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_GetWholeExtent_16(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[6];
  env->GetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetWholeExtent(temp0);
  env->SetIntArrayRegion(id0, 0, 6, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT jintArray  JNICALL Java_vtk_vtkImageEllipsoidSource_GetWholeExtent_17(JNIEnv* env, jobject obj)
{
  int * temp20;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWholeExtent();
  return vtkJavaMakeJArrayOfInt(env, reinterpret_cast<jint*>(temp20), 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetCenter_18(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetCenter_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageEllipsoidSource_GetCenter_110(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetRadius_111(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRadius(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetRadius_112(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRadius(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageEllipsoidSource_GetRadius_113(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRadius();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetInValue_114(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageEllipsoidSource_GetInValue_115(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutValue_116(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageEllipsoidSource_GetOutValue_117(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarType_118(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarType(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageEllipsoidSource_GetOutputScalarType_119(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutputScalarType();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToFloat_120(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToFloat();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToDouble_121(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToDouble();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToLong_122(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToLong();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToUnsignedLong_123(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToUnsignedLong();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToInt_124(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToInt();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToUnsignedInt_125(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToUnsignedInt();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToShort_126(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToShort();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToUnsignedShort_127(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToUnsignedShort();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToChar_128(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToChar();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageEllipsoidSource_SetOutputScalarTypeToUnsignedChar_129(JNIEnv* env, jobject obj)
{

  vtkImageEllipsoidSource* op = static_cast<vtkImageEllipsoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutputScalarTypeToUnsignedChar();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageEllipsoidSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageEllipsoidSource::New());
}
