// java wrapper for vtkImageGaussianSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageGaussianSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageGaussianSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageGaussianSource",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageGaussianSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageGaussianSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageGaussianSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageGaussianSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageGaussianSource_SetWholeExtent_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageGaussianSource_SetCenter_15(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageGaussianSource_SetCenter_16(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetCenter(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageGaussianSource_GetCenter_17(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetCenter();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageGaussianSource_SetMaximum_18(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMaximum(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageGaussianSource_GetMaximum_19(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximum();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageGaussianSource_SetStandardDeviation_110(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStandardDeviation(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageGaussianSource_GetStandardDeviation_111(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageGaussianSource* op = static_cast<vtkImageGaussianSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStandardDeviation();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageGaussianSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageGaussianSource::New());
}
