// java wrapper for vtkImageSinusoidSource object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageSinusoidSource.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageSinusoidSource_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageSinusoidSource",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSinusoidSource_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSinusoidSource_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSinusoidSource_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSinusoidSource_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSinusoidSource_SetWholeExtent_14(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  int   temp0;
  int   temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSinusoidSource_SetDirection_15(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirection(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSinusoidSource_SetDirection_16(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[3];
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetDirection(temp0);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageSinusoidSource_GetDirection_17(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDirection();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSinusoidSource_SetPeriod_18(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPeriod(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSinusoidSource_GetPeriod_19(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPeriod();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSinusoidSource_SetPhase_110(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPhase(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSinusoidSource_GetPhase_111(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPhase();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSinusoidSource_SetAmplitude_112(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAmplitude(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSinusoidSource_GetAmplitude_113(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSinusoidSource* op = static_cast<vtkImageSinusoidSource*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAmplitude();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageSinusoidSource_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageSinusoidSource::New());
}
