// java wrapper for vtkImageStencil object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageStencil.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkThreadedImageAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageStencil_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageStencil",dType)) { return me; }
  if ((res= vtkThreadedImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageStencil_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageStencil_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencil_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencil_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetStencilData_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImageStencilData * temp0;
  temp0 = static_cast<vtkImageStencilData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStencilData(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencil_GetStencil_15(JNIEnv* env, jobject obj)
{
  vtkImageStencilData * temp20;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetStencil();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetStencilConnection_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAlgorithmOutput * temp0;
  temp0 = static_cast<vtkAlgorithmOutput*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStencilConnection(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetReverseStencil_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetReverseStencil(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_ReverseStencilOn_18(JNIEnv* env, jobject obj)
{

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReverseStencilOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_ReverseStencilOff_19(JNIEnv* env, jobject obj)
{

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReverseStencilOff();

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageStencil_GetReverseStencil_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetReverseStencil();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetBackgroundInputData_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImageData * temp0;
  temp0 = static_cast<vtkImageData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBackgroundInputData(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageStencil_GetBackgroundInput_112(JNIEnv* env, jobject obj)
{
  vtkImageData * temp20;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBackgroundInput();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetBackgroundValue_113(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBackgroundValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageStencil_GetBackgroundValue_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBackgroundValue();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetBackgroundColor_115(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3)
{
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp3;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBackgroundColor(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageStencil_SetBackgroundColor_116(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[4];
  env->GetDoubleArrayRegion(id0, 0, 4, &temp0[0]);

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBackgroundColor(temp0);

}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkImageStencil_GetBackgroundColor_117(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkImageStencil* op = static_cast<vtkImageStencil*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBackgroundColor();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 4);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageStencil_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageStencil::New());
}
