// java wrapper for vtkMutableGraphHelper object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMutableGraphHelper.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMutableGraphHelper_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMutableGraphHelper",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMutableGraphHelper_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMutableGraphHelper_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMutableGraphHelper_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMutableGraphHelper_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMutableGraphHelper_SetGraph_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkGraph * temp0;
  temp0 = static_cast<vtkGraph*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetGraph(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMutableGraphHelper_GetGraph_15(JNIEnv* env, jobject obj)
{
  vtkGraph * temp20;

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGraph();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMutableGraphHelper_AddGraphEdge_16(JNIEnv* env, jobject obj,jlong id0,jlong id1)
{
  long long   temp0;
  long long   temp1;
  vtkGraphEdge * temp20;
  temp0 = id0;
  temp1 = id1;

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->AddGraphEdge(temp0,temp1);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMutableGraphHelper_AddVertex_17(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->AddVertex();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMutableGraphHelper_RemoveVertex_18(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveVertex(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMutableGraphHelper_RemoveVertices_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdTypeArray * temp0;
  temp0 = static_cast<vtkIdTypeArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveVertices(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMutableGraphHelper_RemoveEdge_110(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveEdge(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMutableGraphHelper_RemoveEdges_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkIdTypeArray * temp0;
  temp0 = static_cast<vtkIdTypeArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMutableGraphHelper* op = static_cast<vtkMutableGraphHelper*>(vtkJavaGetPointerFromObject(env, obj));
  op->RemoveEdges(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMutableGraphHelper_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMutableGraphHelper::New());
}
