// java wrapper for vtkTableToArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTableToArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkArrayDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTableToArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTableToArray",dType)) { return me; }
  if ((res= vtkArrayDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableToArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableToArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToArray_ClearColumns_14(JNIEnv* env, jobject obj)
{

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearColumns();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToArray_AddColumn_15(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddColumn(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToArray_AddColumn_16(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  temp0 = id0;

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddColumn(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToArray_AddAllColumns_17(JNIEnv* env, jobject obj)
{

  vtkTableToArray* op = static_cast<vtkTableToArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddAllColumns();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTableToArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTableToArray::New());
}
