// java wrapper for vtkTableToSparseArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTableToSparseArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkArrayDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTableToSparseArray_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTableToSparseArray",dType)) { return me; }
  if ((res= vtkArrayDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToSparseArray_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTableToSparseArray_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableToSparseArray_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTableToSparseArray_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToSparseArray_ClearCoordinateColumns_14(JNIEnv* env, jobject obj)
{

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearCoordinateColumns();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToSparseArray_AddCoordinateColumn_15(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddCoordinateColumn(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToSparseArray_SetValueColumn_16(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetValueColumn(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTableToSparseArray_GetValueColumn_17(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetValueColumn();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTableToSparseArray_ClearOutputExtents_18(JNIEnv* env, jobject obj)
{

  vtkTableToSparseArray* op = static_cast<vtkTableToSparseArray*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearOutputExtents();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTableToSparseArray_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTableToSparseArray::New());
}
