// java wrapper for vtkAreaLayoutStrategy object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkAreaLayoutStrategy.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkAreaLayoutStrategy_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkAreaLayoutStrategy",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkAreaLayoutStrategy_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkAreaLayoutStrategy_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAreaLayoutStrategy_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAreaLayoutStrategy_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAreaLayoutStrategy_Layout_14(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkTree * temp0;
  vtkDataArray * temp1;
  vtkDataArray * temp2;
  temp0 = static_cast<vtkTree*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->Layout(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAreaLayoutStrategy_LayoutEdgePoints_15(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2,jobject id3)
{
  vtkTree * temp0;
  vtkDataArray * temp1;
  vtkDataArray * temp2;
  vtkTree * temp3;
  temp0 = static_cast<vtkTree*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkTree*>(vtkJavaGetPointerFromObject(env, id3));

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->LayoutEdgePoints(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkAreaLayoutStrategy_FindVertex_16(JNIEnv* env, jobject obj,jobject id0,jobject id1,jfloatArray id2)
{
  vtkTree * temp0;
  vtkDataArray * temp1;
  float temp2[2];
  long long   temp20;
  temp0 = static_cast<vtkTree*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  env->GetFloatArrayRegion(id2, 0, 2, &temp2[0]);

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FindVertex(temp0,temp1,temp2);
  env->SetFloatArrayRegion(id2, 0, 2, &temp2[0]);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkAreaLayoutStrategy_SetShrinkPercentage_17(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetShrinkPercentage(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkAreaLayoutStrategy_GetShrinkPercentageMinValue_18(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetShrinkPercentageMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkAreaLayoutStrategy_GetShrinkPercentageMaxValue_19(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetShrinkPercentageMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkAreaLayoutStrategy_GetShrinkPercentage_110(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkAreaLayoutStrategy* op = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetShrinkPercentage();
  return temp20;

}
