// java wrapper for vtkGraphLayout object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkGraphLayout.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkGraphAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkGraphLayout_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkGraphLayout",dType)) { return me; }
  if ((res= vtkGraphAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGraphLayout_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGraphLayout_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphLayout_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphLayout_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphLayout_SetLayoutStrategy_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkGraphLayoutStrategy * temp0;
  temp0 = static_cast<vtkGraphLayoutStrategy*>(vtkJavaGetPointerFromObject(env, id0));

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayoutStrategy(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphLayout_GetLayoutStrategy_15(JNIEnv* env, jobject obj)
{
  vtkGraphLayoutStrategy * temp20;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLayoutStrategy();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkGraphLayout_IsLayoutComplete_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsLayoutComplete();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphLayout_GetMTime_17(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkGraphLayout_GetZRange_18(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetZRange();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphLayout_SetZRange_19(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetZRange(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkGraphLayout_GetTransform_110(JNIEnv* env, jobject obj)
{
  vtkAbstractTransform * temp20;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTransform();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphLayout_SetTransform_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAbstractTransform * temp0;
  temp0 = static_cast<vtkAbstractTransform*>(vtkJavaGetPointerFromObject(env, id0));

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTransform(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphLayout_SetUseTransform_112(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetUseTransform(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkGraphLayout_GetUseTransform_113(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUseTransform();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphLayout_UseTransformOn_114(JNIEnv* env, jobject obj)
{

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseTransformOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkGraphLayout_UseTransformOff_115(JNIEnv* env, jobject obj)
{

  vtkGraphLayout* op = static_cast<vtkGraphLayout*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseTransformOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkGraphLayout_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkGraphLayout::New());
}
