// java wrapper for vtkTreeMapToPolyData object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTreeMapToPolyData.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTreeMapToPolyData_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTreeMapToPolyData",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeMapToPolyData_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeMapToPolyData_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTreeMapToPolyData_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTreeMapToPolyData_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapToPolyData_SetRectanglesArrayName_14(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRectanglesArrayName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapToPolyData_SetLevelArrayName_15(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLevelArrayName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTreeMapToPolyData_GetLevelDeltaZ_16(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLevelDeltaZ();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapToPolyData_SetLevelDeltaZ_17(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLevelDeltaZ(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTreeMapToPolyData_GetAddNormals_18(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetAddNormals();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapToPolyData_SetAddNormals_19(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetAddNormals(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeMapToPolyData_FillInputPortInformation_110(JNIEnv* env, jobject obj,jint id0,jobject id1)
{
  int   temp0;
  vtkInformation * temp1;
  int   temp20;
  temp0 = id0;
  temp1 = static_cast<vtkInformation*>(vtkJavaGetPointerFromObject(env, id1));

  vtkTreeMapToPolyData* op = static_cast<vtkTreeMapToPolyData*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FillInputPortInformation(temp0,temp1);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTreeMapToPolyData_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTreeMapToPolyData::New());
}
