// java wrapper for vtkBezierContourLineInterpolator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBezierContourLineInterpolator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkContourLineInterpolator_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkBezierContourLineInterpolator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkBezierContourLineInterpolator",dType)) { return me; }
  if ((res= vtkContourLineInterpolator_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierContourLineInterpolator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierContourLineInterpolator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierContourLineInterpolator_InterpolateLine_14(JNIEnv* env, jobject obj,jobject id0,jobject id1,jint id2,jint id3)
{
  vtkRenderer * temp0;
  vtkContourRepresentation * temp1;
  int   temp2;
  int   temp3;
  int   temp20;
  temp0 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkContourRepresentation*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = id2;
  temp3 = id3;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->InterpolateLine(temp0,temp1,temp2,temp3);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBezierContourLineInterpolator_SetMaximumCurveError_15(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMaximumCurveError(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetMaximumCurveErrorMinValue_16(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumCurveErrorMinValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetMaximumCurveErrorMaxValue_17(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumCurveErrorMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetMaximumCurveError_18(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumCurveError();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBezierContourLineInterpolator_SetMaximumCurveLineSegments_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMaximumCurveLineSegments(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetMaximumCurveLineSegmentsMinValue_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumCurveLineSegmentsMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetMaximumCurveLineSegmentsMaxValue_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumCurveLineSegmentsMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetMaximumCurveLineSegments_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaximumCurveLineSegments();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBezierContourLineInterpolator_GetSpan_113(JNIEnv* env, jobject obj,jint id0,jobject id1,jobject id2)
{
  int   temp0;
  vtkIntArray * temp1;
  vtkContourRepresentation * temp2;
  temp0 = id0;
  temp1 = static_cast<vtkIntArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkContourRepresentation*>(vtkJavaGetPointerFromObject(env, id2));

  vtkBezierContourLineInterpolator* op = static_cast<vtkBezierContourLineInterpolator*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetSpan(temp0,temp1,temp2);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkBezierContourLineInterpolator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkBezierContourLineInterpolator::New());
}
