// java wrapper for vtkBoxWidget object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkBoxWidget.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtk3DWidget_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkBoxWidget_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkBoxWidget",dType)) { return me; }
  if ((res= vtk3DWidget_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetEnabled_14(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetEnabled(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_PlaceWidget_15(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[6];
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->PlaceWidget(temp0);
  env->SetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_PlaceWidget_16(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->PlaceWidget();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_PlaceWidget_17(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3,jdouble id4,jdouble id5)
{
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp3;
  double   temp4;
  double   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->PlaceWidget(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_GetPlanes_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPlanes * temp0;
  temp0 = static_cast<vtkPlanes*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetPlanes(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetInsideOut_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInsideOut(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_GetInsideOut_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInsideOut();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_InsideOutOn_111(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsideOutOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_InsideOutOff_112(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->InsideOutOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_GetTransform_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkTransform * temp0;
  temp0 = static_cast<vtkTransform*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetTransform(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetTransform_114(JNIEnv* env, jobject obj,jobject id0)
{
  vtkTransform * temp0;
  temp0 = static_cast<vtkTransform*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTransform(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_GetPolyData_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPolyData * temp0;
  temp0 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetPolyData(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetHandleProperty_116(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHandleProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetSelectedHandleProperty_117(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSelectedHandleProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_HandlesOn_118(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->HandlesOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_HandlesOff_119(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->HandlesOff();

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetFaceProperty_120(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetFaceProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetSelectedFaceProperty_121(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSelectedFaceProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetOutlineProperty_122(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutlineProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkBoxWidget_GetSelectedOutlineProperty_123(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSelectedOutlineProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetOutlineFaceWires_124(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutlineFaceWires(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_GetOutlineFaceWires_125(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutlineFaceWires();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_OutlineFaceWiresOn_126(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->OutlineFaceWiresOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_OutlineFaceWiresOff_127(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->OutlineFaceWiresOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetOutlineCursorWires_128(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetOutlineCursorWires(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_GetOutlineCursorWires_129(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetOutlineCursorWires();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_OutlineCursorWiresOn_130(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->OutlineCursorWiresOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_OutlineCursorWiresOff_131(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->OutlineCursorWiresOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetTranslationEnabled_132(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTranslationEnabled(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_GetTranslationEnabled_133(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTranslationEnabled();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_TranslationEnabledOn_134(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->TranslationEnabledOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_TranslationEnabledOff_135(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->TranslationEnabledOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetScalingEnabled_136(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalingEnabled(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_GetScalingEnabled_137(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScalingEnabled();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_ScalingEnabledOn_138(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->ScalingEnabledOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_ScalingEnabledOff_139(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->ScalingEnabledOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_SetRotationEnabled_140(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRotationEnabled(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkBoxWidget_GetRotationEnabled_141(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRotationEnabled();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_RotationEnabledOn_142(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->RotationEnabledOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkBoxWidget_RotationEnabledOff_143(JNIEnv* env, jobject obj)
{

  vtkBoxWidget* op = static_cast<vtkBoxWidget*>(vtkJavaGetPointerFromObject(env, obj));
  op->RotationEnabledOff();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkBoxWidget_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkBoxWidget::New());
}
