// java wrapper for vtkTextRepresentation object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTextRepresentation.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkBorderRepresentation_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTextRepresentation_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTextRepresentation",dType)) { return me; }
  if ((res= vtkBorderRepresentation_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTextRepresentation_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTextRepresentation_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetTextActor_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkTextActor * temp0;
  temp0 = static_cast<vtkTextActor*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTextActor(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTextRepresentation_GetTextActor_15(JNIEnv* env, jobject obj)
{
  vtkTextActor * temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTextActor();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetText_16(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetText(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTextRepresentation_GetText_17(JNIEnv* env, jobject obj)
{
  const char * temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetText();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_BuildRepresentation_18(JNIEnv* env, jobject obj)
{

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->BuildRepresentation();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_GetSize_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetSize(temp0);
  env->SetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_GetActors2D_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPropCollection * temp0;
  temp0 = static_cast<vtkPropCollection*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetActors2D(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_ReleaseGraphicsResources_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkWindow * temp0;
  temp0 = static_cast<vtkWindow*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReleaseGraphicsResources(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_RenderOverlay_112(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderOverlay(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_RenderOpaqueGeometry_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderOpaqueGeometry(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_RenderTranslucentPolygonalGeometry_114(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderTranslucentPolygonalGeometry(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_HasTranslucentPolygonalGeometry_115(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasTranslucentPolygonalGeometry();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetWindowLocation_116(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetWindowLocation(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPosition_117(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPosition_118(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[2];
  env->GetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0);
  env->SetDoubleArrayRegion(id0, 0, 2, &temp0[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPaddingLeft_119(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPaddingLeft(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingLeftMinValue_120(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingLeftMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingLeftMaxValue_121(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingLeftMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingLeft_122(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingLeft();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPaddingRight_123(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPaddingRight(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingRightMinValue_124(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingRightMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingRightMaxValue_125(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingRightMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingRight_126(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingRight();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPaddingTop_127(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPaddingTop(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingTopMinValue_128(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingTopMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingTopMaxValue_129(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingTopMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingTop_130(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingTop();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPaddingBottom_131(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPaddingBottom(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingBottomMinValue_132(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingBottomMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingBottomMaxValue_133(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingBottomMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTextRepresentation_GetPaddingBottom_134(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPaddingBottom();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTextRepresentation_SetPadding_135(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTextRepresentation* op = static_cast<vtkTextRepresentation*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPadding(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTextRepresentation_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTextRepresentation::New());
}
