// java wrapper for vtkMPICommunicator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMPICommunicator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkCommunicator_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMPICommunicator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMPICommunicator",dType)) { return me; }
  if ((res= vtkCommunicator_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMPICommunicator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMPICommunicator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMPICommunicator_GetWorldCommunicator_14(JNIEnv* env, jobject obj)
{
  vtkMPICommunicator * temp20;

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWorldCommunicator();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_Initialize_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProcessGroup * temp0;
  int   temp20;
  temp0 = static_cast<vtkProcessGroup*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Initialize(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_SplitInitialize_16(JNIEnv* env, jobject obj,jobject id0,jint id1,jint id2)
{
  vtkCommunicator * temp0;
  int   temp1;
  int   temp2;
  int   temp20;
  temp0 = static_cast<vtkCommunicator*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;
  temp2 = id2;

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SplitInitialize(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_Barrier_17(JNIEnv* env, jobject obj)
{

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  op->Barrier();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_Free_18(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  op->Free(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_SetUseSsend_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetUseSsend(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_GetUseSsendMinValue_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUseSsendMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_GetUseSsendMaxValue_111(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUseSsendMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMPICommunicator_GetUseSsend_112(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetUseSsend();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_UseSsendOn_113(JNIEnv* env, jobject obj)
{

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseSsendOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_UseSsendOff_114(JNIEnv* env, jobject obj)
{

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  op->UseSsendOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMPICommunicator_CopyFrom_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkMPICommunicator * temp0;
  temp0 = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMPICommunicator* op = static_cast<vtkMPICommunicator*>(vtkJavaGetPointerFromObject(env, obj));
  op->CopyFrom(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMPICommunicator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMPICommunicator::New());
}
