// java wrapper for vtkContextClip object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkContextClip.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAbstractContextItem_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkContextClip_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkContextClip",dType)) { return me; }
  if ((res= vtkAbstractContextItem_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContextClip_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkContextClip_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkContextClip_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkContextClip_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkContextClip_Update_14(JNIEnv* env, jobject obj)
{

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->Update();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkContextClip_Paint_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkContext2D * temp0;
  bool   temp20;
  temp0 = static_cast<vtkContext2D*>(vtkJavaGetPointerFromObject(env, id0));

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Paint(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkContextClip_SetClip_16(JNIEnv* env, jobject obj,jfloat id0,jfloat id1,jfloat id2,jfloat id3)
{
  float   temp0;
  float   temp1;
  float   temp2;
  float   temp3;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetClip(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkContextClip_GetRect_17(JNIEnv* env, jobject obj,jfloatArray id0)
{
  float temp0[4];
  env->GetFloatArrayRegion(id0, 0, 4, &temp0[0]);

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetRect(temp0);
  env->SetFloatArrayRegion(id0, 0, 4, &temp0[0]);

}

extern "C" JNIEXPORT jfloat  JNICALL Java_vtk_vtkContextClip_GetX_18(JNIEnv* env, jobject obj)
{
  float   temp20;

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetX();
  return temp20;

}

extern "C" JNIEXPORT jfloat  JNICALL Java_vtk_vtkContextClip_GetY_19(JNIEnv* env, jobject obj)
{
  float   temp20;

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetY();
  return temp20;

}

extern "C" JNIEXPORT jfloat  JNICALL Java_vtk_vtkContextClip_GetWidth_110(JNIEnv* env, jobject obj)
{
  float   temp20;

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetWidth();
  return temp20;

}

extern "C" JNIEXPORT jfloat  JNICALL Java_vtk_vtkContextClip_GetHeight_111(JNIEnv* env, jobject obj)
{
  float   temp20;

  vtkContextClip* op = static_cast<vtkContextClip*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHeight();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkContextClip_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkContextClip::New());
}
