// java wrapper for vtkPolyDataItem object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPolyDataItem.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkContextItem_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPolyDataItem_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPolyDataItem",dType)) { return me; }
  if ((res= vtkContextItem_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataItem_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPolyDataItem_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataItem_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataItem_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkPolyDataItem_Paint_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkContext2D * temp0;
  bool   temp20;
  temp0 = static_cast<vtkContext2D*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Paint(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataItem_SetPolyData_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPolyData * temp0;
  temp0 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPolyData(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataItem_SetMappedColors_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkUnsignedCharArray * temp0;
  temp0 = static_cast<vtkUnsignedCharArray*>(vtkJavaGetPointerFromObject(env, id0));

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMappedColors(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPolyDataItem_GetPolyData_17(JNIEnv* env, jobject obj)
{
  vtkPolyData * temp20;

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPolyData();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataItem_SetPosition_18(JNIEnv* env, jobject obj,jfloat id0,jfloat id1)
{
  float   temp0;
  float   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataItem_SetPosition_19(JNIEnv* env, jobject obj,jfloatArray id0)
{
  float temp0[2];
  env->GetFloatArrayRegion(id0, 0, 2, &temp0[0]);

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPolyDataItem_SetScalarMode_110(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkPolyDataItem* op = static_cast<vtkPolyDataItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScalarMode(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPolyDataItem_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPolyDataItem::New());
}
