// java wrapper for vtkTooltipItem object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTooltipItem.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkContextItem_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTooltipItem_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTooltipItem",dType)) { return me; }
  if ((res= vtkContextItem_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTooltipItem_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTooltipItem_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTooltipItem_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTooltipItem_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTooltipItem_SetPosition_14(JNIEnv* env, jobject obj,jfloat id0,jfloat id1)
{
  float   temp0;
  float   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTooltipItem_SetPosition_15(JNIEnv* env, jobject obj,jfloatArray id0)
{
  float temp0[2];
  env->GetFloatArrayRegion(id0, 0, 2, &temp0[0]);

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPosition(temp0);

}

extern "C" JNIEXPORT jfloatArray  JNICALL Java_vtk_vtkTooltipItem_GetPosition_16(JNIEnv* env, jobject obj)
{
  float * temp20;

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPosition();
  return vtkJavaMakeJArrayOfFloat(env, temp20, 2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTooltipItem_SetText_17(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  vtkStdString temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetText(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkTooltipItem_GetText_18(JNIEnv* env, jobject obj)
{
  vtkStdString   temp20;

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetText();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTooltipItem_GetPen_19(JNIEnv* env, jobject obj)
{
  vtkPen * temp20;

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPen();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTooltipItem_GetBrush_110(JNIEnv* env, jobject obj)
{
  vtkBrush * temp20;

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBrush();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTooltipItem_GetTextProperties_111(JNIEnv* env, jobject obj)
{
  vtkTextProperty * temp20;

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTextProperties();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTooltipItem_Update_112(JNIEnv* env, jobject obj)
{

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  op->Update();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTooltipItem_Paint_113(JNIEnv* env, jobject obj,jobject id0)
{
  vtkContext2D * temp0;
  bool   temp20;
  temp0 = static_cast<vtkContext2D*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTooltipItem* op = static_cast<vtkTooltipItem*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Paint(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTooltipItem_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTooltipItem::New());
}
