// java wrapper for vtkActorCollection object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkActorCollection.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPropCollection_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkActorCollection_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkActorCollection",dType)) { return me; }
  if ((res= vtkPropCollection_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActorCollection_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActorCollection_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActorCollection_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActorCollection_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActorCollection_AddItem_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkActor * temp0;
  temp0 = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddItem(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActorCollection_GetNextActor_15(JNIEnv* env, jobject obj)
{
  vtkActor * temp20;

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNextActor();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActorCollection_GetLastActor_16(JNIEnv* env, jobject obj)
{
  vtkActor * temp20;

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLastActor();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActorCollection_GetNextItem_17(JNIEnv* env, jobject obj)
{
  vtkActor * temp20;

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNextItem();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActorCollection_GetLastItem_18(JNIEnv* env, jobject obj)
{
  vtkActor * temp20;

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLastItem();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActorCollection_ApplyProperties_19(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProperty * temp0;
  temp0 = static_cast<vtkProperty*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActorCollection* op = static_cast<vtkActorCollection*>(vtkJavaGetPointerFromObject(env, obj));
  op->ApplyProperties(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkActorCollection_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkActorCollection::New());
}
