// java wrapper for vtkActor object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkActor.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkProp3D_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkActor_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkActor",dType)) { return me; }
  if ((res= vtkProp3D_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActor_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActor_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_GetActors_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPropCollection * temp0;
  temp0 = static_cast<vtkPropCollection*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetActors(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActor_RenderOpaqueGeometry_15(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderOpaqueGeometry(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActor_RenderTranslucentPolygonalGeometry_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderTranslucentPolygonalGeometry(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActor_HasTranslucentPolygonalGeometry_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasTranslucentPolygonalGeometry();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkActor_HasOpaqueGeometry_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasOpaqueGeometry();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_Render_19(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkRenderer * temp0;
  vtkMapper * temp1;
  temp0 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkMapper*>(vtkJavaGetPointerFromObject(env, id1));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->Render(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ShallowCopy_110(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProp * temp0;
  temp0 = static_cast<vtkProp*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShallowCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ReleaseGraphicsResources_111(JNIEnv* env, jobject obj,jobject id0)
{
  vtkWindow * temp0;
  temp0 = static_cast<vtkWindow*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReleaseGraphicsResources(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetProperty_112(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProperty * temp0;
  temp0 = static_cast<vtkProperty*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetProperty(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetProperty_113(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_MakeProperty_114(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->MakeProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetBackfaceProperty_115(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProperty * temp0;
  temp0 = static_cast<vtkProperty*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetBackfaceProperty(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetBackfaceProperty_116(JNIEnv* env, jobject obj)
{
  vtkProperty * temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBackfaceProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetTexture_117(JNIEnv* env, jobject obj,jobject id0)
{
  vtkTexture * temp0;
  temp0 = static_cast<vtkTexture*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTexture(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetTexture_118(JNIEnv* env, jobject obj)
{
  vtkTexture * temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTexture();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetMapper_119(JNIEnv* env, jobject obj,jobject id0)
{
  vtkMapper * temp0;
  temp0 = static_cast<vtkMapper*>(vtkJavaGetPointerFromObject(env, id0));

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMapper(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetMapper_120(JNIEnv* env, jobject obj)
{
  vtkMapper * temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMapper();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jdoubleArray  JNICALL Java_vtk_vtkActor_GetBounds_121(JNIEnv* env, jobject obj)
{
  double * temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBounds();
  return vtkJavaMakeJArrayOfDouble(env, temp20, 6);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ApplyProperties_122(JNIEnv* env, jobject obj)
{

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ApplyProperties();

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetMTime_123(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkActor_GetRedrawMTime_124(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRedrawMTime();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkActor_GetForceOpaque_125(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetForceOpaque();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetForceOpaque_126(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetForceOpaque(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ForceOpaqueOn_127(JNIEnv* env, jobject obj)
{

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceOpaqueOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ForceOpaqueOff_128(JNIEnv* env, jobject obj)
{

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceOpaqueOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkActor_GetForceTranslucent_129(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetForceTranslucent();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetForceTranslucent_130(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetForceTranslucent(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ForceTranslucentOn_131(JNIEnv* env, jobject obj)
{

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceTranslucentOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_ForceTranslucentOff_132(JNIEnv* env, jobject obj)
{

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceTranslucentOff();

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkActor_GetSupportsSelection_133(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSupportsSelection();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkActor_IsRenderingTranslucentPolygonalGeometry_134(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsRenderingTranslucentPolygonalGeometry();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_SetIsRenderingTranslucentPolygonalGeometry_135(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetIsRenderingTranslucentPolygonalGeometry(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkActor_GetBounds_136(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[6];
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

  vtkActor* op = static_cast<vtkActor*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetBounds(temp0);
  env->SetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkActor_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkActor::New());
}
