// java wrapper for vtkImageSlice object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkImageSlice.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkProp3D_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkImageSlice_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkImageSlice",dType)) { return me; }
  if ((res= vtkProp3D_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSlice_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSlice_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSlice_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSlice_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_SetMapper_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImageMapper3D * temp0;
  temp0 = static_cast<vtkImageMapper3D*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetMapper(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSlice_GetMapper_15(JNIEnv* env, jobject obj)
{
  vtkImageMapper3D * temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMapper();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_SetProperty_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkImageProperty * temp0;
  temp0 = static_cast<vtkImageProperty*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetProperty(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSlice_GetProperty_17(JNIEnv* env, jobject obj)
{
  vtkImageProperty * temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetProperty();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_Update_18(JNIEnv* env, jobject obj)
{

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->Update();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_GetBounds_19(JNIEnv* env, jobject obj,jdoubleArray id0)
{
  double temp0[6];
  env->GetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetBounds(temp0);
  env->SetDoubleArrayRegion(id0, 0, 6, &temp0[0]);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSlice_GetMinXBound_110(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMinXBound();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSlice_GetMaxXBound_111(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaxXBound();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSlice_GetMinYBound_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMinYBound();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSlice_GetMaxYBound_113(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaxYBound();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSlice_GetMinZBound_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMinZBound();
  return temp20;

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkImageSlice_GetMaxZBound_115(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMaxZBound();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSlice_GetMTime_116(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetMTime();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkImageSlice_GetRedrawMTime_117(JNIEnv* env, jobject obj)
{
   unsigned long   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRedrawMTime();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkImageSlice_GetForceTranslucent_118(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetForceTranslucent();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_SetForceTranslucent_119(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetForceTranslucent(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_ForceTranslucentOn_120(JNIEnv* env, jobject obj)
{

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceTranslucentOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_ForceTranslucentOff_121(JNIEnv* env, jobject obj)
{

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->ForceTranslucentOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_ShallowCopy_122(JNIEnv* env, jobject obj,jobject id0)
{
  vtkProp * temp0;
  temp0 = static_cast<vtkProp*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->ShallowCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_GetImages_123(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPropCollection * temp0;
  temp0 = static_cast<vtkPropCollection*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetImages(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSlice_RenderOverlay_124(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderOverlay(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSlice_RenderOpaqueGeometry_125(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderOpaqueGeometry(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSlice_RenderTranslucentPolygonalGeometry_126(JNIEnv* env, jobject obj,jobject id0)
{
  vtkViewport * temp0;
  int   temp20;
  temp0 = static_cast<vtkViewport*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderTranslucentPolygonalGeometry(temp0);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkImageSlice_HasTranslucentPolygonalGeometry_127(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->HasTranslucentPolygonalGeometry();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_Render_128(JNIEnv* env, jobject obj,jobject id0)
{
  vtkRenderer * temp0;
  temp0 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->Render(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_ReleaseGraphicsResources_129(JNIEnv* env, jobject obj,jobject id0)
{
  vtkWindow * temp0;
  temp0 = static_cast<vtkWindow*>(vtkJavaGetPointerFromObject(env, id0));

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReleaseGraphicsResources(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkImageSlice_SetStackedImagePass_130(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkImageSlice* op = static_cast<vtkImageSlice*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetStackedImagePass(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkImageSlice_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkImageSlice::New());
}
