// java wrapper for vtkPropPicker object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPropPicker.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAbstractPropPicker_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkPropPicker_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkPropPicker",dType)) { return me; }
  if ((res= vtkAbstractPropPicker_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPropPicker_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPropPicker_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_PickProp_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jobject id2)
{
  double   temp0;
  double   temp1;
  vtkRenderer * temp2;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id2));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PickProp(temp0,temp1,temp2);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_PickProp_15(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jobject id2,jobject id3)
{
  double   temp0;
  double   temp1;
  vtkRenderer * temp2;
  vtkPropCollection * temp3;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkPropCollection*>(vtkJavaGetPointerFromObject(env, id3));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PickProp(temp0,temp1,temp2,temp3);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_Pick_16(JNIEnv* env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jobject id3)
{
  double   temp0;
  double   temp1;
  double   temp2;
  vtkRenderer * temp3;
  int   temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id3));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Pick(temp0,temp1,temp2,temp3);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_Pick_17(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1)
{
  double temp0[3];
  vtkRenderer * temp1;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Pick(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_Pick3DPoint_18(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1)
{
  double temp0[3];
  vtkRenderer * temp1;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Pick3DPoint(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_PickProp3DPoint_19(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1)
{
  double temp0[3];
  vtkRenderer * temp1;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id1));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PickProp3DPoint(temp0,temp1);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_PickProp3DPoint_110(JNIEnv* env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  double temp0[3];
  vtkRenderer * temp1;
  vtkPropCollection * temp2;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  temp1 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkPropCollection*>(vtkJavaGetPointerFromObject(env, id2));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PickProp3DPoint(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_PickProp3DRay_111(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jobject id2,jobject id3)
{
  double temp0[3];
  double temp1[4];
  vtkRenderer * temp2;
  vtkPropCollection * temp3;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 4, &temp1[0]);
  temp2 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkPropCollection*>(vtkJavaGetPointerFromObject(env, id3));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->PickProp3DRay(temp0,temp1,temp2,temp3);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 4, &temp1[0]);
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPropPicker_Pick3DRay_112(JNIEnv* env, jobject obj,jdoubleArray id0,jdoubleArray id1,jobject id2)
{
  double temp0[3];
  double temp1[4];
  vtkRenderer * temp2;
  int   temp20;
  env->GetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->GetDoubleArrayRegion(id1, 0, 4, &temp1[0]);
  temp2 = static_cast<vtkRenderer*>(vtkJavaGetPointerFromObject(env, id2));

  vtkPropPicker* op = static_cast<vtkPropPicker*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Pick3DRay(temp0,temp1,temp2);
  env->SetDoubleArrayRegion(id0, 0, 3, &temp0[0]);
  env->SetDoubleArrayRegion(id1, 0, 4, &temp1[0]);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPropPicker_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkPropPicker::New());
}
