// java wrapper for vtkMathTextUtilities object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkMathTextUtilities.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkMathTextUtilities_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkMathTextUtilities",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMathTextUtilities_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMathTextUtilities_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMathTextUtilities_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMathTextUtilities_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkMathTextUtilities_IsAvailable_14(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsAvailable();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkMathTextUtilities_GetInstance_15(JNIEnv* env, jobject obj)
{
  vtkMathTextUtilities * temp20;

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInstance();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMathTextUtilities_SetInstance_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkMathTextUtilities * temp0;
  temp0 = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, id0));

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInstance(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkMathTextUtilities_GetBoundingBox_17(JNIEnv* env, jobject obj,jobject id0, jbyteArray id1, jint len1,jint id2,jintArray id3)
{
  vtkTextProperty * temp0;
  char * temp1;
  int   temp2;
  int temp3[4];
  bool   temp20;
  temp0 = static_cast<vtkTextProperty*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = vtkJavaUTF8ToChars(env, id1, len1);
  temp2 = id2;
  env->GetIntArrayRegion(id3, 0, 4, reinterpret_cast<jint*>(&temp3[0]));

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBoundingBox(temp0,temp1,temp2,temp3);
  delete[] temp1;
  env->SetIntArrayRegion(id3, 0, 4, reinterpret_cast<jint*>(&temp3[0]));
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkMathTextUtilities_RenderString_18(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1,jobject id2,jint id3,jintArray id4)
{
  char * temp0;
  vtkImageData * temp1;
  vtkTextProperty * temp2;
  int   temp3;
  int temp4[2];
  bool   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = static_cast<vtkImageData*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkTextProperty*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = id3;
  env->GetIntArrayRegion(id4, 0, 2, reinterpret_cast<jint*>(&temp4[0]));

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->RenderString(temp0,temp1,temp2,temp3,temp4);
  delete[] temp0;
  env->SetIntArrayRegion(id4, 0, 2, reinterpret_cast<jint*>(&temp4[0]));
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkMathTextUtilities_StringToPath_19(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1,jobject id2,jint id3)
{
  char * temp0;
  vtkPath * temp1;
  vtkTextProperty * temp2;
  int   temp3;
  bool   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = static_cast<vtkPath*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkTextProperty*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = id3;

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->StringToPath(temp0,temp1,temp2,temp3);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkMathTextUtilities_GetConstrainedFontSize_110(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1,jint id2,jint id3,jint id4)
{
  char * temp0;
  vtkTextProperty * temp1;
  int   temp2;
  int   temp3;
  int   temp4;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = static_cast<vtkTextProperty*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetConstrainedFontSize(temp0,temp1,temp2,temp3,temp4);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkMathTextUtilities_GetScaleToPowerOfTwo_111(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetScaleToPowerOfTwo();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkMathTextUtilities_SetScaleToPowerOfTwo_112(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkMathTextUtilities* op = static_cast<vtkMathTextUtilities*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetScaleToPowerOfTwo(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkMathTextUtilities_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkMathTextUtilities::New());
}
