// java wrapper for vtkOpenGLInstanceCulling object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkOpenGLInstanceCulling.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkOpenGLInstanceCulling_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkOpenGLInstanceCulling",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLInstanceCulling_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLInstanceCulling_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLInstanceCulling_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLInstanceCulling_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLInstanceCulling_InitLOD_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkPolyData * temp0;
  temp0 = static_cast<vtkPolyData*>(vtkJavaGetPointerFromObject(env, id0));

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  op->InitLOD(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLInstanceCulling_AddLOD_15(JNIEnv* env, jobject obj,jfloat id0,jfloat id1)
{
  float   temp0;
  float   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddLOD(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLInstanceCulling_BuildCullingShaders_16(JNIEnv* env, jobject obj,jobject id0,jlong id1,jboolean id2)
{
  vtkOpenGLShaderCache * temp0;
  long long   temp1;
  bool   temp2;
  temp0 = static_cast<vtkOpenGLShaderCache*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = id1;
  temp2 = (id2 != 0) ? true : false;

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  op->BuildCullingShaders(temp0,temp1,temp2);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLInstanceCulling_GetNumberOfLOD_17(JNIEnv* env, jobject obj)
{
  long long   temp20;

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfLOD();
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOpenGLInstanceCulling_GetLODBuffer_18(JNIEnv* env, jobject obj,jlong id0)
{
  long long   temp0;
  vtkOpenGLBufferObject * temp20;
  temp0 = id0;

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLODBuffer(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLInstanceCulling_RunCullingShaders_19(JNIEnv* env, jobject obj,jlong id0,jobject id1,jobject id2,jobject id3)
{
  long long   temp0;
  vtkOpenGLBufferObject * temp1;
  vtkOpenGLBufferObject * temp2;
  vtkOpenGLBufferObject * temp3;
  temp0 = id0;
  temp1 = static_cast<vtkOpenGLBufferObject*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkOpenGLBufferObject*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkOpenGLBufferObject*>(vtkJavaGetPointerFromObject(env, id3));

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  op->RunCullingShaders(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLInstanceCulling_SetColorLOD_110(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetColorLOD(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkOpenGLInstanceCulling_GetColorLOD_111(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkOpenGLInstanceCulling* op = static_cast<vtkOpenGLInstanceCulling*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetColorLOD();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkOpenGLInstanceCulling_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkOpenGLInstanceCulling::New());
}
