// java wrapper for vtkShader object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkShader.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkShader_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkShader",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShader_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkShader_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShader_SetType_14(JNIEnv* env, jobject obj,jint id0)
{
  vtkShader::Type   temp0;
  temp0 = static_cast<vtkShader::Type>(id0);

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetType(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_GetType_15(JNIEnv* env, jobject obj)
{
  vtkShader::Type   temp20;

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetType();
  return static_cast<jint>(temp20);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShader_SetSource_16(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  std::string temp0;
  temp0 = vtkJavaUTF8ToString(env, id0, len0);

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetSource(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkShader_GetSource_17(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetSource();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkShader_GetError_18(JNIEnv* env, jobject obj)
{
  std::string   temp20;

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetError();
  return vtkJavaStringToUTF8(env, temp20);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkShader_GetHandle_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetHandle();
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkShader_Compile_110(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Compile();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkShader_Cleanup_111(JNIEnv* env, jobject obj)
{

  vtkShader* op = static_cast<vtkShader*>(vtkJavaGetPointerFromObject(env, obj));
  op->Cleanup();

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkShader_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkShader::New());
}
