// java wrapper for vtkTransformFeedback object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTransformFeedback.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTransformFeedback_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTransformFeedback",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFeedback_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFeedback_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFeedback_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFeedback_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_ClearVaryings_14(JNIEnv* env, jobject obj)
{

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->ClearVaryings();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_AddVarying_15(JNIEnv* env, jobject obj,jint id0, jbyteArray id1, jint len1)
{
  vtkTransformFeedback::VaryingRole   temp0;
  std::string temp1;
  temp0 = static_cast<vtkTransformFeedback::VaryingRole>(id0);
  temp1 = vtkJavaUTF8ToString(env, id1, len1);

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->AddVarying(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_BindVaryings_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkShaderProgram * temp0;
  temp0 = static_cast<vtkShaderProgram*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->BindVaryings(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTransformFeedback_GetBuffer_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  vtkOpenGLBufferObject * temp20;
  temp0 = id0;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBuffer(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFeedback_GetBufferHandle_18(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  int   temp20;
  temp0 = id0;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetBufferHandle(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_SetPrimitiveMode_19(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetPrimitiveMode(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTransformFeedback_GetPrimitiveMode_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetPrimitiveMode();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_BindBuffer_111(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->BindBuffer(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_ReadBuffer_112(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReadBuffer(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_ReleaseGraphicsResources_113(JNIEnv* env, jobject obj)
{

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReleaseGraphicsResources();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTransformFeedback_ReleaseBufferData_114(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTransformFeedback* op = static_cast<vtkTransformFeedback*>(vtkJavaGetPointerFromObject(env, obj));
  op->ReleaseBufferData(temp0);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTransformFeedback_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTransformFeedback::New());
}
