// java wrapper for vtkProjectedTetrahedraMapper object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkProjectedTetrahedraMapper.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkUnstructuredGridVolumeMapper_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkProjectedTetrahedraMapper_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkProjectedTetrahedraMapper",dType)) { return me; }
  if ((res= vtkUnstructuredGridVolumeMapper_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_SetVisibilitySort_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkVisibilitySort * temp0;
  temp0 = static_cast<vtkVisibilitySort*>(vtkJavaGetPointerFromObject(env, id0));

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetVisibilitySort(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_GetVisibilitySort_15(JNIEnv* env, jobject obj)
{
  vtkVisibilitySort * temp20;

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVisibilitySort();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_MapScalarsToColors_16(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkDataArray * temp0;
  vtkVolumeProperty * temp1;
  vtkDataArray * temp2;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkVolumeProperty*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id2));

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->MapScalarsToColors(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_TransformPoints_17(JNIEnv* env, jobject obj,jobject id0,jfloatArray id1,jfloatArray id2,jobject id3)
{
  vtkPoints * temp0;
  float temp1[16];
  float temp2[16];
  vtkFloatArray * temp3;
  temp0 = static_cast<vtkPoints*>(vtkJavaGetPointerFromObject(env, id0));
  env->GetFloatArrayRegion(id1, 0, 16, &temp1[0]);
  env->GetFloatArrayRegion(id2, 0, 16, &temp2[0]);
  temp3 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id3));

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  op->TransformPoints(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkProjectedTetrahedraMapper_IsSupported_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkRenderWindow * temp0;
  bool   temp20;
  temp0 = static_cast<vtkRenderWindow*>(vtkJavaGetPointerFromObject(env, id0));

  vtkProjectedTetrahedraMapper* op = static_cast<vtkProjectedTetrahedraMapper*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsSupported(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkProjectedTetrahedraMapper_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkProjectedTetrahedraMapper::New());
}
