// java wrapper for vtkRecursiveSphereDirectionEncoder object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkRecursiveSphereDirectionEncoder.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDirectionEncoder_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkRecursiveSphereDirectionEncoder_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkRecursiveSphereDirectionEncoder",dType)) { return me; }
  if ((res= vtkDirectionEncoder_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetEncodedDirection_14(JNIEnv* env, jobject obj,jfloatArray id0)
{
  float temp0[3];
  int   temp20;
  env->GetFloatArrayRegion(id0, 0, 3, &temp0[0]);

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetEncodedDirection(temp0);
  env->SetFloatArrayRegion(id0, 0, 3, &temp0[0]);
  return temp20;

}

extern "C" JNIEXPORT jfloatArray  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetDecodedGradient_15(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  float * temp20;
  temp0 = id0;

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetDecodedGradient(temp0);
  return vtkJavaMakeJArrayOfFloat(env, temp20, 3);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetNumberOfEncodedDirections_16(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfEncodedDirections();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_SetRecursionDepth_17(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRecursionDepth(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetRecursionDepthMinValue_18(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRecursionDepthMinValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetRecursionDepthMaxValue_19(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRecursionDepthMaxValue();
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_GetRecursionDepth_110(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkRecursiveSphereDirectionEncoder* op = static_cast<vtkRecursiveSphereDirectionEncoder*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRecursionDepth();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkRecursiveSphereDirectionEncoder_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkRecursiveSphereDirectionEncoder::New());
}
