// java wrapper for vtkUnstructuredGridHomogeneousRayIntegrator object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUnstructuredGridHomogeneousRayIntegrator.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkUnstructuredGridVolumeRayIntegrator_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkUnstructuredGridHomogeneousRayIntegrator_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkUnstructuredGridHomogeneousRayIntegrator",dType)) { return me; }
  if ((res= vtkUnstructuredGridVolumeRayIntegrator_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_Initialize_14(JNIEnv* env, jobject obj,jobject id0,jobject id1)
{
  vtkVolume * temp0;
  vtkDataArray * temp1;
  temp0 = static_cast<vtkVolume*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  op->Initialize(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_Integrate_15(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2,jfloatArray id3)
{
  vtkDoubleArray * temp0;
  vtkDataArray * temp1;
  vtkDataArray * temp2;
  float temp3[4];
  temp0 = static_cast<vtkDoubleArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id2));
  env->GetFloatArrayRegion(id3, 0, 4, &temp3[0]);

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  op->Integrate(temp0,temp1,temp2,temp3);
  env->SetFloatArrayRegion(id3, 0, 4, &temp3[0]);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_SetTransferFunctionTableSize_16(JNIEnv* env, jobject obj,jint id0)
{
  int   temp0;
  temp0 = id0;

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTransferFunctionTableSize(temp0);

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_GetTransferFunctionTableSize_17(JNIEnv* env, jobject obj)
{
  int   temp20;

  vtkUnstructuredGridHomogeneousRayIntegrator* op = static_cast<vtkUnstructuredGridHomogeneousRayIntegrator*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTransferFunctionTableSize();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkUnstructuredGridHomogeneousRayIntegrator_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkUnstructuredGridHomogeneousRayIntegrator::New());
}
