// java wrapper for vtkSCurveSpline object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSCurveSpline.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkSpline_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkSCurveSpline_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkSCurveSpline",dType)) { return me; }
  if ((res= vtkSpline_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSCurveSpline_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSCurveSpline_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSCurveSpline_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkSCurveSpline_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSCurveSpline_Compute_14(JNIEnv* env, jobject obj)
{

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->Compute();

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSCurveSpline_Evaluate_15(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  double   temp20;
  temp0 = id0;

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->Evaluate(temp0);
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSCurveSpline_DeepCopy_16(JNIEnv* env, jobject obj,jobject id0)
{
  vtkSpline * temp0;
  temp0 = static_cast<vtkSpline*>(vtkJavaGetPointerFromObject(env, id0));

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->DeepCopy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSCurveSpline_SetNodeWeight_17(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNodeWeight(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkSCurveSpline_GetNodeWeight_18(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkSCurveSpline* op = static_cast<vtkSCurveSpline*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNodeWeight();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkSCurveSpline_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkSCurveSpline::New());
}
