// java wrapper for vtkTreeMapView object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTreeMapView.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkTreeAreaView_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTreeMapView_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTreeMapView",dType)) { return me; }
  if ((res= vtkTreeAreaView_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeMapView_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeMapView_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTreeMapView_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTreeMapView_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_SetLayoutStrategy_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkAreaLayoutStrategy * temp0;
  temp0 = static_cast<vtkAreaLayoutStrategy*>(vtkJavaGetPointerFromObject(env, id0));

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayoutStrategy(temp0);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_SetLayoutStrategy_15(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayoutStrategy(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_SetLayoutStrategyToBox_16(JNIEnv* env, jobject obj)
{

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayoutStrategyToBox();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_SetLayoutStrategyToSliceAndDice_17(JNIEnv* env, jobject obj)
{

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayoutStrategyToSliceAndDice();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_SetLayoutStrategyToSquarify_18(JNIEnv* env, jobject obj)
{

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayoutStrategyToSquarify();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_SetFontSizeRange_19(JNIEnv* env, jobject obj,jint id0,jint id1,jint id2)
{
  int   temp0;
  int   temp1;
  int   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetFontSizeRange(temp0,temp1,temp2);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeMapView_GetFontSizeRange_110(JNIEnv* env, jobject obj,jintArray id0)
{
  int temp0[3];
  env->GetIntArrayRegion(id0, 0, 3, reinterpret_cast<jint*>(&temp0[0]));

  vtkTreeMapView* op = static_cast<vtkTreeMapView*>(vtkJavaGetPointerFromObject(env, obj));
  op->GetFontSizeRange(temp0);
  env->SetIntArrayRegion(id0, 0, 3, reinterpret_cast<jint*>(&temp0[0]));

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTreeMapView_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTreeMapView::New());
}
