// java wrapper for vtkTreeRingView object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkTreeRingView.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkTreeAreaView_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkTreeRingView_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkTreeRingView",dType)) { return me; }
  if ((res= vtkTreeAreaView_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeRingView_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkTreeRingView_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTreeRingView_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkTreeRingView_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_SetRootAngles_14(JNIEnv* env, jobject obj,jdouble id0,jdouble id1)
{
  double   temp0;
  double   temp1;
  temp0 = id0;
  temp1 = id1;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRootAngles(temp0,temp1);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_SetRootAtCenter_15(JNIEnv* env, jobject obj,jboolean id0)
{
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetRootAtCenter(temp0);

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkTreeRingView_GetRootAtCenter_16(JNIEnv* env, jobject obj)
{
  bool   temp20;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetRootAtCenter();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_RootAtCenterOn_17(JNIEnv* env, jobject obj)
{

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->RootAtCenterOn();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_RootAtCenterOff_18(JNIEnv* env, jobject obj)
{

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->RootAtCenterOff();

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_SetLayerThickness_19(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetLayerThickness(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTreeRingView_GetLayerThickness_110(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetLayerThickness();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_SetInteriorRadius_111(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInteriorRadius(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTreeRingView_GetInteriorRadius_112(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInteriorRadius();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkTreeRingView_SetInteriorLogSpacingValue_113(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetInteriorLogSpacingValue(temp0);

}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkTreeRingView_GetInteriorLogSpacingValue_114(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkTreeRingView* op = static_cast<vtkTreeRingView*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetInteriorLogSpacingValue();
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkTreeRingView_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkTreeRingView::New());
}
