// java wrapper for vtkObjectIdMap object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkObjectIdMap.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkObjectIdMap_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkObjectIdMap",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkObjectIdMap_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkObjectIdMap_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkObjectIdMap_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkObjectIdMap_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkObjectIdMap_GetGlobalId_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkObject * temp0;
   unsigned int   temp20;
  temp0 = static_cast<vtkObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetGlobalId(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkObjectIdMap_GetVTKObject_15(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  vtkObject * temp20;
  temp0 = id0;

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetVTKObject(temp0);
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkObjectIdMap_SetActiveObject_16(JNIEnv* env, jobject obj, jbyteArray id0, jint len0,jobject id1)
{
  char * temp0;
  vtkObject * temp1;
   unsigned int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);
  temp1 = static_cast<vtkObject*>(vtkJavaGetPointerFromObject(env, id1));

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->SetActiveObject(temp0,temp1);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkObjectIdMap_GetActiveObject_17(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  vtkObject * temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetActiveObject(temp0);
  delete[] temp0;
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkObjectIdMap_FreeObject_18(JNIEnv* env, jobject obj,jobject id0)
{
  vtkObject * temp0;
  bool   temp20;
  temp0 = static_cast<vtkObject*>(vtkJavaGetPointerFromObject(env, id0));

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FreeObject(temp0);
  return temp20;

}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkObjectIdMap_FreeObjectById_19(JNIEnv* env, jobject obj,jint id0)
{
   unsigned int   temp0;
  bool   temp20;
  temp0 = id0;

  vtkObjectIdMap* op = static_cast<vtkObjectIdMap*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->FreeObjectById(temp0);
  return temp20;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkObjectIdMap_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkObjectIdMap::New());
}
