#include <ctype.h>  /* NOLINT */
#include <stdio.h>  /* NOLINT */
#include <stdlib.h> /* NOLINT */
#include <string.h> /* NOLINT */
#include <time.h>   /* NOLINT */

#if defined(_MSC_VER)
#pragma warning(disable : 4996) /* deprecation */
#endif

#include "vtkTestingObjectFactory.h"


/* Forward declare test functions. */
int TestBlockOpacity(int, char*[]);
int TestBlockVisibility(int, char*[]);
int TestBlurAndSobelPasses(int, char*[]);
int TestCameraShiftScale(int, char*[]);
int TestCoincident(int, char*[]);
int TestCompositeDataPointGaussian(int, char*[]);
int TestCompositeDataPointGaussianSelection(int, char*[]);
int TestCompositePolyDataMapper2(int, char*[]);
int TestCompositePolyDataMapper2CameraShiftScale(int, char*[]);
int TestCompositePolyDataMapper2CellScalars(int, char*[]);
int TestCompositePolyDataMapper2CustomShader(int, char*[]);
int TestCompositePolyDataMapper2MixedGeometryCellScalars(int, char*[]);
int TestCompositePolyDataMapper2MixedGeometryEdges(int, char*[]);
int TestCompositePolyDataMapper2NaNPartial(int, char*[]);
int TestCompositePolyDataMapper2Pickability(int, char*[]);
int TestCompositePolyDataMapper2Picking(int, char*[]);
int TestCompositePolyDataMapper2Scalars(int, char*[]);
int TestCompositePolyDataMapper2ScalarsSurfaceOpacity(int, char*[]);
int TestCompositePolyDataMapper2SharedArray(int, char*[]);
int TestCompositePolyDataMapper2Spheres(int, char*[]);
int TestCompositePolyDataMapper2Vertices(int, char*[]);
int TestCubeMap(int, char*[]);
int TestCubeMap2(int, char*[]);
int TestCubeMapRerender(int, char*[]);
int TestCustomCursorShape(int, char*[]);
int TestDepthOfFieldPass(int, char*[]);
int TestDepthPeelingOcclusionQuery(int, char*[]);
int TestDepthPeelingPass(int, char*[]);
int TestDepthPeelingPassViewport(int, char*[]);
int TestEDLPass(int, char*[]);
int TestEquirectangularToCubeMap(int, char*[]);
int TestFXAAFilter(int, char*[]);
int TestFXAAPass(int, char*[]);
int TestFXAAWithEDLPass(int, char*[]);
int TestFlipRenderFramebuffer(int, char*[]);
int TestFloor(int, char*[]);
int TestFluidMapper(int, char*[]);
int TestFramebufferHDR(int, char*[]);
int TestFramebufferPass(int, char*[]);
int TestGaussianBlurPass(int, char*[]);
int TestGlyph3DMapperCellPicking(int, char*[]);
int TestGlyph3DMapperCulling(int, char*[]);
int TestGlyph3DMapperEdges(int, char*[]);
int TestGlyph3DMapperPickability(int, char*[]);
int TestGlyph3DMapperTreeIndexingCompositeGlyphs(int, char*[]);
int TestHiddenLineRemovalPass(int, char*[]);
int TestLightingMapLuminancePass(int, char*[]);
int TestLightingMapNormalsPass(int, char*[]);
int TestMultiBlockPartialArrayFieldData(int, char*[]);
int TestMultiBlockPartialArrayPointData(int, char*[]);
int TestMultiTexturing(int, char*[]);
int TestMultiTexturingInterpolateScalars(int, char*[]);
int TestNormalMapping(int, char*[]);
int TestOffscreenRenderingResize(int, char*[]);
int TestOutlineGlowPass(int, char*[]);
int TestOrderIndependentTranslucentPass(int, char*[]);
int TestPanoramicProjectionPass(int, char*[]);
int TestPBRClearCoat(int, char*[]);
int TestPBREdgeTint(int, char*[]);
int TestPBRHdrEnvironment(int, char*[]);
int TestPBRAnisotropy(int, char*[]);
int TestPBRColorMultiplier(int, char*[]);
int TestPBRIrradianceHDR(int, char*[]);
int TestPBRMapping(int, char*[]);
int TestPBRMaterials(int, char*[]);
int TestPBRMaterialsCoat(int, char*[]);
int TestPointFillPass(int, char*[]);
int TestPointGaussianMapper(int, char*[]);
int TestPointGaussianMapperOpacity(int, char*[]);
int TestPointGaussianSelection(int, char*[]);
int TestPropPicker2Renderers(int, char*[]);
int TestRemoveActorNonCurrentContext(int, char*[]);
int TestRenderToImage(int, char*[]);
int TestSetZBuffer(int, char*[]);
int TestShadowMapBakerPass(int, char*[]);
int TestShadowMapPass(int, char*[]);
int TestSharedRenderWindow(int, char*[]);
int TestDirectSelectionRendering(int, char*[]);
int TestSimpleMotionBlur(int, char*[]);
int TestSobelGradientMagnitudePass(int, char*[]);
int TestSphereMap(int, char*[]);
int TestSpherePoints(int, char*[]);
int TestSphereVertex(int, char*[]);
int TestSRGB(int, char*[]);
int TestSSAAPass(int, char*[]);
int TestSSAOPass(int, char*[]);
int TestSSAOPassWithRenderer(int, char*[]);
int TestSurfaceInterpolationSwitch(int, char*[]);
int TestTexture16Bits(int, char*[]);
int TestTexture32Bits(int, char*[]);
int TestToneMappingPass(int, char*[]);
int TestUserShader(int, char*[]);
int TestUserShader2(int, char*[]);
int TestValuePassFloatingPoint(int, char*[]);
int TestVBOPLYMapper(int, char*[]);
int TestVBOPointsLines(int, char*[]);
int TestWindowBlits(int, char*[]);
int UnitTestOpenGLUniforms(int, char*[]);


#ifdef __cplusplus
#  define CM_CAST(TYPE, EXPR) static_cast<TYPE>(EXPR)
#  if __cplusplus >= 201103L
#    define CM_NULL nullptr
#  else
#    define CM_NULL NULL
#  endif
#  define CM_NAMESPACE_BEGIN namespace {
#  define CM_NAMESPACE_END }
#  define CM_LOCAL
#else
#  define CM_CAST(TYPE, EXPR) (TYPE)(EXPR)
#  define CM_NULL NULL
#  define CM_NAMESPACE_BEGIN
#  define CM_NAMESPACE_END
#  define CM_LOCAL static
#endif

CM_NAMESPACE_BEGIN

/* Create map.  */

typedef int (*MainFuncPointer)(int, char* []); /* NOLINT */
typedef struct /* NOLINT */
{
  const char* name;
  MainFuncPointer func;
} functionMapEntry;

CM_LOCAL const functionMapEntry cmakeGeneratedFunctionMapEntries[] = {
    {
    "TestBlockOpacity",
    TestBlockOpacity
  },
  {
    "TestBlockVisibility",
    TestBlockVisibility
  },
  {
    "TestBlurAndSobelPasses",
    TestBlurAndSobelPasses
  },
  {
    "TestCameraShiftScale",
    TestCameraShiftScale
  },
  {
    "TestCoincident",
    TestCoincident
  },
  {
    "TestCompositeDataPointGaussian",
    TestCompositeDataPointGaussian
  },
  {
    "TestCompositeDataPointGaussianSelection",
    TestCompositeDataPointGaussianSelection
  },
  {
    "TestCompositePolyDataMapper2",
    TestCompositePolyDataMapper2
  },
  {
    "TestCompositePolyDataMapper2CameraShiftScale",
    TestCompositePolyDataMapper2CameraShiftScale
  },
  {
    "TestCompositePolyDataMapper2CellScalars",
    TestCompositePolyDataMapper2CellScalars
  },
  {
    "TestCompositePolyDataMapper2CustomShader",
    TestCompositePolyDataMapper2CustomShader
  },
  {
    "TestCompositePolyDataMapper2MixedGeometryCellScalars",
    TestCompositePolyDataMapper2MixedGeometryCellScalars
  },
  {
    "TestCompositePolyDataMapper2MixedGeometryEdges",
    TestCompositePolyDataMapper2MixedGeometryEdges
  },
  {
    "TestCompositePolyDataMapper2NaNPartial",
    TestCompositePolyDataMapper2NaNPartial
  },
  {
    "TestCompositePolyDataMapper2Pickability",
    TestCompositePolyDataMapper2Pickability
  },
  {
    "TestCompositePolyDataMapper2Picking",
    TestCompositePolyDataMapper2Picking
  },
  {
    "TestCompositePolyDataMapper2Scalars",
    TestCompositePolyDataMapper2Scalars
  },
  {
    "TestCompositePolyDataMapper2ScalarsSurfaceOpacity",
    TestCompositePolyDataMapper2ScalarsSurfaceOpacity
  },
  {
    "TestCompositePolyDataMapper2SharedArray",
    TestCompositePolyDataMapper2SharedArray
  },
  {
    "TestCompositePolyDataMapper2Spheres",
    TestCompositePolyDataMapper2Spheres
  },
  {
    "TestCompositePolyDataMapper2Vertices",
    TestCompositePolyDataMapper2Vertices
  },
  {
    "TestCubeMap",
    TestCubeMap
  },
  {
    "TestCubeMap2",
    TestCubeMap2
  },
  {
    "TestCubeMapRerender",
    TestCubeMapRerender
  },
  {
    "TestCustomCursorShape",
    TestCustomCursorShape
  },
  {
    "TestDepthOfFieldPass",
    TestDepthOfFieldPass
  },
  {
    "TestDepthPeelingOcclusionQuery",
    TestDepthPeelingOcclusionQuery
  },
  {
    "TestDepthPeelingPass",
    TestDepthPeelingPass
  },
  {
    "TestDepthPeelingPassViewport",
    TestDepthPeelingPassViewport
  },
  {
    "TestEDLPass",
    TestEDLPass
  },
  {
    "TestEquirectangularToCubeMap",
    TestEquirectangularToCubeMap
  },
  {
    "TestFXAAFilter",
    TestFXAAFilter
  },
  {
    "TestFXAAPass",
    TestFXAAPass
  },
  {
    "TestFXAAWithEDLPass",
    TestFXAAWithEDLPass
  },
  {
    "TestFlipRenderFramebuffer",
    TestFlipRenderFramebuffer
  },
  {
    "TestFloor",
    TestFloor
  },
  {
    "TestFluidMapper",
    TestFluidMapper
  },
  {
    "TestFramebufferHDR",
    TestFramebufferHDR
  },
  {
    "TestFramebufferPass",
    TestFramebufferPass
  },
  {
    "TestGaussianBlurPass",
    TestGaussianBlurPass
  },
  {
    "TestGlyph3DMapperCellPicking",
    TestGlyph3DMapperCellPicking
  },
  {
    "TestGlyph3DMapperCulling",
    TestGlyph3DMapperCulling
  },
  {
    "TestGlyph3DMapperEdges",
    TestGlyph3DMapperEdges
  },
  {
    "TestGlyph3DMapperPickability",
    TestGlyph3DMapperPickability
  },
  {
    "TestGlyph3DMapperTreeIndexingCompositeGlyphs",
    TestGlyph3DMapperTreeIndexingCompositeGlyphs
  },
  {
    "TestHiddenLineRemovalPass",
    TestHiddenLineRemovalPass
  },
  {
    "TestLightingMapLuminancePass",
    TestLightingMapLuminancePass
  },
  {
    "TestLightingMapNormalsPass",
    TestLightingMapNormalsPass
  },
  {
    "TestMultiBlockPartialArrayFieldData",
    TestMultiBlockPartialArrayFieldData
  },
  {
    "TestMultiBlockPartialArrayPointData",
    TestMultiBlockPartialArrayPointData
  },
  {
    "TestMultiTexturing",
    TestMultiTexturing
  },
  {
    "TestMultiTexturingInterpolateScalars",
    TestMultiTexturingInterpolateScalars
  },
  {
    "TestNormalMapping",
    TestNormalMapping
  },
  {
    "TestOffscreenRenderingResize",
    TestOffscreenRenderingResize
  },
  {
    "TestOutlineGlowPass",
    TestOutlineGlowPass
  },
  {
    "TestOrderIndependentTranslucentPass",
    TestOrderIndependentTranslucentPass
  },
  {
    "TestPanoramicProjectionPass",
    TestPanoramicProjectionPass
  },
  {
    "TestPBRClearCoat",
    TestPBRClearCoat
  },
  {
    "TestPBREdgeTint",
    TestPBREdgeTint
  },
  {
    "TestPBRHdrEnvironment",
    TestPBRHdrEnvironment
  },
  {
    "TestPBRAnisotropy",
    TestPBRAnisotropy
  },
  {
    "TestPBRColorMultiplier",
    TestPBRColorMultiplier
  },
  {
    "TestPBRIrradianceHDR",
    TestPBRIrradianceHDR
  },
  {
    "TestPBRMapping",
    TestPBRMapping
  },
  {
    "TestPBRMaterials",
    TestPBRMaterials
  },
  {
    "TestPBRMaterialsCoat",
    TestPBRMaterialsCoat
  },
  {
    "TestPointFillPass",
    TestPointFillPass
  },
  {
    "TestPointGaussianMapper",
    TestPointGaussianMapper
  },
  {
    "TestPointGaussianMapperOpacity",
    TestPointGaussianMapperOpacity
  },
  {
    "TestPointGaussianSelection",
    TestPointGaussianSelection
  },
  {
    "TestPropPicker2Renderers",
    TestPropPicker2Renderers
  },
  {
    "TestRemoveActorNonCurrentContext",
    TestRemoveActorNonCurrentContext
  },
  {
    "TestRenderToImage",
    TestRenderToImage
  },
  {
    "TestSetZBuffer",
    TestSetZBuffer
  },
  {
    "TestShadowMapBakerPass",
    TestShadowMapBakerPass
  },
  {
    "TestShadowMapPass",
    TestShadowMapPass
  },
  {
    "TestSharedRenderWindow",
    TestSharedRenderWindow
  },
  {
    "TestDirectSelectionRendering",
    TestDirectSelectionRendering
  },
  {
    "TestSimpleMotionBlur",
    TestSimpleMotionBlur
  },
  {
    "TestSobelGradientMagnitudePass",
    TestSobelGradientMagnitudePass
  },
  {
    "TestSphereMap",
    TestSphereMap
  },
  {
    "TestSpherePoints",
    TestSpherePoints
  },
  {
    "TestSphereVertex",
    TestSphereVertex
  },
  {
    "TestSRGB",
    TestSRGB
  },
  {
    "TestSSAAPass",
    TestSSAAPass
  },
  {
    "TestSSAOPass",
    TestSSAOPass
  },
  {
    "TestSSAOPassWithRenderer",
    TestSSAOPassWithRenderer
  },
  {
    "TestSurfaceInterpolationSwitch",
    TestSurfaceInterpolationSwitch
  },
  {
    "TestTexture16Bits",
    TestTexture16Bits
  },
  {
    "TestTexture32Bits",
    TestTexture32Bits
  },
  {
    "TestToneMappingPass",
    TestToneMappingPass
  },
  {
    "TestUserShader",
    TestUserShader
  },
  {
    "TestUserShader2",
    TestUserShader2
  },
  {
    "TestValuePassFloatingPoint",
    TestValuePassFloatingPoint
  },
  {
    "TestVBOPLYMapper",
    TestVBOPLYMapper
  },
  {
    "TestVBOPointsLines",
    TestVBOPointsLines
  },
  {
    "TestWindowBlits",
    TestWindowBlits
  },
  {
    "UnitTestOpenGLUniforms",
    UnitTestOpenGLUniforms
  },

  { CM_NULL, CM_NULL } /* NOLINT */
};

CM_LOCAL const int NumTests = CM_CAST(int,
  sizeof(cmakeGeneratedFunctionMapEntries) / sizeof(functionMapEntry)) - 1;

/* Allocate and create a lowercased copy of string
   (note that it has to be free'd manually) */
CM_LOCAL char* lowercase(const char* string)
{
  char *new_string;
  char *p;
  size_t stringSize;

  stringSize = CM_CAST(size_t, strlen(string) + 1);
  new_string = CM_CAST(char*, malloc(sizeof(char) * stringSize));

  if (new_string == CM_NULL) { /* NOLINT */
    return CM_NULL;            /* NOLINT */
  }
  strcpy(new_string, string);  /* NOLINT */
  for (p = new_string; *p != 0; ++p) {
    *p = CM_CAST(char, tolower(*p));
  }
  return new_string;
}

CM_LOCAL int isTestSkipped(const char *name, int n_skipped_tests, char *skipped_tests[]) {
  int i;
  for (i = 0; i < n_skipped_tests; i++) {
    if (strcmp(name, skipped_tests[i]) == 0) {
      return 1;
    }
  }

  return 0;
}

CM_NAMESPACE_END

int main(int ac, char* av[])
{
  int i;
  int testNum = 0;
  int partial_match;
  int run_all;
  char *arg;
  int testToRun = -1;

  

  /* If no test name was given */
  /* process command line with user function.  */
  if (ac < 2) {
    /* Ask for a test.  */
    printf("Available tests:\n");
    for (i = 0; i < NumTests; ++i) {
      printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
    }
    printf("To run a test, enter the test number: ");
    fflush(stdout);
    if (scanf("%d", &testNum) != 1) {
      printf("Couldn't parse that input as a number\n");
      return -1;
    }
    if (testNum >= NumTests) {
      printf("%3d is an invalid test number.\n", testNum);
      return -1;
    }
    testToRun = testNum;
    ac--;
    av++;
  }
  partial_match = 0;
  run_all = 0;
  arg = CM_NULL; /* NOLINT */
  /* If partial match or running all tests are requested.  */
  if (testToRun == -1 && ac > 1) {
    partial_match = (strcmp(av[1], "-R") == 0) ? 1 : 0;
    run_all = (strcmp(av[1], "-A") == 0) ? 1 : 0;
  }
  if (partial_match != 0 && ac < 3) {
    printf("-R needs an additional parameter.\n");
    return -1;
  }
  if (run_all == 1) {
    clock_t t;
    int status = 0;
    const char* status_message = CM_NULL;
    printf("TAP version 13\n");
    printf("1..%d\n", NumTests);
    for (i = 0; i < NumTests; ++i) {
      const char *name = cmakeGeneratedFunctionMapEntries[i].name;
      if (ac > 2) {
        if (isTestSkipped(name, ac - 2, av + 2) == 1) {
          printf("ok %d %s # SKIP\n", i + 1, name);
          continue;
        }
      }
      t = clock();
      status = (*cmakeGeneratedFunctionMapEntries[i].func)(ac, av);
      t = clock() - t;
      status_message = (status == -1) ? "not ok" : "ok";
      {
        double time_taken = CM_CAST(double, t) / CLOCKS_PER_SEC;
        printf("%s %d %s # %f\n", status_message, i + 1, name, time_taken);
      }
    }
    printf("All tests finished.\n");

    return 0;
  }

  if (testToRun == -1) {
    arg = lowercase(av[1 + partial_match]);
  }
  for (i = 0; i < NumTests && testToRun == -1; ++i) {
    char *test_name = lowercase(cmakeGeneratedFunctionMapEntries[i].name);
    if (partial_match != 0 && strstr(test_name, arg) != CM_NULL) { /* NOLINT */
      testToRun = i;
      ac -= 2;
      av += 2;
    } else if (partial_match == 0 && strcmp(test_name, arg) == 0) {
      testToRun = i;
      ac--;
      av++;
    }
    free(test_name);
  }
  free(arg);
  if (testToRun != -1) {
    int result;

    vtksys::SystemInformation::SetStackTraceOnError(1);
#ifndef NDEBUG
    vtkFloatingPointExceptions::Disable();
#endif

    // Set defaults
    vtkTestingInteractor::ValidBaseline = "Use_-V_for_Baseline";
    vtkTestingInteractor::TempDirectory =
      std::string("/builddir/build/BUILD/vtk-9.2.6-build/VTK-9.2.6/redhat-linux-build-serial/Testing/Temporary");
    vtkTestingInteractor::DataDirectory = std::string("Use_-D_for_Data");

    int interactive = 0;
    for (int ii = 0; ii < ac; ++ii)
      {
      if (strcmp(av[ii], "-I") == 0)
        {
        interactive = 1;
        continue;
        }
      if (ii < ac-1 && strcmp(av[ii], "-V") == 0)
        {
        vtkTestingInteractor::ValidBaseline = std::string(av[++ii]);
        continue;
        }
      if (ii < ac-1 && strcmp(av[ii], "-T") == 0)
        {
        vtkTestingInteractor::TempDirectory = std::string(av[++ii]);
        continue;
        }
      if (ii < ac-1 && strcmp(av[ii], "-D") == 0)
        {
        vtkTestingInteractor::DataDirectory = std::string(av[++ii]);
        continue;
        }
      if (ii < ac-1 && strcmp(av[ii], "-E") == 0)
        {
        vtkTestingInteractor::ErrorThreshold =
            static_cast<double>(atof(av[++ii]));
        continue;
        }
      if (ii < ac-1 && strcmp(av[ii], "-v") == 0)
        {
        vtkLogger::SetStderrVerbosity(static_cast<vtkLogger::Verbosity>(atoi(av[++ii])));
        continue;
        }
      }

    // init logging
    vtkLogger::Init(ac, av, nullptr);

    // turn on windows stack traces if applicable
    vtkWindowsTestUtilitiesSetupForTesting();

    vtkSmartPointer<vtkTestingObjectFactory> factory = vtkSmartPointer<vtkTestingObjectFactory>::New();
    if (!interactive)
      {
      // Disable any other overrides before registering our factory.
      vtkObjectFactoryCollection *collection = vtkObjectFactory::GetRegisteredFactories();
      collection->InitTraversal();
      vtkObjectFactory *f = collection->GetNextItem();
      while (f)
        {
        f->Disable("vtkRenderWindowInteractor");
        f = collection->GetNextItem();
        }
      vtkObjectFactory::RegisterFactory(factory);
      }

    if (testToRun < 0 || testToRun >= NumTests) {
      printf("testToRun was modified by TestDriver code to an invalid value: "
             "%3d.\n",
             testNum);
      return -1;
    }
    result = (*cmakeGeneratedFunctionMapEntries[testToRun].func)(ac, av);

   if (result == VTK_SKIP_RETURN_CODE)
     {
     printf("Unsupported runtime configuration: Test returned "
            "VTK_SKIP_RETURN_CODE. Skipping test.\n");
     return result;
     }

   if (!interactive)
     {
     if (vtkTestingInteractor::TestReturnStatus != -1)
        {
        if (vtkTestingInteractor::TestReturnStatus != vtkTesting::PASSED)
          {
          result = EXIT_FAILURE;
          }
        else
          {
          result = EXIT_SUCCESS;
          }
        }
      vtkObjectFactory::UnRegisterFactory(factory);
      }

    return result;
  }

  /* Nothing was run, display the test names.  */
  printf("Available tests:\n");
  for (i = 0; i < NumTests; ++i) {
    printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
  }
  printf("Failed: %s is an invalid test name.\n", av[1]);

  return -1;
}
