// java wrapper for vtkOverlappingCellsDetector object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkOverlappingCellsDetector.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPassInputTypeAlgorithm_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkOverlappingCellsDetector_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkOverlappingCellsDetector",dType)) { return me; }
  if ((res= vtkPassInputTypeAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOverlappingCellsDetector_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOverlappingCellsDetector_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOverlappingCellsDetector_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOverlappingCellsDetector_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOverlappingCellsDetector_SetController_14(JNIEnv* env, jobject obj,jobject id0)
{
  vtkMultiProcessController * temp0;
  temp0 = static_cast<vtkMultiProcessController*>(vtkJavaGetPointerFromObject(env, id0));

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetController(temp0);

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkOverlappingCellsDetector_GetController_15(JNIEnv* env, jobject obj)
{
  vtkMultiProcessController * temp20;

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetController();
  return reinterpret_cast<jlong>(temp20);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkOverlappingCellsDetector_GetTolerance_16(JNIEnv* env, jobject obj)
{
  double   temp20;

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetTolerance();
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOverlappingCellsDetector_SetTolerance_17(JNIEnv* env, jobject obj,jdouble id0)
{
  double   temp0;
  temp0 = id0;

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetTolerance(temp0);

}

extern "C" JNIEXPORT jbyteArray  JNICALL Java_vtk_vtkOverlappingCellsDetector_GetNumberOfOverlapsPerCellArrayName_18(JNIEnv* env, jobject obj)
{
  char * temp20;

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfOverlapsPerCellArrayName();
  return (temp20 == nullptr) ? env->NewByteArray(0) : vtkJavaCharsToUTF8(env, temp20, strlen(temp20));

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOverlappingCellsDetector_SetNumberOfOverlapsPerCellArrayName_19(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkOverlappingCellsDetector* op = static_cast<vtkOverlappingCellsDetector*>(vtkJavaGetPointerFromObject(env, obj));
  op->SetNumberOfOverlapsPerCellArrayName(temp0);
  delete[] temp0;

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkOverlappingCellsDetector_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkOverlappingCellsDetector::New());
}
