// java wrapper for vtkCompressCompositer object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkCompressCompositer.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkCompositer_Typecast(void* op,char* dType);

extern "C" JNIEXPORT void* vtkCompressCompositer_Typecast(void* me,char* dType)
{
  void* res;
  if (!strcmp("vtkCompressCompositer",dType)) { return me; }
  if ((res= vtkCompositer_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCompressCompositer_IsTypeOf_10(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkCompressCompositer_IsA_11(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  int   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->IsA(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCompressCompositer_GetNumberOfGenerationsFromBaseType_12(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBaseType(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkCompressCompositer_GetNumberOfGenerationsFromBase_13(JNIEnv* env, jobject obj, jbyteArray id0, jint len0)
{
  char * temp0;
  long long   temp20;
  temp0 = vtkJavaUTF8ToChars(env, id0, len0);

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  temp20 = op->GetNumberOfGenerationsFromBase(temp0);
  delete[] temp0;
  return temp20;

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCompressCompositer_CompositeBuffer_14(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2,jobject id3)
{
  vtkDataArray * temp0;
  vtkFloatArray * temp1;
  vtkDataArray * temp2;
  vtkFloatArray * temp3;
  temp0 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id3));

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  op->CompositeBuffer(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCompressCompositer_Compress_15(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2,jobject id3)
{
  vtkFloatArray * temp0;
  vtkDataArray * temp1;
  vtkFloatArray * temp2;
  vtkDataArray * temp3;
  temp0 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id3));

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  op->Compress(temp0,temp1,temp2,temp3);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCompressCompositer_Uncompress_16(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2,jobject id3,jint id4)
{
  vtkFloatArray * temp0;
  vtkDataArray * temp1;
  vtkFloatArray * temp2;
  vtkDataArray * temp3;
  int   temp4;
  temp0 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = id4;

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  op->Uncompress(temp0,temp1,temp2,temp3,temp4);

}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkCompressCompositer_CompositeImagePair_17(JNIEnv* env, jobject obj,jobject id0,jobject id1,jobject id2,jobject id3,jobject id4,jobject id5)
{
  vtkFloatArray * temp0;
  vtkDataArray * temp1;
  vtkFloatArray * temp2;
  vtkDataArray * temp3;
  vtkFloatArray * temp4;
  vtkDataArray * temp5;
  temp0 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id0));
  temp1 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id1));
  temp2 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id2));
  temp3 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id3));
  temp4 = static_cast<vtkFloatArray*>(vtkJavaGetPointerFromObject(env, id4));
  temp5 = static_cast<vtkDataArray*>(vtkJavaGetPointerFromObject(env, id5));

  vtkCompressCompositer* op = static_cast<vtkCompressCompositer*>(vtkJavaGetPointerFromObject(env, obj));
  op->CompositeImagePair(temp0,temp1,temp2,temp3,temp4,temp5);

}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkCompressCompositer_VTKInit(JNIEnv*, jobject)
{
  return reinterpret_cast<jlong>(vtkCompressCompositer::New());
}
